/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/dynpmc/gziphandle.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define PARROT_DYNPMC_CLASS_LOAD
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_gziphandle.h"
#include "pmc_handle.h"
#include "pmc_default.h"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#undef PARROT_DYNPMC_CLASS_LOAD
#line 1 "./src/dynpmc/gziphandle.pmc"
/*
Copyright (C) 2010-2014, Parrot Foundation.

=head1 NAME

src/dynpmc/gziphandle.pmc - GzipHandle PMC

=head1 DESCRIPTION

The GzipHandle PMC performs I/O operations on a source or destination file.

This PMC wraps the zlib.

=head2 Vtable Functions

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 53 "./src/dynpmc/gziphandle.c"
static  INTVAL  Parrot_GzipHandle_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_GzipHandle_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_open(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_close(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_eof(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_flush(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_print(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_puts(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_read(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_version(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_compress(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_uncompress(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_GzipHandle_nci_crc32(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL 
Parrot_GzipHandle_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 52 "./src/dynpmc/gziphandle.pmc"

    gzFile file;
    GETATTR_GzipHandle_file(interp, _self, file);
    return !gzeof(file);
#line 75 "./src/dynpmc/gziphandle.c"
}
static  void 
Parrot_GzipHandle_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 38 "./src/dynpmc/gziphandle.pmc"

    PARROT_GZIPHANDLE(_self)->file = NULL;
    Parrot_warn_experimental(interp, "GzipHandle is experimental");
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 85 "./src/dynpmc/gziphandle.c"
}
static  void
Parrot_GzipHandle_nci_open(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* filename;
    STRING* mode;
    INTVAL has_mode;
    
    const INTVAL arity = 2; /* "PiSSoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    filename = VTABLE_get_string_keyed_int(interp, _call_object, 1);
    if (param_count > 2) {
        mode = VTABLE_get_string_keyed_int(interp, _call_object, 2);
        has_mode = 1;
    }
    else {
        mode = STRINGNULL;
        has_mode = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 75 "./src/dynpmc/gziphandle.pmc"

    char * const path  = Parrot_str_to_cstring(interp, filename);
    gzFile file;

    if (has_mode) {
        char * const mod = Parrot_str_to_cstring(interp, mode);
        file      = gzopen(path, mod);
        Parrot_str_free_cstring(mod);
    }
    else
        file = gzopen(path, "rb");

    Parrot_str_free_cstring(path);

    if (!file)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_LIBRARY_ERROR,
            "gzopen fails");

    SETATTR_GzipHandle_file(interp, _self, file);
    #line 143 "./src/dynpmc/gziphandle.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)_self);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 94 "./src/dynpmc/gziphandle.pmc"

#line 151 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_GzipHandle_nci_close(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 106 "./src/dynpmc/gziphandle.pmc"

    INTVAL status;
    gzFile file;
    GETATTR_GzipHandle_file(interp, _self, file);
    status = gzclose(file);
    #line 184 "./src/dynpmc/gziphandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)status);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 111 "./src/dynpmc/gziphandle.pmc"

#line 192 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_GzipHandle_nci_eof(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 123 "./src/dynpmc/gziphandle.pmc"

    INTVAL status;
    gzFile file;
    GETATTR_GzipHandle_file(interp, _self, file);
    status = gzeof(file);
    #line 225 "./src/dynpmc/gziphandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)status);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 128 "./src/dynpmc/gziphandle.pmc"

#line 233 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_GzipHandle_nci_flush(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 140 "./src/dynpmc/gziphandle.pmc"

    INTVAL status;
    gzFile file;
    GETATTR_GzipHandle_file(interp, _self, file);
    status = gzflush(file, Z_SYNC_FLUSH);
    #line 266 "./src/dynpmc/gziphandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)status);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 145 "./src/dynpmc/gziphandle.pmc"

#line 274 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_GzipHandle_nci_print(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* value;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    value = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 158 "./src/dynpmc/gziphandle.pmc"

    gzFile file;
    STRING * const str = VTABLE_get_string(interp, value);
    char   * const buf = Parrot_str_to_cstring(interp, str);
    const UINTVAL  len =  Parrot_str_byte_length(interp, str);

    GETATTR_GzipHandle_file(interp, _self, file);
    (void)gzwrite(file, buf, len);
    Parrot_str_free_cstring(buf);
#line 313 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_GzipHandle_nci_puts(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* value;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    value = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 179 "./src/dynpmc/gziphandle.pmc"

    INTVAL status;
    gzFile file;
    char * const  buf = Parrot_str_to_cstring(interp, value);
    const UINTVAL len =  Parrot_str_byte_length(interp, value);

    GETATTR_GzipHandle_file(interp, _self, file);
    status =  gzwrite(file, buf, len);
    Parrot_str_free_cstring(buf);
    #line 352 "./src/dynpmc/gziphandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)status);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 188 "./src/dynpmc/gziphandle.pmc"

#line 360 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_GzipHandle_nci_read(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    INTVAL length;
    
    const INTVAL arity = 2; /* "PiI" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    length = VTABLE_get_integer_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 200 "./src/dynpmc/gziphandle.pmc"

    int result;
    gzFile file;
    STRING *str = STRINGNULL;
    char * const buf = mem_internal_allocate_n_zeroed_typed(length, char);
    GETATTR_GzipHandle_file(interp, _self, file);
    result = gzread(file, buf, length);
    if (result > 0) {
        str = Parrot_str_new_init(interp, buf, result,
                Parrot_binary_encoding_ptr, 0);
    }
    mem_sys_free(buf);
    #line 402 "./src/dynpmc/gziphandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)str);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 212 "./src/dynpmc/gziphandle.pmc"

#line 410 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_GzipHandle_nci_version(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 233 "./src/dynpmc/gziphandle.pmc"

    STRING * const version = Parrot_str_new_constant(interp, zlibVersion());
    #line 440 "./src/dynpmc/gziphandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)version);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 235 "./src/dynpmc/gziphandle.pmc"

#line 448 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_GzipHandle_nci_compress(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* str;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    str = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 238 "./src/dynpmc/gziphandle.pmc"

    int rc;
    char *buf;
    STRING *dst = STRINGNULL;
    UINTVAL srcLen, dstLen;
    char * const src = Parrot_str_to_cstring(interp, str);

    if (!src)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_ALLOCATION_ERROR,
            "failed to allocate");

    srcLen = Parrot_str_byte_length(interp, str);
    dstLen = 12 + srcLen + srcLen / 1000;
    buf    = mem_internal_allocate_n_zeroed_typed(dstLen, char);

    if (!buf) {
        Parrot_str_free_cstring(src);
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_ALLOCATION_ERROR,
            "failed to allocate");
    }

    rc = compress((Bytef *)buf, &dstLen, (const Bytef *)src, srcLen);
    Parrot_str_free_cstring(src);

    switch (rc) {
      case Z_OK:
        dst = Parrot_str_new_init(interp, buf, dstLen,
                Parrot_binary_encoding_ptr, 0);
        mem_sys_free(buf);
        break;

      case Z_MEM_ERROR:
        mem_sys_free(buf);
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_ALLOCATION_ERROR,
            "not enough memory");
        break;

      case Z_BUF_ERROR:
        mem_sys_free(buf);
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_LIBRARY_ERROR,
            "output buffer error");
        break;

      default:
        /* these are the only three documented return values */
        break;
    }

    #line 526 "./src/dynpmc/gziphandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)dst);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 286 "./src/dynpmc/gziphandle.pmc"

#line 534 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_GzipHandle_nci_uncompress(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* str;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    str = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 289 "./src/dynpmc/gziphandle.pmc"

    int rc;
    char *buf;
    STRING *dst = STRINGNULL;
    UINTVAL srcLen, dstLen;
    char * const src = Parrot_str_to_cstring(interp, str);

    if (!src)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_ALLOCATION_ERROR,
            "failed to allocate");

    srcLen = Parrot_str_byte_length(interp, str);
    dstLen = 2 * srcLen;
REDO:
    buf = mem_internal_allocate_n_zeroed_typed(dstLen, char);

    if (!buf) {
        Parrot_str_free_cstring(src);
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_ALLOCATION_ERROR,
            "failed to allocate");
    }

    rc = uncompress((Bytef *)buf, &dstLen, (const Bytef *)src, srcLen);

    switch (rc) {
      case Z_OK:
        Parrot_str_free_cstring(src);
        dst = Parrot_str_new_init(interp, buf, dstLen,
                Parrot_binary_encoding_ptr, 0);
        mem_sys_free(buf);
        break;

      case Z_MEM_ERROR:
        Parrot_str_free_cstring(src);
        mem_sys_free(buf);
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_ALLOCATION_ERROR,
            "not enough memory");
        break;

      case Z_BUF_ERROR:
        mem_sys_free(buf);
        dstLen *= 2;
        goto REDO;

      case Z_DATA_ERROR:
        Parrot_str_free_cstring(src);
        mem_sys_free(buf);
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_LIBRARY_ERROR,
            "input data corrupted");
        break;

      default:
        /* these are the only four documented return values */
        break;
    }

    #line 620 "./src/dynpmc/gziphandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)dst);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 345 "./src/dynpmc/gziphandle.pmc"

#line 628 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_GzipHandle_nci_crc32(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    INTVAL crc;
    STRING* str;
    
    const INTVAL arity = 3; /* "PiIS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    crc = VTABLE_get_integer_keyed_int(interp, _call_object, 1);
    str = VTABLE_get_string_keyed_int(interp, _call_object, 2);

    { /* BEGIN PMETHOD BODY */
#line 348 "./src/dynpmc/gziphandle.pmc"

    UINTVAL srcLen;
    char * const src = Parrot_str_to_cstring(interp, str);

    if (!src)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_ALLOCATION_ERROR,
            "failed to allocate");

    srcLen  = Parrot_str_byte_length(interp, str);

    crc = crc32(crc, (const Bytef *)src, srcLen);
    #line 671 "./src/dynpmc/gziphandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)crc);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 359 "./src/dynpmc/gziphandle.pmc"

#line 679 "./src/dynpmc/gziphandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_GzipHandle_update_vtable(VTABLE *vt) {
    vt->get_bool = Parrot_GzipHandle_get_bool;
    vt->init = Parrot_GzipHandle_init;
    vt->attr_size = sizeof(Parrot_GzipHandle_attributes);

    return vt;
}


PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_GzipHandle_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->get_bool = Parrot_GzipHandle_get_bool;
    vt->attr_size = sizeof(Parrot_GzipHandle_attributes);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_GzipHandle_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_get_vtable(interp);
    Parrot_GzipHandle_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_GzipHandle_get_vtable_pointer(PARROT_INTERP) {
    STRING * const type_name = Parrot_str_new_constant(interp, "GzipHandle");
    const INTVAL type_num  = Parrot_pmc_get_type_str(interp, type_name);
    return interp->vtables[type_num];
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_GzipHandle_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_ro_get_vtable(interp);
    Parrot_GzipHandle_ro_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_GzipHandle_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Handle_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "GzipHandle"));
    return mro;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_GzipHandle_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_Handle_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "GzipHandle")), PMCNULL);
    return isa;
}

void
Parrot_GzipHandle_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":os_handle Srecord_separator :io_vtable :read_buffer :write_buffer Sencoding :file ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_GzipHandle_get_vtable(interp);
        vt->base_type      = -1;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->base_type    = entry;
        vt->whoami       = Parrot_str_new_init(interp, "GzipHandle", 10,
                                       Parrot_ascii_encoding_ptr, PObj_constant_FLAG|PObj_external_FLAG);
        vt->provides_str = Parrot_str_concat(interp, vt->provides_str,
            Parrot_str_new_init(interp, "scalar", 6, Parrot_ascii_encoding_ptr,
            PObj_constant_FLAG|PObj_external_FLAG));

        vt->isa_hash     = Parrot_GzipHandle_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_GzipHandle_ro_get_vtable(interp);
            vt_ro->base_type           = -1;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_GzipHandle_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "open");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_open),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "close");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_close),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "eof");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_eof),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "flush");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_flush),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "print");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_print),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "puts");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_puts),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "read");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_read),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "version");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_version),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "compress");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_compress),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "uncompress");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_uncompress),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "crc32");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_GzipHandle_nci_crc32),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_GzipHandle_class_init */

INTVAL dynpmc_class_GzipHandle;

/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */

PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_gziphandle_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    int pass;

    /* create a library PMC */
    pmc = Parrot_pmc_new(interp, enum_class_ParrotLibrary);

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "GzipHandle");
    dynpmc_class_GzipHandle = Parrot_pmc_register_new_type(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_GzipHandle_class_init(interp, dynpmc_class_GzipHandle, pass);
    }
    return pmc;
}

#line 360 "./src/dynpmc/gziphandle.pmc"


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */

