/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/dynpmc/select.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define PARROT_DYNPMC_CLASS_LOAD
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_select.h"
#include "pmc_default.h"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#undef PARROT_DYNPMC_CLASS_LOAD
#line 1 "./src/dynpmc/select.pmc"
/*
Copyright (C) 2011,2014, Parrot Foundation.

=head1 NAME

src/dynpmc/select.pmc - Select PMC

=head1 DESCRIPTION

This is the base-class for non-blocking IO using select().

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "../src/io/io_private.h"
#include "pmc/pmc_filehandle.h"
#include <sys/select.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#define SELECT_READ  1
#define SELECT_WRITE 2
#define SELECT_ERROR 4

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */

/*

=item C<INTVAL find_max_fd(INTERP, PMC *fd_map)>

Returns the maximum of all the c89 standard integer file descriptors held by
the Hash PMC

=back

=head2 Vtable Functions

=over 4

=cut

*/
    static INTVAL find_max_fd(PARROT_INTERP, ARGIN(PMC *fd_map)) {
        PMC * const  iter  = VTABLE_get_iter(interp, fd_map);
        const INTVAL n     = VTABLE_elements(interp, fd_map);
        INTVAL       maxid = -1;
        INTVAL       j;

        for (j = 0; j < n; ++j) {
            const INTVAL id = VTABLE_shift_integer(interp, iter);
            if (maxid < id)
                maxid = id;
        }
        return maxid;
    }
#line 92 "./src/dynpmc/select.c"
static  void  Parrot_Select_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Select_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Select_nci_max_fd(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Select_nci_fd_map(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Select_nci_update(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Select_nci_remove(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Select_nci_can_read(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Select_nci_can_write(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Select_nci_has_exception(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Select_nci_select(PARROT_INTERP, ARGMOD(PMC *_self));
static  void 
Parrot_Select_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 85 "./src/dynpmc/select.pmc"

    PMC * const fd_map = Parrot_pmc_new(interp, enum_class_Hash);
    VTABLE_set_integer_native(interp, fd_map, Hash_key_type_int);
    SETATTR_Select_fd_map(interp, _self, fd_map);
    SETATTR_Select_max_fd(interp, _self, -1);

    FD_ZERO(&(PARROT_SELECT(_self)->rb_array));
    FD_ZERO(&(PARROT_SELECT(_self)->wb_array));
    FD_ZERO(&(PARROT_SELECT(_self)->eb_array));

    PObj_custom_mark_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 119 "./src/dynpmc/select.c"
}
static  void 
Parrot_Select_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 107 "./src/dynpmc/select.pmc"

    PMC *fd_map;
    GETATTR_Select_fd_map(interp, _self, fd_map);
    Parrot_gc_mark_PMC_alive(interp, fd_map);
#line 129 "./src/dynpmc/select.c"
}
static  void
Parrot_Select_nci_max_fd(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 130 "./src/dynpmc/select.pmc"

    INTVAL v;
    GETATTR_Select_max_fd(interp, _self, v);
    #line 153 "./src/dynpmc/select.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)v);
        
        return;
     }
#line 133 "./src/dynpmc/select.pmc"

#line 161 "./src/dynpmc/select.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Select_nci_fd_map(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 149 "./src/dynpmc/select.pmc"

    PMC *fd_map;
    GETATTR_Select_fd_map(interp, _self, fd_map);
    #line 192 "./src/dynpmc/select.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)fd_map);
        
        return;
     }
#line 152 "./src/dynpmc/select.pmc"

#line 200 "./src/dynpmc/select.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Select_nci_update(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* handle;
    PMC* data;
    INTVAL rwe;
    
    const INTVAL arity = 4; /* "PiPPI" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    handle = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);
    data = VTABLE_get_pmc_keyed_int(interp, _call_object, 2);
    rwe = VTABLE_get_integer_keyed_int(interp, _call_object, 3);

    { /* BEGIN PMETHOD BODY */
#line 172 "./src/dynpmc/select.pmc"

    PMC    *fd_map;
    INTVAL  maxid,  fdkey;

    GETATTR_FileHandle_os_handle(interp, handle, fdkey);
    GETATTR_Select_fd_map(interp, _self, fd_map);
    GETATTR_Select_max_fd(interp, _self, maxid);
    VTABLE_set_pmc_keyed_int(interp, fd_map, fdkey, data);
    if (rwe & SELECT_READ)  { FD_SET(fdkey, &PARROT_SELECT(_self)->rb_array); }
    if (rwe & SELECT_WRITE) { FD_SET(fdkey, &PARROT_SELECT(_self)->wb_array); }
    if (rwe & SELECT_ERROR) { FD_SET(fdkey, &PARROT_SELECT(_self)->eb_array); }
    if (maxid < fdkey)
        maxid = fdkey;
    SETATTR_Select_max_fd(interp, _self, maxid);
#line 248 "./src/dynpmc/select.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Select_nci_remove(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* handle;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    handle = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 197 "./src/dynpmc/select.pmc"

    PMC    *fd_map;
    INTVAL fd, maxid;

    GETATTR_FileHandle_os_handle(interp, handle, fd);
    GETATTR_Select_fd_map(interp, _self, fd_map);
    GETATTR_Select_max_fd(interp, _self, maxid);
    VTABLE_delete_keyed_int(interp, fd_map, fd);
    FD_CLR(fd, &PARROT_SELECT(_self)->rb_array);
    FD_CLR(fd, &PARROT_SELECT(_self)->wb_array);
    FD_CLR(fd, &PARROT_SELECT(_self)->eb_array);
    if (fd == maxid) {
        maxid = find_max_fd(interp, fd_map);
        SETATTR_Select_max_fd(interp, _self, maxid);
    }
#line 293 "./src/dynpmc/select.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Select_nci_can_read(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    FLOATVAL timeout;
    
    const INTVAL arity = 2; /* "PiN" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    timeout = VTABLE_get_number_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 228 "./src/dynpmc/select.pmc"

    fd_set rdset;
    struct timeval timeouts;
    PMC    *results;
    PMC    *fd_map;
    INTVAL maxid, i;

    const INTVAL sec  = timeout / 1000000;
    const INTVAL usec = timeout - sec;

    GETATTR_Select_fd_map(interp, _self, fd_map);
    GETATTR_Select_max_fd(interp, _self, maxid);
    timeouts.tv_sec  = sec;
    timeouts.tv_usec = usec;
    results          = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    memcpy(&rdset, &PARROT_SELECT(_self)->rb_array, sizeof (fd_set));

    select(maxid + 1, &rdset, NULL, NULL, &timeouts);
    for (i=0; i <= maxid; i++) {
        if (FD_ISSET(i, &rdset)) {
            VTABLE_push_pmc(interp, results, VTABLE_get_pmc_keyed_int(interp, fd_map, i));
        }
    }
    #line 346 "./src/dynpmc/select.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)results);
        
        return;
     }
#line 251 "./src/dynpmc/select.pmc"

#line 354 "./src/dynpmc/select.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Select_nci_can_write(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    FLOATVAL timeout;
    
    const INTVAL arity = 2; /* "PiN" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    timeout = VTABLE_get_number_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 268 "./src/dynpmc/select.pmc"

    fd_set         wbset;
    struct timeval timeouts;
    PMC    *results, *fd_map;
    INTVAL maxid, i;

    const INTVAL sec  = timeout / 1000000;
    const INTVAL usec = timeout - sec;

    GETATTR_Select_fd_map(interp, _self, fd_map);
    GETATTR_Select_max_fd(interp, _self, maxid);
    timeouts.tv_sec  = sec;
    timeouts.tv_usec = usec;
    results          = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    memcpy(&wbset, &PARROT_SELECT(_self)->wb_array, sizeof (fd_set));

    select(maxid + 1, NULL, &wbset, NULL, &timeouts);
    for (i=0; i<=maxid; i++) {
        if (FD_ISSET(i, &wbset)) {
            VTABLE_push_pmc(interp, results, VTABLE_get_pmc_keyed_int(interp, fd_map, i));
        }
    }
    #line 406 "./src/dynpmc/select.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)results);
        
        return;
     }
#line 290 "./src/dynpmc/select.pmc"

#line 414 "./src/dynpmc/select.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Select_nci_has_exception(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    FLOATVAL timeout;
    
    const INTVAL arity = 2; /* "PiN" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    timeout = VTABLE_get_number_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 307 "./src/dynpmc/select.pmc"

    fd_set ebset;
    struct timeval timeouts;
    PMC    *results, *fd_map;
    INTVAL maxid, i;

    const INTVAL sec  = timeout / 1000000;
    const INTVAL usec = timeout - sec;

    GETATTR_Select_fd_map(interp, _self, fd_map);
    GETATTR_Select_max_fd(interp, _self, maxid);
    timeouts.tv_sec  = sec;
    timeouts.tv_usec = usec;
    results          = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    memcpy(&ebset, &PARROT_SELECT(_self)->eb_array, sizeof (fd_set));

    select(maxid + 1, NULL, NULL, &ebset, &timeouts);
    for (i=0; i<=maxid; i++) {
        if (FD_ISSET(i, &ebset)) {
            VTABLE_push_pmc(interp, results, VTABLE_get_pmc_keyed_int(interp, fd_map, i));
        }
    }
    #line 466 "./src/dynpmc/select.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)results);
        
        return;
     }
#line 329 "./src/dynpmc/select.pmc"

#line 474 "./src/dynpmc/select.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Select_nci_select(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    FLOATVAL timeout;
    
    const INTVAL arity = 2; /* "PiN" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    timeout = VTABLE_get_number_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 348 "./src/dynpmc/select.pmc"

    fd_set rdset, wrset, erset;
    struct timeval timeouts;

    PMC    *results, *rresults, *wresults, *eresults, *fd_map;
    INTVAL maxid, i;

    const INTVAL sec  = timeout / 1000000;
    const INTVAL usec = timeout - sec;

    GETATTR_Select_fd_map(interp, _self, fd_map);
    GETATTR_Select_max_fd(interp, _self, maxid);
    timeouts.tv_sec  = sec;
    timeouts.tv_usec = usec;
    results          = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    rresults         = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    wresults         = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    eresults         = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    memcpy(&rdset, &PARROT_SELECT(_self)->rb_array, sizeof (fd_set));
    memcpy(&wrset, &PARROT_SELECT(_self)->wb_array, sizeof (fd_set));
    memcpy(&erset, &PARROT_SELECT(_self)->eb_array, sizeof (fd_set));

    select(maxid + 1, &rdset, &wrset, &erset, &timeouts);
    for (i=0; i<=maxid; i++) {
        if (FD_ISSET(i, &rdset)) {
            VTABLE_push_pmc(interp, rresults, VTABLE_get_pmc_keyed_int(interp, fd_map, i));
        }
        if (FD_ISSET(i, &wrset)) {
            VTABLE_push_pmc(interp, wresults, VTABLE_get_pmc_keyed_int(interp, fd_map, i));
        }
        if (FD_ISSET(i, &erset)) {
            VTABLE_push_pmc(interp, eresults, VTABLE_get_pmc_keyed_int(interp, fd_map, i));
        }
    }
    VTABLE_push_pmc(interp, results, rresults);
    VTABLE_push_pmc(interp, results, wresults);
    VTABLE_push_pmc(interp, results, eresults);
    #line 541 "./src/dynpmc/select.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)results);
        
        return;
     }
#line 385 "./src/dynpmc/select.pmc"

#line 549 "./src/dynpmc/select.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_Select_update_vtable(VTABLE *vt) {
    vt->init = Parrot_Select_init;
    vt->mark = Parrot_Select_mark;
    vt->attr_size = sizeof(Parrot_Select_attributes);

    return vt;
}


PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_Select_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->mark = Parrot_Select_mark;
    vt->attr_size = sizeof(Parrot_Select_attributes);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Select_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Select_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Select_get_vtable_pointer(PARROT_INTERP) {
    STRING * const type_name = Parrot_str_new_constant(interp, "Select");
    const INTVAL type_num  = Parrot_pmc_get_type_str(interp, type_name);
    return interp->vtables[type_num];
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Select_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Select_ro_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Select_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Select"));
    return mro;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Select_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Select")), PMCNULL);
    return isa;
}

void
Parrot_Select_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Ffd_map :rb_array :wb_array :eb_array Imax_fd ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Select_get_vtable(interp);
        vt->base_type      = -1;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->base_type    = entry;
        vt->whoami       = Parrot_str_new_init(interp, "Select", 6,
                                       Parrot_ascii_encoding_ptr, PObj_constant_FLAG|PObj_external_FLAG);
        vt->provides_str = Parrot_str_concat(interp, vt->provides_str,
            Parrot_str_new_init(interp, "scalar", 6, Parrot_ascii_encoding_ptr,
            PObj_constant_FLAG|PObj_external_FLAG));

        vt->isa_hash     = Parrot_Select_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_Select_ro_get_vtable(interp);
            vt_ro->base_type           = -1;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Select_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "max_fd");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Select_nci_max_fd),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "fd_map");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Select_nci_fd_map),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "update");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Select_nci_update),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "remove");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Select_nci_remove),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "can_read");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Select_nci_can_read),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "can_write");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Select_nci_can_write),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "has_exception");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Select_nci_has_exception),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "select");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Select_nci_select),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_Select_class_init */

INTVAL dynpmc_class_Select;

/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */

PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_select_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    int pass;

    /* create a library PMC */
    pmc = Parrot_pmc_new(interp, enum_class_ParrotLibrary);

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "Select");
    dynpmc_class_Select = Parrot_pmc_register_new_type(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_Select_class_init(interp, dynpmc_class_Select, pass);
    }
    return pmc;
}

#line 386 "./src/dynpmc/select.pmc"


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
