/* ex: set ro:
** !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
**
** This file is generated automatically from src/vtable.tbl by
** tools/build/vtable_extend.pl
*/

/*
Copyright (C) 2001-2011, Parrot Foundation.

=head1 NAME

src/extend_vtable.c - Parrot vtable extension interface

=head1 DESCRIPTION

These are the functions that Parrot extensions (that is, Parrot subroutines
written in C, or some other compiled language, rather than in Parrot
bytecode) may access.

There is a deliberate distancing from the internals here. Don't go
peeking inside -- you've as much access as bytecode does, but no more,
so we can provide backwards compatibility for as long as we possibly
can.

=head2 Functions

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

/* Some internal notes. Parrot will die a horrible and bizarre death
   if the stack start pointer's not set and a GC run is
   triggered. The pointer *will* be set by the interpreter if the
   interpreter calls code which calls these functions, so most
   extension code is safe, no problem.

   The problem comes in if these routines are called from *outside*
   an interpreter. This happens when an embedding application calls
   them to do stuff with PMCs, STRINGS, interpreter contents, and
   suchlike things. This is perfectly legal -- in fact it's what
   we've documented should be done -- but the problem is that the
   stack base pointer will be NULL. This is Very Bad.

   To deal with this there are two macros that are defined to handle
   the problem.

   PARROT_CALLIN_START(interpreter) will figure out if the stack
   anchor needs setting and, if so, will set it. It must *always*
   come immediately after the last variable declared in the block
   making the calls into the interpreter, as it declares a variable
   and has some code.

   PARROT_CALLIN_END(interpreter) will put the stack anchor back to
   the way it was, and should always be the last statement before a
   return. (If you have multiple returns have it in multiple times)

   Not doing this is a good way to introduce bizarre heisenbugs, so
   just do it. This is the only place they ought to have to be put
   in, and most of the functions are already written, so it's not
   like it's an onerous requirement.

*/

#include "parrot/parrot.h"
#include "parrot/extend.h"

/* HEADERIZER HFILE: none */ /* XXX Ideally the headerizer can run on this file as well. */

/*

=item C<Parrot_PMC
absolute(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_absolute( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_absolute( interp, pmc, dest );
    return retval;
}

/*

=item C<Parrot_PMC
add(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_add( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_add( interp, pmc, value, dest );
    return retval;
}

/*

=item C<void
add_attribute(PARROT_INTERP, Parrot_PMC pmc, Parrot_String name, Parrot_PMC type)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_add_attribute( PARROT_INTERP, Parrot_PMC pmc, Parrot_String name, Parrot_PMC type )
{
VTABLE_add_attribute( interp, pmc, name, type );
    return;
}

/*

=item C<Parrot_PMC
add_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_add_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_add_float( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
add_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_add_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_add_int( interp, pmc, value, dest );
    return retval;
}

/*

=item C<void
add_method(PARROT_INTERP, Parrot_PMC pmc, Parrot_String method_name, Parrot_PMC sub_pmc)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_add_method( PARROT_INTERP, Parrot_PMC pmc, Parrot_String method_name, Parrot_PMC sub_pmc )
{
VTABLE_add_method( interp, pmc, method_name, sub_pmc );
    return;
}

/*

=item C<void
add_parent(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC parent)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_add_parent( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC parent )
{
VTABLE_add_parent( interp, pmc, parent );
    return;
}

/*

=item C<void
add_role(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC role)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_add_role( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC role )
{
VTABLE_add_role( interp, pmc, role );
    return;
}

/*

=item C<void
add_vtable_override(PARROT_INTERP, Parrot_PMC pmc, Parrot_String vtable_name, Parrot_PMC sub_pmc)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_add_vtable_override( PARROT_INTERP, Parrot_PMC pmc, Parrot_String vtable_name, Parrot_PMC sub_pmc )
{
VTABLE_add_vtable_override( interp, pmc, vtable_name, sub_pmc );
    return;
}

/*

=item C<void
assign_pmc(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_assign_pmc( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_assign_pmc( interp, pmc, value );
    return;
}

/*

=item C<void
assign_string_native(PARROT_INTERP, Parrot_PMC pmc, Parrot_String value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_assign_string_native( PARROT_INTERP, Parrot_PMC pmc, Parrot_String value )
{
VTABLE_assign_string_native( interp, pmc, value );
    return;
}

/*

=item C<Parrot_PMC
clone(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_clone( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_PMC retval;
retval = VTABLE_clone( interp, pmc );
    return retval;
}

/*

=item C<Parrot_PMC
clone_pmc(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC args)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_clone_pmc( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC args )
{
    Parrot_PMC retval;
retval = VTABLE_clone_pmc( interp, pmc, args );
    return retval;
}

/*

=item C<Parrot_Int
cmp(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_cmp( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
    Parrot_Int retval;
retval = VTABLE_cmp( interp, pmc, value );
    return retval;
}

/*

=item C<Parrot_Int
cmp_num(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_cmp_num( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
    Parrot_Int retval;
retval = VTABLE_cmp_num( interp, pmc, value );
    return retval;
}

/*

=item C<Parrot_PMC
cmp_pmc(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_cmp_pmc( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
    Parrot_PMC retval;
retval = VTABLE_cmp_pmc( interp, pmc, value );
    return retval;
}

/*

=item C<Parrot_Int
cmp_string(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_cmp_string( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
    Parrot_Int retval;
retval = VTABLE_cmp_string( interp, pmc, value );
    return retval;
}

/*

=item C<Parrot_PMC
concatenate(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_concatenate( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_concatenate( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
concatenate_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_concatenate_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_concatenate_str( interp, pmc, value, dest );
    return retval;
}

/*

=item C<void
decrement(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_decrement( PARROT_INTERP, Parrot_PMC pmc )
{
VTABLE_decrement( interp, pmc );
    return;
}

/*

=item C<Parrot_Int
defined(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_defined( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Int retval;
retval = VTABLE_defined( interp, pmc );
    return retval;
}

/*

=item C<Parrot_Int
defined_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_defined_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_Int retval;
retval = VTABLE_defined_keyed( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_Int
defined_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_defined_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_Int retval;
retval = VTABLE_defined_keyed_int( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_Int
defined_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_defined_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_Int retval;
retval = VTABLE_defined_keyed_str( interp, pmc, key );
    return retval;
}

/*

=item C<void
delete_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_delete_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key )
{
VTABLE_delete_keyed( interp, pmc, key );
    return;
}

/*

=item C<void
delete_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_delete_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key )
{
VTABLE_delete_keyed_int( interp, pmc, key );
    return;
}

/*

=item C<void
delete_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_delete_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key )
{
VTABLE_delete_keyed_str( interp, pmc, key );
    return;
}

/*

=item C<Parrot_PMC
divide(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_divide( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_divide( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
divide_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_divide_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_divide_float( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
divide_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_divide_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_divide_int( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_Int
does(PARROT_INTERP, Parrot_PMC pmc, Parrot_String role)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_does( PARROT_INTERP, Parrot_PMC pmc, Parrot_String role )
{
    Parrot_Int retval;
retval = VTABLE_does( interp, pmc, role );
    return retval;
}

/*

=item C<Parrot_Int
does_pmc(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC role)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_does_pmc( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC role )
{
    Parrot_Int retval;
retval = VTABLE_does_pmc( interp, pmc, role );
    return retval;
}

/*

=item C<Parrot_Int
elements(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_elements( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Int retval;
retval = VTABLE_elements( interp, pmc );
    return retval;
}

/*

=item C<Parrot_Int
exists_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_exists_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_Int retval;
retval = VTABLE_exists_keyed( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_Int
exists_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_exists_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_Int retval;
retval = VTABLE_exists_keyed_int( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_Int
exists_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_exists_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_Int retval;
retval = VTABLE_exists_keyed_str( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_PMC
find_method(PARROT_INTERP, Parrot_PMC pmc, Parrot_String method_name)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_find_method( PARROT_INTERP, Parrot_PMC pmc, Parrot_String method_name )
{
    Parrot_PMC retval;
retval = VTABLE_find_method( interp, pmc, method_name );
    return retval;
}

/*

=item C<Parrot_PMC
floor_divide(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_floor_divide( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_floor_divide( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
floor_divide_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_floor_divide_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_floor_divide_float( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
floor_divide_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_floor_divide_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_floor_divide_int( interp, pmc, value, dest );
    return retval;
}

/*

=item C<void
freeze(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC info)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_freeze( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC info )
{
VTABLE_freeze( interp, pmc, info );
    return;
}

/*

=item C<Parrot_PMC
get_attr_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_String idx)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_get_attr_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_String idx )
{
    Parrot_PMC retval;
retval = VTABLE_get_attr_keyed( interp, pmc, key, idx );
    return retval;
}

/*

=item C<Parrot_PMC
get_attr_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String idx)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_get_attr_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String idx )
{
    Parrot_PMC retval;
retval = VTABLE_get_attr_str( interp, pmc, idx );
    return retval;
}

/*

=item C<Parrot_Int
get_bool(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_get_bool( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Int retval;
retval = VTABLE_get_bool( interp, pmc );
    return retval;
}

/*

=item C<Parrot_PMC
get_class(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_get_class( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_PMC retval;
retval = VTABLE_get_class( interp, pmc );
    return retval;
}

/*

=item C<Parrot_Int
get_integer(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_get_integer( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Int retval;
retval = VTABLE_get_integer( interp, pmc );
    return retval;
}

/*

=item C<Parrot_Int
get_integer_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_get_integer_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_Int retval;
retval = VTABLE_get_integer_keyed( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_Int
get_integer_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_get_integer_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_Int retval;
retval = VTABLE_get_integer_keyed_int( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_Int
get_integer_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_get_integer_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_Int retval;
retval = VTABLE_get_integer_keyed_str( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_PMC
get_iter(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_get_iter( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_PMC retval;
retval = VTABLE_get_iter( interp, pmc );
    return retval;
}

/*

=item C<Parrot_PMC
get_namespace(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_get_namespace( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_PMC retval;
retval = VTABLE_get_namespace( interp, pmc );
    return retval;
}

/*

=item C<Parrot_Float
get_number(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Float
Parrot_PMC_get_number( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Float retval;
retval = VTABLE_get_number( interp, pmc );
    return retval;
}

/*

=item C<Parrot_Float
get_number_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_EXPORT Parrot_Float
Parrot_PMC_get_number_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_Float retval;
retval = VTABLE_get_number_keyed( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_Float
get_number_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_EXPORT Parrot_Float
Parrot_PMC_get_number_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_Float retval;
retval = VTABLE_get_number_keyed_int( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_Float
get_number_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_EXPORT Parrot_Float
Parrot_PMC_get_number_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_Float retval;
retval = VTABLE_get_number_keyed_str( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_PMC
get_pmc(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_get_pmc( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_PMC retval;
retval = VTABLE_get_pmc( interp, pmc );
    return retval;
}

/*

=item C<Parrot_PMC
get_pmc_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_get_pmc_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_PMC retval;
retval = VTABLE_get_pmc_keyed( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_PMC
get_pmc_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_get_pmc_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_PMC retval;
retval = VTABLE_get_pmc_keyed_int( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_PMC
get_pmc_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_get_pmc_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_PMC retval;
retval = VTABLE_get_pmc_keyed_str( interp, pmc, key );
    return retval;
}

/*

=item C<void*
get_pointer(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT void*
Parrot_PMC_get_pointer( PARROT_INTERP, Parrot_PMC pmc )
{
    void* retval;
retval = VTABLE_get_pointer( interp, pmc );
    return retval;
}

/*

=item C<void*
get_pointer_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_EXPORT void*
Parrot_PMC_get_pointer_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key )
{
    void* retval;
retval = VTABLE_get_pointer_keyed( interp, pmc, key );
    return retval;
}

/*

=item C<void*
get_pointer_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_EXPORT void*
Parrot_PMC_get_pointer_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key )
{
    void* retval;
retval = VTABLE_get_pointer_keyed_int( interp, pmc, key );
    return retval;
}

/*

=item C<void*
get_pointer_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_EXPORT void*
Parrot_PMC_get_pointer_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key )
{
    void* retval;
retval = VTABLE_get_pointer_keyed_str( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_String
get_repr(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_String
Parrot_PMC_get_repr( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_String retval;
retval = VTABLE_get_repr( interp, pmc );
    return retval;
}

/*

=item C<Parrot_String
get_string(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_String
Parrot_PMC_get_string( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_String retval;
retval = VTABLE_get_string( interp, pmc );
    return retval;
}

/*

=item C<Parrot_String
get_string_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_EXPORT Parrot_String
Parrot_PMC_get_string_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_String retval;
retval = VTABLE_get_string_keyed( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_String
get_string_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_EXPORT Parrot_String
Parrot_PMC_get_string_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_String retval;
retval = VTABLE_get_string_keyed_int( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_String
get_string_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_EXPORT Parrot_String
Parrot_PMC_get_string_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_String retval;
retval = VTABLE_get_string_keyed_str( interp, pmc, key );
    return retval;
}

/*

=item C<Parrot_Int
hashvalue(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_hashvalue( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Int retval;
retval = VTABLE_hashvalue( interp, pmc );
    return retval;
}

/*

=item C<void
i_absolute(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_absolute( PARROT_INTERP, Parrot_PMC pmc )
{
VTABLE_i_absolute( interp, pmc );
    return;
}

/*

=item C<void
i_add(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_add( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_i_add( interp, pmc, value );
    return;
}

/*

=item C<void
i_add_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_add_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value )
{
VTABLE_i_add_float( interp, pmc, value );
    return;
}

/*

=item C<void
i_add_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_add_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_i_add_int( interp, pmc, value );
    return;
}

/*

=item C<void
i_concatenate(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_concatenate( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_i_concatenate( interp, pmc, value );
    return;
}

/*

=item C<void
i_concatenate_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_concatenate_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String value )
{
VTABLE_i_concatenate_str( interp, pmc, value );
    return;
}

/*

=item C<void
i_divide(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_divide( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_i_divide( interp, pmc, value );
    return;
}

/*

=item C<void
i_divide_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_divide_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value )
{
VTABLE_i_divide_float( interp, pmc, value );
    return;
}

/*

=item C<void
i_divide_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_divide_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_i_divide_int( interp, pmc, value );
    return;
}

/*

=item C<void
i_floor_divide(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_floor_divide( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_i_floor_divide( interp, pmc, value );
    return;
}

/*

=item C<void
i_floor_divide_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_floor_divide_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value )
{
VTABLE_i_floor_divide_float( interp, pmc, value );
    return;
}

/*

=item C<void
i_floor_divide_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_floor_divide_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_i_floor_divide_int( interp, pmc, value );
    return;
}

/*

=item C<void
i_modulus(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_modulus( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_i_modulus( interp, pmc, value );
    return;
}

/*

=item C<void
i_modulus_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_modulus_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value )
{
VTABLE_i_modulus_float( interp, pmc, value );
    return;
}

/*

=item C<void
i_modulus_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_modulus_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_i_modulus_int( interp, pmc, value );
    return;
}

/*

=item C<void
i_multiply(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_multiply( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_i_multiply( interp, pmc, value );
    return;
}

/*

=item C<void
i_multiply_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_multiply_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value )
{
VTABLE_i_multiply_float( interp, pmc, value );
    return;
}

/*

=item C<void
i_multiply_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_multiply_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_i_multiply_int( interp, pmc, value );
    return;
}

/*

=item C<void
i_neg(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_neg( PARROT_INTERP, Parrot_PMC pmc )
{
VTABLE_i_neg( interp, pmc );
    return;
}

/*

=item C<void
i_repeat(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_repeat( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_i_repeat( interp, pmc, value );
    return;
}

/*

=item C<void
i_repeat_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_repeat_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_i_repeat_int( interp, pmc, value );
    return;
}

/*

=item C<void
i_subtract(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_subtract( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_i_subtract( interp, pmc, value );
    return;
}

/*

=item C<void
i_subtract_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_subtract_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value )
{
VTABLE_i_subtract_float( interp, pmc, value );
    return;
}

/*

=item C<void
i_subtract_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_i_subtract_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_i_subtract_int( interp, pmc, value );
    return;
}

/*

=item C<void
increment(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_increment( PARROT_INTERP, Parrot_PMC pmc )
{
VTABLE_increment( interp, pmc );
    return;
}

/*

=item C<void
init(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_init( PARROT_INTERP, Parrot_PMC pmc )
{
VTABLE_init( interp, pmc );
    return;
}

/*

=item C<void
init_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int initializer)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_init_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int initializer )
{
VTABLE_init_int( interp, pmc, initializer );
    return;
}

/*

=item C<void
init_pmc(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC initializer)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_init_pmc( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC initializer )
{
VTABLE_init_pmc( interp, pmc, initializer );
    return;
}

/*

=item C<Parrot_PMC
inspect(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_inspect( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_PMC retval;
retval = VTABLE_inspect( interp, pmc );
    return retval;
}

/*

=item C<Parrot_PMC
inspect_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String what)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_inspect_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String what )
{
    Parrot_PMC retval;
retval = VTABLE_inspect_str( interp, pmc, what );
    return retval;
}

/*

=item C<Parrot_PMC
instantiate(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC sig)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_instantiate( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC sig )
{
    Parrot_PMC retval;
retval = VTABLE_instantiate( interp, pmc, sig );
    return retval;
}

/*

=item C<Parrot_Int
is_equal(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_is_equal( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
    Parrot_Int retval;
retval = VTABLE_is_equal( interp, pmc, value );
    return retval;
}

/*

=item C<Parrot_Int
is_equal_num(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_is_equal_num( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
    Parrot_Int retval;
retval = VTABLE_is_equal_num( interp, pmc, value );
    return retval;
}

/*

=item C<Parrot_Int
is_equal_string(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_is_equal_string( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
    Parrot_Int retval;
retval = VTABLE_is_equal_string( interp, pmc, value );
    return retval;
}

/*

=item C<Parrot_Int
is_same(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_is_same( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
    Parrot_Int retval;
retval = VTABLE_is_same( interp, pmc, value );
    return retval;
}

/*

=item C<Parrot_Int
isa(PARROT_INTERP, Parrot_PMC pmc, Parrot_String _class)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_isa( PARROT_INTERP, Parrot_PMC pmc, Parrot_String _class )
{
    Parrot_Int retval;
retval = VTABLE_isa( interp, pmc, _class );
    return retval;
}

/*

=item C<Parrot_Int
isa_pmc(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC _class)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_isa_pmc( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC _class )
{
    Parrot_Int retval;
retval = VTABLE_isa_pmc( interp, pmc, _class );
    return retval;
}

/*

=item C<Parrot_PMC
modulus(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_modulus( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_modulus( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
modulus_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_modulus_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_modulus_float( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
modulus_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_modulus_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_modulus_int( interp, pmc, value, dest );
    return retval;
}

/*

=item C<void
morph(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC type)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_morph( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC type )
{
VTABLE_morph( interp, pmc, type );
    return;
}

/*

=item C<Parrot_PMC
multiply(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_multiply( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_multiply( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
multiply_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_multiply_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_multiply_float( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
multiply_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_multiply_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_multiply_int( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_String
name(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_String
Parrot_PMC_name( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_String retval;
retval = VTABLE_name( interp, pmc );
    return retval;
}

/*

=item C<Parrot_PMC
neg(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_neg( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_neg( interp, pmc, dest );
    return retval;
}

/*

=item C<Parrot_Float
pop_float(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Float
Parrot_PMC_pop_float( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Float retval;
retval = VTABLE_pop_float( interp, pmc );
    return retval;
}

/*

=item C<Parrot_Int
pop_integer(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_pop_integer( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Int retval;
retval = VTABLE_pop_integer( interp, pmc );
    return retval;
}

/*

=item C<Parrot_PMC
pop_pmc(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_pop_pmc( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_PMC retval;
retval = VTABLE_pop_pmc( interp, pmc );
    return retval;
}

/*

=item C<Parrot_String
pop_string(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_String
Parrot_PMC_pop_string( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_String retval;
retval = VTABLE_pop_string( interp, pmc );
    return retval;
}

/*

=item C<void
push_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_push_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value )
{
VTABLE_push_float( interp, pmc, value );
    return;
}

/*

=item C<void
push_integer(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_push_integer( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_push_integer( interp, pmc, value );
    return;
}

/*

=item C<void
push_pmc(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_push_pmc( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_push_pmc( interp, pmc, value );
    return;
}

/*

=item C<void
push_string(PARROT_INTERP, Parrot_PMC pmc, Parrot_String value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_push_string( PARROT_INTERP, Parrot_PMC pmc, Parrot_String value )
{
VTABLE_push_string( interp, pmc, value );
    return;
}

/*

=item C<void
remove_attribute(PARROT_INTERP, Parrot_PMC pmc, Parrot_String name)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_remove_attribute( PARROT_INTERP, Parrot_PMC pmc, Parrot_String name )
{
VTABLE_remove_attribute( interp, pmc, name );
    return;
}

/*

=item C<void
remove_method(PARROT_INTERP, Parrot_PMC pmc, Parrot_String method_name)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_remove_method( PARROT_INTERP, Parrot_PMC pmc, Parrot_String method_name )
{
VTABLE_remove_method( interp, pmc, method_name );
    return;
}

/*

=item C<void
remove_parent(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC parent)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_remove_parent( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC parent )
{
VTABLE_remove_parent( interp, pmc, parent );
    return;
}

/*

=item C<void
remove_role(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC role)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_remove_role( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC role )
{
VTABLE_remove_role( interp, pmc, role );
    return;
}

/*

=item C<void
remove_vtable_override(PARROT_INTERP, Parrot_PMC pmc, Parrot_String vtable_name)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_remove_vtable_override( PARROT_INTERP, Parrot_PMC pmc, Parrot_String vtable_name )
{
VTABLE_remove_vtable_override( interp, pmc, vtable_name );
    return;
}

/*

=item C<Parrot_PMC
repeat(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_repeat( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_repeat( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
repeat_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_repeat_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_repeat_int( interp, pmc, value, dest );
    return retval;
}

/*

=item C<void
set_attr_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_String idx, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_attr_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_String idx, Parrot_PMC value )
{
VTABLE_set_attr_keyed( interp, pmc, key, idx, value );
    return;
}

/*

=item C<void
set_attr_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String idx, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_attr_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String idx, Parrot_PMC value )
{
VTABLE_set_attr_str( interp, pmc, idx, value );
    return;
}

/*

=item C<void
set_bool(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_bool( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_set_bool( interp, pmc, value );
    return;
}

/*

=item C<void
set_integer_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_integer_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_Int value )
{
VTABLE_set_integer_keyed( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_integer_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_integer_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key, Parrot_Int value )
{
VTABLE_set_integer_keyed_int( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_integer_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_integer_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key, Parrot_Int value )
{
VTABLE_set_integer_keyed_str( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_integer_native(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_integer_native( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_set_integer_native( interp, pmc, value );
    return;
}

/*

=item C<void
set_number_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_number_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_Float value )
{
VTABLE_set_number_keyed( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_number_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_number_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key, Parrot_Float value )
{
VTABLE_set_number_keyed_int( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_number_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_number_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key, Parrot_Float value )
{
VTABLE_set_number_keyed_str( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_number_native(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_number_native( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value )
{
VTABLE_set_number_native( interp, pmc, value );
    return;
}

/*

=item C<void
set_pmc(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_pmc( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_set_pmc( interp, pmc, value );
    return;
}

/*

=item C<void
set_pmc_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_pmc_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_PMC value )
{
VTABLE_set_pmc_keyed( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_pmc_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_pmc_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key, Parrot_PMC value )
{
VTABLE_set_pmc_keyed_int( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_pmc_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_pmc_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key, Parrot_PMC value )
{
VTABLE_set_pmc_keyed_str( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_pointer(PARROT_INTERP, Parrot_PMC pmc, void* value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_pointer( PARROT_INTERP, Parrot_PMC pmc, void* value )
{
VTABLE_set_pointer( interp, pmc, value );
    return;
}

/*

=item C<void
set_pointer_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, void* value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_pointer_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, void* value )
{
VTABLE_set_pointer_keyed( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_pointer_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key, void* value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_pointer_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key, void* value )
{
VTABLE_set_pointer_keyed_int( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_pointer_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key, void* value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_pointer_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key, void* value )
{
VTABLE_set_pointer_keyed_str( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_string_keyed(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_String value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_string_keyed( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC key, Parrot_String value )
{
VTABLE_set_string_keyed( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_string_keyed_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key, Parrot_String value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_string_keyed_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int key, Parrot_String value )
{
VTABLE_set_string_keyed_int( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_string_keyed_str(PARROT_INTERP, Parrot_PMC pmc, Parrot_String key, Parrot_String value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_string_keyed_str( PARROT_INTERP, Parrot_PMC pmc, Parrot_String key, Parrot_String value )
{
VTABLE_set_string_keyed_str( interp, pmc, key, value );
    return;
}

/*

=item C<void
set_string_native(PARROT_INTERP, Parrot_PMC pmc, Parrot_String value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_set_string_native( PARROT_INTERP, Parrot_PMC pmc, Parrot_String value )
{
VTABLE_set_string_native( interp, pmc, value );
    return;
}

/*

=item C<void
share(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_share( PARROT_INTERP, Parrot_PMC pmc )
{
VTABLE_share( interp, pmc );
    return;
}

/*

=item C<Parrot_Float
shift_float(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Float
Parrot_PMC_shift_float( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Float retval;
retval = VTABLE_shift_float( interp, pmc );
    return retval;
}

/*

=item C<Parrot_Int
shift_integer(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_shift_integer( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Int retval;
retval = VTABLE_shift_integer( interp, pmc );
    return retval;
}

/*

=item C<Parrot_PMC
shift_pmc(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_shift_pmc( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_PMC retval;
retval = VTABLE_shift_pmc( interp, pmc );
    return retval;
}

/*

=item C<Parrot_String
shift_string(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_String
Parrot_PMC_shift_string( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_String retval;
retval = VTABLE_shift_string( interp, pmc );
    return retval;
}

/*

=item C<void
splice(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_Int offset, Parrot_Int count)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_splice( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_Int offset, Parrot_Int count )
{
VTABLE_splice( interp, pmc, value, offset, count );
    return;
}

/*

=item C<Parrot_String
substr(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int offset, Parrot_Int length)>

=cut

*/

PARROT_EXPORT Parrot_String
Parrot_PMC_substr( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int offset, Parrot_Int length )
{
    Parrot_String retval;
retval = VTABLE_substr( interp, pmc, offset, length );
    return retval;
}

/*

=item C<Parrot_PMC
subtract(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_subtract( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_subtract( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
subtract_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_subtract_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_subtract_float( interp, pmc, value, dest );
    return retval;
}

/*

=item C<Parrot_PMC
subtract_int(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest)>

=cut

*/

PARROT_EXPORT Parrot_PMC
Parrot_PMC_subtract_int( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value, Parrot_PMC dest )
{
    Parrot_PMC retval;
retval = VTABLE_subtract_int( interp, pmc, value, dest );
    return retval;
}

/*

=item C<void
thaw(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC info)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_thaw( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC info )
{
VTABLE_thaw( interp, pmc, info );
    return;
}

/*

=item C<void
thawfinish(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC info)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_thawfinish( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC info )
{
VTABLE_thawfinish( interp, pmc, info );
    return;
}

/*

=item C<Parrot_Int
type(PARROT_INTERP, Parrot_PMC pmc)>

=cut

*/

PARROT_EXPORT Parrot_Int
Parrot_PMC_type( PARROT_INTERP, Parrot_PMC pmc )
{
    Parrot_Int retval;
retval = VTABLE_type( interp, pmc );
    return retval;
}

/*

=item C<void
unshift_float(PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_unshift_float( PARROT_INTERP, Parrot_PMC pmc, Parrot_Float value )
{
VTABLE_unshift_float( interp, pmc, value );
    return;
}

/*

=item C<void
unshift_integer(PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_unshift_integer( PARROT_INTERP, Parrot_PMC pmc, Parrot_Int value )
{
VTABLE_unshift_integer( interp, pmc, value );
    return;
}

/*

=item C<void
unshift_pmc(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_unshift_pmc( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC value )
{
VTABLE_unshift_pmc( interp, pmc, value );
    return;
}

/*

=item C<void
unshift_string(PARROT_INTERP, Parrot_PMC pmc, Parrot_String value)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_unshift_string( PARROT_INTERP, Parrot_PMC pmc, Parrot_String value )
{
VTABLE_unshift_string( interp, pmc, value );
    return;
}

/*

=item C<void
visit(PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC info)>

=cut

*/

PARROT_EXPORT void
Parrot_PMC_visit( PARROT_INTERP, Parrot_PMC pmc, Parrot_PMC info )
{
VTABLE_visit( interp, pmc, info );
    return;
}

/*

=back

=head1 SEE ALSO

See F<include/parrot/extend.h>, F<docs/extend.pod>, F<docs/embed.pod> and F<docs/pdds/pdd11_extending.pod>.

=head1 HISTORY

Initial version by Dan Sugalski.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
