/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/exporter.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_exporter.h"
#include "pmc_default.h"
#include "exporter.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/exporter.pmc"
/*
Copyright (C) 2007-2014, Parrot Foundation.

=head1 NAME

src/pmc/exporter.pmc - Exporter PMC

=head1 SYNOPSIS

Export globals from one namespace to another.

You can use Exporter in PIR to import subs from a library. At its simplest:

 .sub main :main
     load_bytecode 'Test/More.pir'

     .local pmc exporter, src_ns, dest_ns
     src_ns   = get_namespace [ 'Test'; 'More' ]
     exporter = new 'Exporter'

     exporter.'import'( src_ns :named('source') 'plan ok' :named('globals') )
     plan(1)
     ok(1, 'exporter has imported the requested functions')
 .end

You can also specify the exporter attributes before making the import call,
for example to import into the alternate namespace 'Foo' you could use the
following code:

    src_ns   = get_namespace [ 'Test'; 'More' ]
    dest_ns  = get_namespace [ 'Foo' ]
    exporter.'source'(src_ns)
    exporter.'destination'(dest_ns)
    exporter.'import'('plan ok' :named('globals'))

You can even import subroutines under different names if globals is a hash:

    globals         = new 'Hash'
    globals['plan'] = 'steps'
    globals['ok']   = 'passed'
    exporter.'import'(globals :named('globals'))
    steps(1)
    passed(1)


=head1 DESCRIPTION

Exports globals from one namespace to another. Exporter always uses
the typed namespace interface, as outlined in
F<docs/pdds/pdd21_namespaces.pod>.

Exporter is not derived from any other PMC, and does not provide any
vtable interface--its interface consists solely of methods, not
vtable functions.

=head2 Structure

The Exporter PMC structure (C<Parrot_Exporter>) consists of three items:

=over 4

=item C<ns_src>

The source namespace -- a NameSpace PMC.
A Null PMC is allocated during initialization.

=item C<ns_dest>

The destination namespace -- a NameSpace PMC.
A PMC representing the current namespace is allocated upon initialization.

=item C<globals>

The globals to export -- a PMC that implements a hash, an array, a String
containing a list of space-separated subroutine names or Null.

A Null PMC is allocated during initialization.

=cut

*/

/*

=back

=head2 Functions

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 121 "./src/pmc/exporter.c"
static  void  Parrot_Exporter_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Exporter_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Exporter_nci_source(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Exporter_nci_destination(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Exporter_nci_globals(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Exporter_nci_import(PARROT_INTERP, ARGMOD(PMC *_self));
static  void 
Parrot_Exporter_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 115 "./src/pmc/exporter.pmc"

    /* Set up the object. */
    SETATTR_Exporter_ns_src(interp, _self, PMCNULL);
    SETATTR_Exporter_ns_dest(interp, _self, Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp)));
    SETATTR_Exporter_globals(interp, _self, PMCNULL);

    /* Set flags for custom GC mark and destroy. */
    PObj_custom_mark_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 141 "./src/pmc/exporter.c"
}
static  void 
Parrot_Exporter_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 135 "./src/pmc/exporter.pmc"

    PMC *ns_src;
    PMC *ns_dest;
    PMC *globals;
    GETATTR_Exporter_ns_src(interp, _self, ns_src);
    GETATTR_Exporter_ns_dest(interp, _self, ns_dest);
    GETATTR_Exporter_globals(interp, _self, globals);

    Parrot_gc_mark_PMC_alive(interp, ns_src);
    Parrot_gc_mark_PMC_alive(interp, ns_dest);
    Parrot_gc_mark_PMC_alive(interp, globals);
#line 158 "./src/pmc/exporter.c"
}
static  void
Parrot_Exporter_nci_source(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* src;
    INTVAL got_src;
    
    const INTVAL arity = 1; /* "PiPoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        src = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);
        got_src = 1;
    }
    else {
        src = PMCNULL;
        got_src = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 168 "./src/pmc/exporter.pmc"

    if (got_src) {
        if (src->vtable->base_type != enum_class_NameSpace)
            Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
                    "source must be a NameSpace PMC");

        SETATTR_Exporter_ns_src(interp, _self, src);
    }
    else {
        PMC *tmp_ns_src;
        GETATTR_Exporter_ns_src(interp, _self, tmp_ns_src);
        #line 206 "./src/pmc/exporter.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)tmp_ns_src);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 179 "./src/pmc/exporter.pmc"

    }
#line 215 "./src/pmc/exporter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Exporter_nci_destination(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* dest;
    INTVAL got_dest;
    
    const INTVAL arity = 1; /* "PiPoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        dest = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);
        got_dest = 1;
    }
    else {
        dest = PMCNULL;
        got_dest = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 197 "./src/pmc/exporter.pmc"

    if (got_dest) {

        if (dest->vtable->base_type != enum_class_NameSpace)
            Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
                    "destination must be a NameSpace PMC");

        SETATTR_Exporter_ns_dest(interp, _self, dest);
    }
    else {
        PMC *tmp_ns_dest;
        GETATTR_Exporter_ns_dest(interp, _self, tmp_ns_dest);
        #line 271 "./src/pmc/exporter.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)tmp_ns_dest);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 209 "./src/pmc/exporter.pmc"

    }
#line 280 "./src/pmc/exporter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Exporter_nci_globals(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* glb;
    INTVAL got_glb;
    
    const INTVAL arity = 1; /* "PiPoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        glb = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);
        got_glb = 1;
    }
    else {
        glb = PMCNULL;
        got_glb = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 232 "./src/pmc/exporter.pmc"

    STRING * const s_str   = CONST_STRING(interp, "String");
    STRING * const s_arr   = CONST_STRING(interp, "array");
    STRING * const s_hash  = CONST_STRING(interp, "hash");
    STRING * const s_space = CONST_STRING(interp, " ");

    if (got_glb) {
        STRING * const s_empty      = CONST_STRING(interp, "");
        PMC           *temp_globals = Parrot_pmc_new(interp, enum_class_Hash);

        if (PMC_IS_NULL(glb)) {
            temp_globals = PMCNULL;
        }
        else if (VTABLE_isa(interp, glb, s_str) || (VTABLE_does(interp, glb, s_arr))) {
            PMC    *glb_array;
            INTVAL n, i;

            if (VTABLE_isa(interp, glb, s_str))
                glb_array = Parrot_str_split(interp, s_space,
                    VTABLE_get_string(interp, glb));
            else
                glb_array = glb;

            n = VTABLE_elements(interp, glb_array);

            if (n == 0)
                temp_globals = PMCNULL;

            for (i = 0; i < n; ++i) {
                STRING * const item = VTABLE_get_string_keyed_int(interp, glb_array, i);
                VTABLE_set_string_keyed_str(interp, temp_globals, item, s_empty);
            }
        }
        else if (VTABLE_does(interp, glb, s_hash)) {
            if (VTABLE_elements(interp, glb) == 0)
                temp_globals = PMCNULL;
            else
                temp_globals = glb;
        }
        else {
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                    "Invalid type %d in globals()", glb->vtable->base_type);
        }

        SETATTR_Exporter_globals(interp, _self, temp_globals);
     }
     else {
        PMC *tmp_globals;
        GETATTR_Exporter_globals(interp, _self, tmp_globals);
        if (PMC_IS_NULL(tmp_globals)) {
            #line 374 "./src/pmc/exporter.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)PMCNULL);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 282 "./src/pmc/exporter.pmc"

        }
        else
            #line 384 "./src/pmc/exporter.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)tmp_globals);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 285 "./src/pmc/exporter.pmc"

    }
#line 393 "./src/pmc/exporter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Exporter_nci_import(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* _param_name_str_destination = CONST_STRING_GEN(interp, "destination");
    PMC* dest;
    INTVAL got_dest;
    STRING* _param_name_str_source = CONST_STRING_GEN(interp, "source");
    PMC* src;
    INTVAL got_src;
    STRING* _param_name_str_globals = CONST_STRING_GEN(interp, "globals");
    PMC* globals;
    INTVAL got_globals;
    
    Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSnPoIpSnPoIpSnPoIp",
        &_self, &_param_name_str_destination, &dest, &got_dest, &_param_name_str_source, &src, &got_src, &_param_name_str_globals, &globals, &got_globals);

    { /* BEGIN PMETHOD BODY */
#line 313 "./src/pmc/exporter.pmc"


    PMC *ns_src, *ns_dest, *ns_globals;

    if (got_src)
        #line 429 "./src/pmc/exporter.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "source"), "P->", src);
#line 318 "./src/pmc/exporter.pmc"


    if (got_dest)
        #line 435 "./src/pmc/exporter.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "destination"), "P->", dest);
#line 321 "./src/pmc/exporter.pmc"


    if (got_globals)
        #line 441 "./src/pmc/exporter.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "globals"), "P->", globals);
#line 324 "./src/pmc/exporter.pmc"


    GETATTR_Exporter_ns_src(interp, _self, ns_src);
    if (PMC_IS_NULL(ns_src))
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
                "source namespace not set");

    GETATTR_Exporter_ns_dest(interp, _self, ns_dest);

    /* This condition must never happen, destination is set during init and
     * attempts to change it with wrong values are rejected.
     * Even if it gets changed for unexpected reasons, "export_to" will
     * catch the problem. */
    PARROT_ASSERT(!PMC_IS_NULL(ns_dest));

    GETATTR_Exporter_globals(interp, _self, ns_globals);

    #line 461 "./src/pmc/exporter.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, ns_src, CONST_STRING_GEN(interp, "export_to"), "PP->", ns_dest, ns_globals);
#line 341 "./src/pmc/exporter.pmc"

#line 465 "./src/pmc/exporter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Exporter_update_vtable(VTABLE *vt) {
    vt->init = Parrot_Exporter_init;
    vt->mark = Parrot_Exporter_mark;
    vt->attr_size = sizeof(Parrot_Exporter_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Exporter_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->mark = Parrot_Exporter_mark;
    vt->attr_size = sizeof(Parrot_Exporter_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Exporter_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Exporter_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Exporter_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Exporter_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Exporter_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Exporter"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Exporter_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Exporter")), PMCNULL);
    return isa;
}

void
Parrot_Exporter_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fns_src Fns_dest Fglobals ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Exporter_get_vtable(interp);
        vt->base_type      = enum_class_Exporter;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Exporter");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_Exporter_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_Exporter_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_Exporter;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Exporter_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "source");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Exporter_nci_source),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "destination");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Exporter_nci_destination),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "globals");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Exporter_nci_globals),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "import");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Exporter_nci_import),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_Exporter_class_init */

#line 344 "./src/pmc/exporter.pmc"
 /* end pmclass Exporter */

/*

=back

=head1 STABILITY

Unstable. This PMC is under active development; major portions of the
interface have not yet been completed.

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>, F<docs/pdds/pdd21_namespaces.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
