/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/filehandle.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_filehandle.h"
#include "pmc_handle.h"
#include "pmc_default.h"
#include "filehandle.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/filehandle.pmc"
/*
Copyright (C) 2008-2015, Parrot Foundation.

=head1 NAME

src/pmc/filehandle.pmc - FileHandle PMC

=head1 DESCRIPTION

The FileHandle PMC performs I/O operations on a source or destination file.

=head2 Vtable Functions

=over 4

=cut

*/

#include "../src/io/io_private.h"
#include "pmc/pmc_bytebuffer.h"

#ifdef PARROT_HAS_READLINE
#ifdef __cplusplus
extern "C" {
#endif
    char *readline(const char *);
    void add_history(const char*);
#ifdef __cplusplus
}
#endif
#endif

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 61 "./src/pmc/filehandle.c"
static  PMC  * Parrot_FileHandle_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_FileHandle_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_FileHandle_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_FileHandle_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), const INTVAL key);
static  void  Parrot_FileHandle_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_FileHandle_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_FileHandle_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value);
static  void Parrot_FileHandle_nci_open(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_isatty(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_is_closed(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_readline_interactive(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_readall(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_flush(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_print(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_buffer_type(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_buffer_size(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_mode(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_eof(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_handle(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_exit_status(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_tell(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_seek(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_peek(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_setasync(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_FileHandle_nci_setblocking(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  *
Parrot_FileHandle_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 99 "./src/pmc/filehandle.pmc"

    Parrot_FileHandle_attributes * const old_attrs
        = PARROT_FILEHANDLE(_self);
    PMC * const copy = Parrot_pmc_new(interp, enum_class_FileHandle);
    Parrot_FileHandle_attributes * const new_attrs
        = PARROT_FILEHANDLE(copy);

    /* Properly clone string data. */
    new_attrs->filename       = old_attrs->filename;
    new_attrs->mode           = old_attrs->mode;
    new_attrs->encoding       = old_attrs->encoding;

    /* Prevent GC of the strings. */
    Parrot_gc_mark_STRING_alive(interp, new_attrs->filename);
    Parrot_gc_mark_STRING_alive(interp, new_attrs->mode);
    Parrot_gc_mark_STRING_alive(interp, new_attrs->encoding);

    /* Copy over some metadata */
    new_attrs->flags          = old_attrs->flags;
    new_attrs->process_id     = old_attrs->process_id;
    new_attrs->exit_status    = old_attrs->exit_status;
    new_attrs->file_pos       = old_attrs->file_pos;
    new_attrs->last_pos       = old_attrs->last_pos;

    /* Duplicate the file handle. */
    new_attrs->os_handle = Parrot_io_internal_dup(interp, old_attrs->os_handle);

    /* TODO: Clone the buffers and copy flags/data */

    return copy;
#line 121 "./src/pmc/filehandle.c"
}
static  void 
Parrot_FileHandle_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 164 "./src/pmc/filehandle.pmc"

    Parrot_io_close(interp, _self, 1);
#line 129 "./src/pmc/filehandle.c"
}
static  INTVAL 
Parrot_FileHandle_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 233 "./src/pmc/filehandle.pmc"

    return !Parrot_io_eof(interp, _self);
#line 137 "./src/pmc/filehandle.c"
}
static  INTVAL 
Parrot_FileHandle_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), const INTVAL key)
{
#line 180 "./src/pmc/filehandle.pmc"

    INTVAL result;
    switch (key) {
      case 0:
        GETATTR_FileHandle_process_id(interp, _self, result);
        break;
      default:
        result = 0;
    }

    return result;
#line 154 "./src/pmc/filehandle.c"
}
static  void 
Parrot_FileHandle_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 63 "./src/pmc/filehandle.pmc"

    Parrot_FileHandle_attributes * const attrs =
        PMC_data_typed(_self, Parrot_FileHandle_attributes *);

    attrs->record_separator = CONST_STRING(interp, "\n");
    attrs->flags            = 0;
    attrs->filename         = STRINGNULL;
    attrs->mode             = STRINGNULL;
    attrs->encoding         = STRINGNULL;
    attrs->process_id       = 0;
    attrs->exit_status      = 0;
    attrs->file_pos         = piooffsetzero;
    attrs->last_pos         = piooffsetzero;
    attrs->io_vtable        = (IO_VTABLE *)Parrot_io_get_vtable(interp,
                                                                IO_VTABLE_FILEHANDLE, NULL);

    /* Initialize the os_handle to the platform-specific value for closed */
    attrs->os_handle     = (PIOHANDLE) PIO_INVALID_HANDLE;
    attrs->read_buffer = NULL;
    attrs->write_buffer = NULL;

    PObj_custom_mark_SET(_self);
    PObj_custom_destroy_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 184 "./src/pmc/filehandle.c"
}
static  void 
Parrot_FileHandle_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 142 "./src/pmc/filehandle.pmc"

    Parrot_FileHandle_attributes * const attrs
        = PARROT_FILEHANDLE(_self);

    Parrot_gc_mark_STRING_alive(interp, attrs->mode);
    Parrot_gc_mark_STRING_alive(interp, attrs->filename);
    Parrot_gc_mark_STRING_alive(interp, attrs->encoding);
    Parrot_gc_mark_STRING_alive(interp, attrs->record_separator);
    Parrot_io_buffer_mark(interp, attrs->read_buffer);
    Parrot_io_buffer_mark(interp, attrs->write_buffer);
#line 200 "./src/pmc/filehandle.c"
}
static  void 
Parrot_FileHandle_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value)
{
#line 205 "./src/pmc/filehandle.pmc"

    switch (key) {
      case 0:
        {
        SETATTR_FileHandle_process_id(interp, _self, value);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        }
        break;
      default:
        break;
    }
#line 217 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_open(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* filename;
    INTVAL got_filename;
    STRING* mode;
    INTVAL got_mode;
    
    const INTVAL arity = 1; /* "PiSoIpSoIp" */
    const INTVAL arity_opt  = 2;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        filename = VTABLE_get_string_keyed_int(interp, _call_object, 1);
        got_filename = 1;
    }
    else {
        filename = STRINGNULL;
        got_filename = 0;
    }
    if (param_count > 2) {
        mode = VTABLE_get_string_keyed_int(interp, _call_object, 2);
        got_mode = 1;
    }
    else {
        mode = STRINGNULL;
        got_mode = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 282 "./src/pmc/filehandle.pmc"

    PMC    *filehandle;

    if (!Parrot_io_is_closed(interp, _self))
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_PIO_ERROR,
                            "Cannot reopen already open FileHandle");

    if (!got_mode || STRING_IS_NULL(mode))
        GETATTR_FileHandle_mode(interp, _self, mode);

    if (!got_filename || STRING_IS_NULL(filename))
        GETATTR_FileHandle_filename(interp, _self, filename);

    filehandle = Parrot_io_open(interp, _self, filename, mode);
    #line 278 "./src/pmc/filehandle.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)filehandle);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 296 "./src/pmc/filehandle.pmc"

#line 286 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_isatty(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 310 "./src/pmc/filehandle.pmc"

    const INTVAL isatty = Parrot_io_is_tty_handle(interp, _self);
    #line 316 "./src/pmc/filehandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)isatty);
        
        return;
     }
#line 312 "./src/pmc/filehandle.pmc"

#line 324 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_is_closed(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 326 "./src/pmc/filehandle.pmc"

    const INTVAL status = Parrot_io_is_closed(interp, _self);
    #line 354 "./src/pmc/filehandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)status);
        
        return;
     }
#line 328 "./src/pmc/filehandle.pmc"

#line 362 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_readline_interactive(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* prompt;
    INTVAL got_prompt;
    
    const INTVAL arity = 1; /* "PiSoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        prompt = VTABLE_get_string_keyed_int(interp, _call_object, 1);
        got_prompt = 1;
    }
    else {
        prompt = STRINGNULL;
        got_prompt = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 343 "./src/pmc/filehandle.pmc"

    STRING *string_result = NULL;

#ifdef PARROT_HAS_READLINE
/* 4-column indent to get c_indent.t to DTRT */
    char * const prompt_cstring =
        (got_prompt ? Parrot_str_to_cstring(interp, prompt) : NULL);
    char * const r = readline(prompt_cstring);
    Parrot_str_free_cstring(prompt_cstring);

    if (r) {
        STRING *encoding;
        const STR_VTABLE *enc = NULL;
        GETATTR_FileHandle_encoding(interp, _self, encoding);
        if (*r)
            add_history(r);
        if (!STRING_IS_NULL(encoding))
            enc = Parrot_find_encoding_by_string(interp, encoding);
        if (enc == NULL)
            string_result = Parrot_str_new(interp, r, 0);
        else
            string_result = Parrot_str_new_init(interp, r, strlen(r), enc, 0);
        free(r);
    }
#else
    if (got_prompt) {
        char * const prompt_cstring = Parrot_str_to_cstring(interp, prompt);
        fprintf(stderr, "%s", prompt_cstring);
        Parrot_str_free_cstring(prompt_cstring);
    }

    string_result = Parrot_io_readline(interp, _self);

    {
        INTVAL len = STRING_length(string_result);

        if (len == 0) {
            string_result = NULL;
        }
        else {
            while (len > 0) {
                const INTVAL c = STRING_ord(interp, string_result, len - 1);

                if (c != '\n' && c != '\r')
                    break;

                --len;
            }

            string_result = STRING_substr(interp, string_result, 0, len);
        }
    }
#endif

    if (string_result)
        #line 461 "./src/pmc/filehandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)string_result);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 398 "./src/pmc/filehandle.pmc"

    else
        #line 470 "./src/pmc/filehandle.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)PMCNULL);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 400 "./src/pmc/filehandle.pmc"

#line 478 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_readall(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* name;
    INTVAL got_name;
    
    const INTVAL arity = 1; /* "PiSoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        name = VTABLE_get_string_keyed_int(interp, _call_object, 1);
        got_name = 1;
    }
    else {
        name = STRINGNULL;
        got_name = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 429 "./src/pmc/filehandle.pmc"

    STRING *result;

    if (got_name) {
        /* called as class method - open, slurp, close file */
        PMC    *filehandle;
        STRING *encoding;

        GETATTR_FileHandle_encoding(interp, _self, encoding);

        if (!Parrot_io_is_closed(interp, _self))
            Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_PIO_ERROR,
                "Cannot readall on a new file from an already open filehandle");

        filehandle = Parrot_io_open(interp, PMCNULL, name, STRINGNULL);

        SETATTR_FileHandle_encoding(interp, filehandle, encoding);
        result = Parrot_io_readall_s(interp, filehandle);

        Parrot_io_close(interp, filehandle, 1);
    }
    else
        result = Parrot_io_readall_s(interp, _self);

    #line 546 "./src/pmc/filehandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)result);
        
        return;
     }
#line 453 "./src/pmc/filehandle.pmc"

#line 554 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_flush(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 467 "./src/pmc/filehandle.pmc"

    Parrot_io_flush(interp, _self);
#line 584 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_print(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* to_print;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    to_print = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 482 "./src/pmc/filehandle.pmc"

    STRING * const string_to_print = VTABLE_get_string(interp, to_print);

    const INTVAL status = Parrot_io_write_s(interp, _self, string_to_print);

    #line 619 "./src/pmc/filehandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)status);
        
        return;
     }
#line 487 "./src/pmc/filehandle.pmc"

#line 627 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_buffer_type(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* new_type;
    INTVAL got_type;
    
    const INTVAL arity = 1; /* "PiSoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        new_type = VTABLE_get_string_keyed_int(interp, _call_object, 1);
        got_type = 1;
    }
    else {
        new_type = STRINGNULL;
        got_type = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 517 "./src/pmc/filehandle.pmc"

    if (got_type) {
        Parrot_io_set_buffer_mode(interp, _self, new_type);
        PARROT_GC_WRITE_BARRIER(interp, _self);
    }
    else {
        STRING * type_str = Parrot_io_get_buffer_mode(interp, _self);
        #line 678 "./src/pmc/filehandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)type_str);
        
        return;
     }
#line 524 "./src/pmc/filehandle.pmc"

    }
#line 687 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_buffer_size(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    INTVAL new_size;
    INTVAL got_size;
    
    const INTVAL arity = 1; /* "PiIoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        new_size = VTABLE_get_integer_keyed_int(interp, _call_object, 1);
        got_size = 1;
    }
    else {
        new_size = 0;
        got_size = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 539 "./src/pmc/filehandle.pmc"

    INTVAL buffer_size = Parrot_io_buffer_size(interp, _self, new_size, got_size);
    #line 733 "./src/pmc/filehandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)buffer_size);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 541 "./src/pmc/filehandle.pmc"

#line 741 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_mode(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 555 "./src/pmc/filehandle.pmc"

    STRING *mode;
    GETATTR_FileHandle_mode(interp, _self, mode);
    #line 772 "./src/pmc/filehandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)mode);
        
        return;
     }
#line 558 "./src/pmc/filehandle.pmc"

#line 780 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_eof(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 574 "./src/pmc/filehandle.pmc"

    const INTVAL flags = Parrot_io_eof(interp, _self);
    #line 810 "./src/pmc/filehandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)flags);
        
        return;
     }
#line 576 "./src/pmc/filehandle.pmc"

#line 818 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_handle(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 590 "./src/pmc/filehandle.pmc"

    INTVAL handle;
    GETATTR_FileHandle_os_handle(interp, _self, handle);
    #line 849 "./src/pmc/filehandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)handle);
        
        return;
     }
#line 593 "./src/pmc/filehandle.pmc"

#line 857 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_exit_status(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 605 "./src/pmc/filehandle.pmc"

    INTVAL exit_status;
    GETATTR_FileHandle_exit_status(interp, _self, exit_status);
    #line 888 "./src/pmc/filehandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)exit_status);
        
        return;
     }
#line 608 "./src/pmc/filehandle.pmc"

#line 896 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_tell(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 624 "./src/pmc/filehandle.pmc"

    PIOOFF_T pos;
    GETATTR_FileHandle_file_pos(interp, _self, pos);
    #line 927 "./src/pmc/filehandle.c"
    {  /*BEGIN RETURN INTVAL pos, INTVAL pos>>32 */
        Parrot_pcc_set_call_from_c_args(interp, _call_object,
            "II", (INTVAL)pos, (INTVAL)pos>>32);
        
        return;
    }   /*END RETURN INTVAL pos, INTVAL pos>>32 */
#line 627 "./src/pmc/filehandle.pmc"

#line 936 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_seek(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    INTVAL whence;
    INTVAL offs;
    INTVAL offs_overflow;
    INTVAL has_overflow;
    
    const INTVAL arity = 3; /* "PiIIIoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    whence = VTABLE_get_integer_keyed_int(interp, _call_object, 1);
    offs = VTABLE_get_integer_keyed_int(interp, _call_object, 2);
    if (param_count > 3) {
        offs_overflow = VTABLE_get_integer_keyed_int(interp, _call_object, 3);
        has_overflow = 1;
    }
    else {
        offs_overflow = 0;
        has_overflow = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 651 "./src/pmc/filehandle.pmc"

    const PIOOFF_T pio_offs = has_overflow ?
                                Parrot_io_make_offset32(offs_overflow, offs) :
                                offs;
    const INTVAL status = Parrot_io_seek(interp, _self, pio_offs, whence);
    if (0 > status)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
                                    "seek failed: %d", status);
#line 992 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_peek(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 671 "./src/pmc/filehandle.pmc"

    STRING * const s = Parrot_io_peek(interp, _self);
    #line 1022 "./src/pmc/filehandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)s);
        
        return;
     }
#line 673 "./src/pmc/filehandle.pmc"

#line 1030 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_setasync(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 683 "./src/pmc/filehandle.pmc"

    /* Parrot_io_async(interp, _self, 1); */
#line 1060 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_FileHandle_nci_setblocking(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 694 "./src/pmc/filehandle.pmc"

    /* Parrot_io_async(interp, _self, 0); */
#line 1090 "./src/pmc/filehandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_FileHandle_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_FileHandle_clone;
    vt->destroy = Parrot_FileHandle_destroy;
    vt->get_bool = Parrot_FileHandle_get_bool;
    vt->get_integer_keyed_int = Parrot_FileHandle_get_integer_keyed_int;
    vt->init = Parrot_FileHandle_init;
    vt->mark = Parrot_FileHandle_mark;
    vt->set_integer_keyed_int = Parrot_FileHandle_set_integer_keyed_int;
    vt->attr_size = sizeof(Parrot_FileHandle_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_FileHandle_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_FileHandle_clone;
    vt->destroy = Parrot_FileHandle_destroy;
    vt->get_bool = Parrot_FileHandle_get_bool;
    vt->get_integer_keyed_int = Parrot_FileHandle_get_integer_keyed_int;
    vt->mark = Parrot_FileHandle_mark;
    vt->attr_size = sizeof(Parrot_FileHandle_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_FileHandle_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_get_vtable(interp);
    Parrot_FileHandle_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_FileHandle_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_ro_get_vtable(interp);
    Parrot_FileHandle_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_FileHandle_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Handle_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "FileHandle"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_FileHandle_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_Handle_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "FileHandle")), PMCNULL);
    return isa;
}

void
Parrot_FileHandle_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":os_handle Srecord_separator :io_vtable :read_buffer :write_buffer Sencoding Iflags Sfilename Smode Iprocess_id Iexit_status :file_pos :last_pos ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_FileHandle_get_vtable(interp);
        vt->base_type      = enum_class_FileHandle;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "FileHandle");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_FileHandle_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_FileHandle_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_FileHandle;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_FileHandle_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "open");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_open),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "isatty");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_isatty),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "is_closed");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_is_closed),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "readline_interactive");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_readline_interactive),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "readall");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_readall),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "flush");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_flush),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "print");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_print),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "buffer_type");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_buffer_type),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "buffer_size");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_buffer_size),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "mode");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_mode),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "eof");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_eof),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "handle");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_handle),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "exit_status");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_exit_status),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "tell");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_tell),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "seek");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_seek),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "peek");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_peek),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "setasync");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_setasync),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "setblocking");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_FileHandle_nci_setblocking),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_FileHandle_class_init */

#line 704 "./src/pmc/filehandle.pmc"
 /* end pmclass */

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
