/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/hashiterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_hashiterator.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "hashiterator.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/hashiterator.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/hashiterator.pmc - HashIterator PMC

=head1 DESCRIPTION

Generic iterator for traversing a Hash PMC.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, hash, key, entry
    iterator = iter hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    key   = shift iterator     # get the key. Some key
    entry = hash[key]
    ...
    goto iter_loop
  iter_end:

=head2 C++-style usage

    .local pmc iterator, hash, iter_key, key, entry
    iterator = iter hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    iter_key = shift iterator     # get the key
    key = iter_key.'key'()        # get an original key used to put value
    key = iter_key.'value'()      # get an entry
    ...
    goto iter_loop
  iter_end:


=head1 Methods

=over 4

=cut

*/

#include "pmc/pmc_hash.h"
#include "pmc/pmc_hashiteratorkey.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void advance_to_next(ARGMOD(PMC *self))
        __attribute__nonnull__(1)
        FUNC_MODIFIES(*self);

#define ASSERT_ARGS_advance_to_next __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(self))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static void advance_to_next(PMC *self)>

Advance to next position. Return found (if any) HashBucket.

=cut

*/

static void
advance_to_next(ARGMOD(PMC *self))
{
    ASSERT_ARGS(advance_to_next)
    Parrot_HashIterator_attributes * const attrs  = PARROT_HASHITERATOR(self);

    if (attrs->elements <= 0) {
        attrs->elements = -1;
        return;
    }

    if (attrs->parrot_hash->key_type == Hash_key_type_int
    ||  attrs->parrot_hash->key_type == Hash_key_type_ptr
    ||  attrs->parrot_hash->key_type == Hash_key_type_cstring) {
        /* indexed scan */
        if (attrs->bucket)
            attrs->bucket = attrs->bucket->next;
        while (!attrs->bucket) {
            /* Check pos overflow, can happen if items are deleted */
            if (attrs->pos == attrs->total_buckets) {
                attrs->elements = 0;
                break;
            }
            attrs->bucket = attrs->parrot_hash->index[attrs->pos++];
        }
    }
    else {
        /* linear scan */
        const int n_buckets = N_BUCKETS(attrs->total_buckets);

        if (!attrs->bucket)
            attrs->bucket = attrs->parrot_hash->buckets;
        while (attrs->pos < n_buckets) {
            attrs->bucket = attrs->parrot_hash->buckets + attrs->pos++;
            if (attrs->bucket->key)
                break;
        }
        /* Can happen if items are deleted */
        if (!attrs->bucket->key)
            attrs->elements = 0;
    }

    --attrs->elements;

    return;
}
#line 143 "./src/pmc/hashiterator.c"
static  PMC*  Parrot_HashIterator_clone(SHIM_INTERP, SHIM(PMC *_self));
static  INTVAL  Parrot_HashIterator_elements(SHIM_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_HashIterator_get_bool(SHIM_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_HashIterator_get_integer(SHIM_INTERP, ARGMOD(PMC *_self));
static  PMC*  Parrot_HashIterator_get_pmc(SHIM_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_HashIterator_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *hash);
static  void  Parrot_HashIterator_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_HashIterator_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  INTVAL  Parrot_HashIterator_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_HashIterator_shift_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING*  Parrot_HashIterator_shift_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC* 
Parrot_HashIterator_clone(SHIM_INTERP, SHIM(PMC *_self))
{
#line 177 "./src/pmc/hashiterator.pmc"
    return PMCNULL;
#line 160 "./src/pmc/hashiterator.c"
}
static  INTVAL 
Parrot_HashIterator_elements(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 247 "./src/pmc/hashiterator.pmc"
    return PARROT_HASHITERATOR(_self)->elements;
#line 167 "./src/pmc/hashiterator.c"
}
static  INTVAL 
Parrot_HashIterator_get_bool(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 231 "./src/pmc/hashiterator.pmc"
    return PARROT_HASHITERATOR(_self)->elements != 0;

#line 175 "./src/pmc/hashiterator.c"
}
static  INTVAL 
Parrot_HashIterator_get_integer(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 252 "./src/pmc/hashiterator.pmc"
    return PARROT_HASHITERATOR(_self)->elements;
#line 182 "./src/pmc/hashiterator.c"
}
static  PMC* 
Parrot_HashIterator_get_pmc(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 216 "./src/pmc/hashiterator.pmc"
    return PARROT_HASHITERATOR(_self)->pmc_hash;
#line 189 "./src/pmc/hashiterator.c"
}
static  void 
Parrot_HashIterator_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *hash)
{
#line 140 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs =
        (Parrot_HashIterator_attributes *) PMC_data(_self);

    attrs->pmc_hash         = hash;
    attrs->parrot_hash      = (Hash*)VTABLE_get_pointer(interp, hash);
    attrs->total_buckets    = attrs->parrot_hash->mask + 1;
    attrs->elements         = attrs->parrot_hash->entries;
    attrs->bucket           = NULL;
    attrs->pos              = 0;

    PObj_custom_mark_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 208 "./src/pmc/hashiterator.c"
}
static  void 
Parrot_HashIterator_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 164 "./src/pmc/hashiterator.pmc"

    PMC * const hash = PARROT_HASHITERATOR(_self)->pmc_hash;
    Parrot_gc_mark_PMC_alive(interp, hash);
    /* We don't mark underlying parrot_hash. Hash PMC will mark it */
#line 218 "./src/pmc/hashiterator.c"
}
static  void 
Parrot_HashIterator_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 190 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs =
            PARROT_HASHITERATOR(_self);

    if (value == ITERATE_FROM_START) {
        /* Restart iterator */
        attrs->elements         = attrs->parrot_hash->entries;
        attrs->bucket           = NULL;
        attrs->pos              = 0;
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
    }

    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
            "HashIterator: unknown iterator type");
#line 239 "./src/pmc/hashiterator.c"
}
static  INTVAL 
Parrot_HashIterator_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 309 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs = PARROT_HASHITERATOR(_self);

    /* Move to next bucket */
    advance_to_next(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);

    if (attrs->elements < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "StopIteration");

    return Parrot_hash_key_to_int(interp, attrs->parrot_hash, attrs->bucket->key);
#line 257 "./src/pmc/hashiterator.c"
}
static  PMC  *
Parrot_HashIterator_shift_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 268 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs =
            PARROT_HASHITERATOR(_self);

    PMC        *ret;

    /* Move to next bucket */
    advance_to_next(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);

    if (attrs->elements < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "StopIteration");

    ret = Parrot_pmc_new(interp, enum_class_HashIteratorKey);
    VTABLE_set_pointer_keyed_int(interp, ret, 0, attrs->parrot_hash);
    VTABLE_set_pointer_keyed_int(interp, ret, 1, attrs->bucket);

    return ret;
#line 282 "./src/pmc/hashiterator.c"
}
static  STRING* 
Parrot_HashIterator_shift_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 293 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs = PARROT_HASHITERATOR(_self);

    /* Move to next bucket */
    advance_to_next(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);

    if (attrs->elements < 0)
        return CONST_STRING(interp, "");

    return Parrot_hash_key_to_string(interp, attrs->parrot_hash, attrs->bucket->key);
#line 299 "./src/pmc/hashiterator.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_HashIterator_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_HashIterator_clone;
    vt->elements = Parrot_HashIterator_elements;
    vt->get_bool = Parrot_HashIterator_get_bool;
    vt->get_integer = Parrot_HashIterator_get_integer;
    vt->get_pmc = Parrot_HashIterator_get_pmc;
    vt->init_pmc = Parrot_HashIterator_init_pmc;
    vt->mark = Parrot_HashIterator_mark;
    vt->set_integer_native = Parrot_HashIterator_set_integer_native;
    vt->shift_integer = Parrot_HashIterator_shift_integer;
    vt->shift_pmc = Parrot_HashIterator_shift_pmc;
    vt->shift_string = Parrot_HashIterator_shift_string;
    vt->attr_size = sizeof(Parrot_HashIterator_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_HashIterator_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_HashIterator_clone;
    vt->elements = Parrot_HashIterator_elements;
    vt->get_bool = Parrot_HashIterator_get_bool;
    vt->get_integer = Parrot_HashIterator_get_integer;
    vt->get_pmc = Parrot_HashIterator_get_pmc;
    vt->mark = Parrot_HashIterator_mark;
    vt->attr_size = sizeof(Parrot_HashIterator_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_HashIterator_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_get_vtable(interp);
    Parrot_HashIterator_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_HashIterator_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_ro_get_vtable(interp);
    Parrot_HashIterator_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_HashIterator_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Iterator_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "HashIterator"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_HashIterator_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_Iterator_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "HashIterator")), PMCNULL);
    return isa;
}

void
Parrot_HashIterator_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fpmc_hash :parrot_hash :bucket Itotal_buckets Ipos Ielements ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_HashIterator_get_vtable(interp);
        vt->base_type      = enum_class_HashIterator;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "HashIterator");
        vt->provides_str = CONST_STRING_GEN(interp, "iterator");
        vt->isa_hash     = Parrot_HashIterator_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_HashIterator_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_HashIterator;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_HashIterator_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_HashIterator_class_init */

#line 321 "./src/pmc/hashiterator.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
