/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/packfileview.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_packfileview.h"
#include "pmc_default.h"
#include "packfileview.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/packfileview.pmc"
/*
Copyright (C) 2011-2014, Parrot Foundation.

=head1 NAME

src/pmc/packfileview.pmc - PackfileView PMC

=head1 DESCRIPTION

This class implements a user-accessible, read-only wrapper for the PackFile*
structure used internally by Parrot. It is essentially an interface for the user
to call Packfile subsystem API calls, and work with the PackFile* structures
output from utilities which generate them.

NOTICE: This PMC should contain very little logic. It should be a thin wrapper
around the public functions in src/packfile/api.c. This PMC should contain
absolutely NO functionality for modifying the packfile. To create a new
packfile or modify an existing one, use the PackFile PMC instead.

=head2 VTABLES

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void add_called_tag(PARROT_INTERP,
    ARGMOD(PMC * self),
    ARGIN(STRING * tag))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(* self);

static INTVAL find_called_tag(PARROT_INTERP,
    ARGIN(PMC * self),
    ARGIN(STRING * tag))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

PARROT_CAN_RETURN_NULL
static PackFile_ConstTable * get_const_table(PARROT_INTERP,
    ARGIN(PMC * self))
        __attribute__nonnull__(2);

PARROT_CANNOT_RETURN_NULL
static PMC * get_first_sub(PARROT_INTERP, ARGIN(PMC *pfpmc))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

#define ASSERT_ARGS_add_called_tag __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(tag))
#define ASSERT_ARGS_find_called_tag __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(tag))
#define ASSERT_ARGS_get_const_table __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_get_first_sub __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(pfpmc))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static PackFile_ConstTable * get_const_table(PARROT_INTERP, PMC * self)>

Get the constant table for the PackFile*. Return NULL if there's a problem.

=cut

*/

PARROT_CAN_RETURN_NULL
static PackFile_ConstTable *
get_const_table(SHIM_INTERP, ARGIN(PMC * self))
{
    ASSERT_ARGS(get_const_table)
    Parrot_PackfileView_attributes * const attrs =
                PARROT_PACKFILEVIEW(self);
    PackFile * const pf = attrs->pf;
    PackFile_ByteCode * bt;
    if (!pf)
        return NULL;
    bt = pf->cur_cs;
    if (!bt)
        return NULL;
    return bt->const_table;
}

/*

=item C<static INTVAL find_called_tag(PARROT_INTERP, PMC * self, STRING * tag)>

Find a called tag in the cache. Return 1 if it exists, 0 otherwise.

=item C<static void add_called_tag(PARROT_INTERP, PMC * self, STRING * tag)>

Add a called tag to the cache, if it doesn't exist already. Do nothing
otherwise.

=cut

*/

static INTVAL
find_called_tag(PARROT_INTERP, ARGIN(PMC * self), ARGIN(STRING * tag))
{
    ASSERT_ARGS(find_called_tag)
    Parrot_PackfileView_attributes * const attrs = PARROT_PACKFILEVIEW(self);
    PMC *  const called_tags = attrs->called_tags;
    if (!PMC_IS_NULL(called_tags)) {
        const INTVAL count = VTABLE_elements(interp, called_tags);
        INTVAL i;
        for (i = 0; i < count; i++) {
            STRING * const str = VTABLE_get_string_keyed_int(interp, called_tags, i);
            if (STRING_equal(interp, str, tag))
                return 1;
        }
    }
    return 0;
}

static void
add_called_tag(PARROT_INTERP, ARGMOD(PMC * self), ARGIN(STRING * tag))
{
    ASSERT_ARGS(add_called_tag)
    const int has_it = find_called_tag(interp, self, tag);
    if (!has_it) {
        Parrot_PackfileView_attributes * const attrs = PARROT_PACKFILEVIEW(self);
        PMC *  called_tags = attrs->called_tags;
        if (PMC_IS_NULL(called_tags)) {
            called_tags = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
            attrs->called_tags = called_tags;
        }
        VTABLE_push_string(interp, called_tags, tag);
    }
}
#line 171 "./src/pmc/packfileview.c"
static  void  Parrot_PackfileView_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_PackfileView_get_bool(SHIM_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_PackfileView_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  PMC *  Parrot_PackfileView_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  void  * Parrot_PackfileView_get_pointer(SHIM_INTERP, ARGMOD(PMC *_self));
static  STRING *  Parrot_PackfileView_get_string(SHIM_INTERP, ARGMOD(PMC *_self));
static  STRING *  Parrot_PackfileView_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  void  Parrot_PackfileView_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PackfileView_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PackfileView_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr);
static  void  Parrot_PackfileView_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *path);
static  void Parrot_PackfileView_nci_constant_counts(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_main_sub(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_subs_by_tag(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_single_sub_by_tag(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_all_subs(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_first_sub_in_const_table(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_all_tags(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_all_tagged_pmcs(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_mark_initialized(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_is_initialized(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_serialized_size(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_serialize(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_deserialize(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_read_from_file(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_write_to_file(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_get_version(PARROT_INTERP, ARGMOD(PMC *_self));
static  void 
Parrot_PackfileView_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 190 "./src/pmc/packfileview.pmc"

    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf != NULL)
        Parrot_pf_destroy(interp, attrs->pf);
#line 208 "./src/pmc/packfileview.c"
}
static  INTVAL 
Parrot_PackfileView_get_bool(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 238 "./src/pmc/packfileview.pmc"
    return (PARROT_PACKFILEVIEW(_self)->pf != NULL);
#line 215 "./src/pmc/packfileview.c"
}
static  FLOATVAL 
Parrot_PackfileView_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 304 "./src/pmc/packfileview.pmc"

    PackFile_ConstTable * const ct = get_const_table(interp, _self);
    if (!ct)
        return 0.0;
    if (idx < 0 || idx >= ct->num.const_count) {
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "index out of bounds");
    }
    return ct->num.constants[idx];
#line 230 "./src/pmc/packfileview.c"
}
static  PMC * 
Parrot_PackfileView_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 282 "./src/pmc/packfileview.pmc"

    PackFile_ConstTable * const ct = get_const_table(interp, _self);
    if (!ct)
        return PMCNULL;
    if (idx < 0 || idx >= ct->pmc.const_count) {
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "index out of bounds");
    }
    return ct->pmc.constants[idx];
#line 245 "./src/pmc/packfileview.c"
}
static  void  *
Parrot_PackfileView_get_pointer(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 233 "./src/pmc/packfileview.pmc"
    return PARROT_PACKFILEVIEW(_self)->pf;
#line 252 "./src/pmc/packfileview.c"
}
static  STRING * 
Parrot_PackfileView_get_string(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 257 "./src/pmc/packfileview.pmc"

    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    return attrs->path ? attrs->path : STRINGNULL;
#line 262 "./src/pmc/packfileview.c"
}
static  STRING * 
Parrot_PackfileView_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 293 "./src/pmc/packfileview.pmc"

    PackFile_ConstTable * const ct = get_const_table(interp, _self);
    if (!ct)
        return STRINGNULL;
    if (idx < 0 || idx >= ct->str.const_count) {
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "index out of bounds");
    }
    return ct->str.constants[idx];
#line 277 "./src/pmc/packfileview.c"
}
static  void 
Parrot_PackfileView_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 183 "./src/pmc/packfileview.pmc"

    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    attrs->pf = NULL;
    PObj_custom_mark_destroy_SETALL(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 289 "./src/pmc/packfileview.c"
}
static  void 
Parrot_PackfileView_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 172 "./src/pmc/packfileview.pmc"

    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf != NULL)
        Parrot_pf_mark_packfile(interp, attrs->pf);
    if (!STRING_IS_NULL(attrs->path))
        Parrot_gc_mark_STRING_alive(interp, attrs->path);
    if (!PMC_IS_NULL(attrs->called_tags))
        Parrot_gc_mark_PMC_alive(interp, attrs->called_tags);
#line 304 "./src/pmc/packfileview.c"
}
static  void 
Parrot_PackfileView_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr)
{
#line 221 "./src/pmc/packfileview.pmc"

    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf != NULL)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
            "Cannot overwrite existing pointer in PackfileView");
    attrs->pf = (PackFile*)ptr;
    /* Do not free an empty pf? See above */
    if (ptr != NULL)
        PARROT_GC_WRITE_BARRIER(interp, _self);
#line 320 "./src/pmc/packfileview.c"
}
static  void 
Parrot_PackfileView_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *path)
{
#line 253 "./src/pmc/packfileview.pmc"

    PARROT_PACKFILEVIEW(_self)->path = path;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 329 "./src/pmc/packfileview.c"
}
static  void
Parrot_PackfileView_nci_constant_counts(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 332 "./src/pmc/packfileview.pmc"

    PackFile_ConstTable * const ct = get_const_table(interp, _self);
    if (!ct)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_UNEXPECTED_NULL,
            "NULL or Malformed Packfile");
    else {
        PMC * const counts = Parrot_pmc_new(interp, enum_class_FixedIntegerArray);
        VTABLE_set_integer_native(interp, counts, 3);
        VTABLE_set_integer_keyed_int(interp, counts, 0, ct->num.const_count);
        VTABLE_set_integer_keyed_int(interp, counts, 1, ct->str.const_count);
        VTABLE_set_integer_keyed_int(interp, counts, 2, ct->pmc.const_count);
        #line 361 "./src/pmc/packfileview.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)counts);
        
        return;
     }
#line 343 "./src/pmc/packfileview.pmc"

    }
#line 370 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_main_sub(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 395 "./src/pmc/packfileview.pmc"

    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf == NULL)
        #line 402 "./src/pmc/packfileview.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)PMCNULL);
        
        return;
     }
#line 399 "./src/pmc/packfileview.pmc"

    else {
        PMC * const main_sub = Parrot_pf_get_packfile_main_sub(interp, _self);
        #line 412 "./src/pmc/packfileview.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)main_sub);
        
        return;
     }
#line 402 "./src/pmc/packfileview.pmc"

    }
#line 421 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_subs_by_tag(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* flag;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    flag = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 406 "./src/pmc/packfileview.pmc"

    PMC * const subs = Parrot_pf_subs_by_tag(interp, _self, flag);
    #line 453 "./src/pmc/packfileview.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)subs);
        
        return;
     }
#line 408 "./src/pmc/packfileview.pmc"

#line 461 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_single_sub_by_tag(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* flag;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    flag = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 411 "./src/pmc/packfileview.pmc"

    PMC * const sub = Parrot_pf_single_sub_by_tag(interp, _self, flag);
    #line 493 "./src/pmc/packfileview.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)sub);
        
        return;
     }
#line 413 "./src/pmc/packfileview.pmc"

#line 501 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_all_subs(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 416 "./src/pmc/packfileview.pmc"

    PMC * const array = Parrot_pf_all_subs(interp, _self);
    #line 531 "./src/pmc/packfileview.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)array);
        
        return;
     }
#line 418 "./src/pmc/packfileview.pmc"

#line 539 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_first_sub_in_const_table(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 421 "./src/pmc/packfileview.pmc"

    PMC * const sub = get_first_sub(interp, _self);
    #line 569 "./src/pmc/packfileview.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)sub);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 423 "./src/pmc/packfileview.pmc"

#line 577 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_all_tags(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 426 "./src/pmc/packfileview.pmc"

    PMC * const array = Parrot_pf_all_tags_list(interp, _self);
    #line 607 "./src/pmc/packfileview.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)array);
        
        return;
     }
#line 428 "./src/pmc/packfileview.pmc"

#line 615 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_all_tagged_pmcs(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 431 "./src/pmc/packfileview.pmc"

    PMC * const hash = Parrot_pf_all_tagged_pmcs(interp, _self);
    #line 645 "./src/pmc/packfileview.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)hash);
        
        return;
     }
#line 433 "./src/pmc/packfileview.pmc"

#line 653 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_mark_initialized(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* tag;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    tag = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 436 "./src/pmc/packfileview.pmc"

    add_called_tag(interp, _self, tag);
#line 685 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_is_initialized(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* tag;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    tag = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 440 "./src/pmc/packfileview.pmc"

    const INTVAL has_it = find_called_tag(interp, _self, tag);
    #line 717 "./src/pmc/packfileview.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)has_it);
        
        return;
     }
#line 442 "./src/pmc/packfileview.pmc"

#line 725 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_serialized_size(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 464 "./src/pmc/packfileview.pmc"

    INTVAL size;
    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf == NULL)
        #line 758 "./src/pmc/packfileview.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)0);
        
        return;
     }
#line 469 "./src/pmc/packfileview.pmc"

    size = Parrot_pf_serialized_size(interp, attrs->pf);
    #line 767 "./src/pmc/packfileview.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)size);
        
        return;
     }
#line 471 "./src/pmc/packfileview.pmc"

#line 775 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_serialize(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 474 "./src/pmc/packfileview.pmc"

    STRING *str;
    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf == NULL)
        #line 808 "./src/pmc/packfileview.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)STRINGNULL);
        
        return;
     }
#line 479 "./src/pmc/packfileview.pmc"

    str = Parrot_pf_serialize(interp, attrs->pf);
    #line 817 "./src/pmc/packfileview.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)str);
        
        return;
     }
#line 481 "./src/pmc/packfileview.pmc"

#line 825 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_deserialize(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* pbc;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    pbc = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 484 "./src/pmc/packfileview.pmc"

    PackFile * const pf = Parrot_pf_deserialize(interp, pbc);
    VTABLE_set_pointer(interp, _self, pf);
#line 858 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_read_from_file(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* filename;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    filename = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 505 "./src/pmc/packfileview.pmc"

    PackFile * const pf = Parrot_pf_read_pbc_file(interp, filename);
    VTABLE_set_pointer(interp, _self, pf);
    pf->view = _self;
    VTABLE_set_string_native(interp, _self, filename);
#line 893 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_write_to_file(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* filename;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    filename = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 512 "./src/pmc/packfileview.pmc"

    Parrot_pf_write_pbc_file(interp, _self, filename);
#line 925 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_get_version(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 526 "./src/pmc/packfileview.pmc"

    STRING * const version = Parrot_pf_get_version_string(interp, _self);
    #line 955 "./src/pmc/packfileview.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)version);
        
        return;
     }
#line 528 "./src/pmc/packfileview.pmc"

#line 963 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_PackfileView_update_vtable(VTABLE *vt) {
    vt->destroy = Parrot_PackfileView_destroy;
    vt->get_bool = Parrot_PackfileView_get_bool;
    vt->get_number_keyed_int = Parrot_PackfileView_get_number_keyed_int;
    vt->get_pmc_keyed_int = Parrot_PackfileView_get_pmc_keyed_int;
    vt->get_pointer = Parrot_PackfileView_get_pointer;
    vt->get_string = Parrot_PackfileView_get_string;
    vt->get_string_keyed_int = Parrot_PackfileView_get_string_keyed_int;
    vt->init = Parrot_PackfileView_init;
    vt->mark = Parrot_PackfileView_mark;
    vt->set_pointer = Parrot_PackfileView_set_pointer;
    vt->set_string_native = Parrot_PackfileView_set_string_native;
    vt->attr_size = sizeof(Parrot_PackfileView_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_PackfileView_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->destroy = Parrot_PackfileView_destroy;
    vt->get_bool = Parrot_PackfileView_get_bool;
    vt->get_number_keyed_int = Parrot_PackfileView_get_number_keyed_int;
    vt->get_pmc_keyed_int = Parrot_PackfileView_get_pmc_keyed_int;
    vt->get_pointer = Parrot_PackfileView_get_pointer;
    vt->get_string = Parrot_PackfileView_get_string;
    vt->get_string_keyed_int = Parrot_PackfileView_get_string_keyed_int;
    vt->mark = Parrot_PackfileView_mark;
    vt->attr_size = sizeof(Parrot_PackfileView_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_PackfileView_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_PackfileView_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_PackfileView_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_PackfileView_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_PackfileView_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "PackfileView"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_PackfileView_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "PackfileView")), PMCNULL);
    return isa;
}

void
Parrot_PackfileView_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":pf Spath Fcalled_tags ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_PackfileView_get_vtable(interp);
        vt->base_type      = enum_class_PackfileView;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "PackfileView");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_PackfileView_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_PackfileView_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_PackfileView;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_PackfileView_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "constant_counts");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_constant_counts),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "main_sub");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_main_sub),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "subs_by_tag");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_subs_by_tag),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "single_sub_by_tag");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_single_sub_by_tag),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "all_subs");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_all_subs),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "first_sub_in_const_table");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_first_sub_in_const_table),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "all_tags");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_all_tags),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "all_tagged_pmcs");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_all_tagged_pmcs),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "mark_initialized");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_mark_initialized),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "is_initialized");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_is_initialized),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "serialized_size");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_serialized_size),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "serialize");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_serialize),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "deserialize");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_deserialize),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "read_from_file");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_read_from_file),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "write_to_file");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_write_to_file),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_version");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_get_version),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_PackfileView_class_init */

#line 529 "./src/pmc/packfileview.pmc"


/*

=item C<static PMC * get_first_sub(PARROT_INTERP, PMC *pfpmc)>

Returns the first Sub constant from the constant table.

=cut

*/

PARROT_CANNOT_RETURN_NULL
static PMC *
get_first_sub(PARROT_INTERP, ARGIN(PMC *pfpmc))
{
    ASSERT_ARGS(get_first_sub)
    PackFile * const pf = (PackFile*)VTABLE_get_pointer(interp, pfpmc);
    if (!pf || !pf->cur_cs || !pf->cur_cs->const_table)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_UNEXPECTED_NULL,
            "NULL or invalid packfile");

    {
        PackFile_ConstTable * const ct = pf->cur_cs->const_table;
        INTVAL i;
        STRING * const SUB = CONST_STRING(interp, "Sub");
        for (i = 0; i < ct->pmc.const_count; ++i) {
            PMC * const x = ct->pmc.constants[i];
            if (VTABLE_isa(interp, x, SUB))
                return x;
        }
        return PMCNULL;
    }
}

/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
