/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/pmcproxy.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_pmcproxy.h"
#include "pmc_class.h"
#include "pmc_default.h"
#include "pmcproxy.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/pmcproxy.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/pmcproxy.pmc - PMCProxy PMC

=head1 DESCRIPTION

Proxy class object for a PMC enabling introspection.

This class is used to describe a PMC. It can sit in an inheritance hierarchy
of a PDD15 class as well as allowing introspection of the PMC.

PMCProxy is not derived from any other PMC.

=head2 Structure

This class stores its state in the Parrot_Class structure, using the
following fields.

=over 4

=item C<id>

The type number of the PMC that is being described.

=item C<name>

The name of the PMC -- a STRING.

=item C<namespace>

The namespace the PMC is associated with, if any.

=item C<parents>

An array of immediate parent classes.
An empty ResizablePMCArray PMC is allocated during initialization.

=item C<all_parents>

A cached array of ourself and all parent classes, in MRO order.
A ResizablePMCArray PMC is allocated during initialization,
and is populated with the current class.

=back

NOTE: No doubt we will need other things later; this is a start.

=cut

*/

#include "parrot/oo_private.h"

/*

=head2 Functions

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 94 "./src/pmc/pmcproxy.c"
static  INTVAL  Parrot_PMCProxy_does(PARROT_INTERP, ARGMOD(PMC *_self), STRING *role_name);
static  STRING  * Parrot_PMCProxy_get_string(SHIM_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PMCProxy_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PMCProxy_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL type_num);
static  void  Parrot_PMCProxy_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init_data);
static  PMC  * Parrot_PMCProxy_inspect(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_PMCProxy_instantiate(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init);
static  INTVAL  Parrot_PMCProxy_isa(PARROT_INTERP, ARGMOD(PMC *_self), STRING *classname);
static  INTVAL  Parrot_PMCProxy_isa_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *lookup);
static  INTVAL  Parrot_PMCProxy_type(SHIM_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PMCProxy_nci_name(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PMCProxy_nci_get_namespace(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PMCProxy_nci_new(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PMCProxy_nci_methods(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PMCProxy_nci_parents(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PMCProxy_nci_inspect(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL 
Parrot_PMCProxy_does(PARROT_INTERP, ARGMOD(PMC *_self), STRING *role_name)
{
#line 303 "./src/pmc/pmcproxy.pmc"

    const INTVAL id = PARROT_CLASS(_self)->id;
    const INTVAL type_does = Parrot_pmc_type_does(interp, role_name, id);

    if (type_does)
        return 1;
    return VTABLE_isa(interp, _self, role_name);
#line 122 "./src/pmc/pmcproxy.c"
}
static  STRING  *
Parrot_PMCProxy_get_string(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 371 "./src/pmc/pmcproxy.pmc"
    const Parrot_Class_attributes * const proxy_info = PARROT_CLASS(_self);
    return proxy_info->name;
#line 130 "./src/pmc/pmcproxy.c"
}
static  void 
Parrot_PMCProxy_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 84 "./src/pmc/pmcproxy.pmc"

    Parrot_PMCProxy_attributes * const _pmc = PARROT_PMCPROXY(_self);
    STRING                     * const name = CONST_STRING(interp, "proxy");
    PMC                        * const new_attribute
         = Parrot_pmc_new(interp, enum_class_Hash);

    interp->vtables[enum_class_Class]->init(interp, _self);

    /* Set up the attribute storage for the proxy instance */
    VTABLE_set_string_keyed_str(interp, new_attribute, CONST_STRING(interp, "name"), name);
    VTABLE_set_pmc_keyed_str(interp, _pmc->attrib_metadata, name, new_attribute);

    CLASS_is_anon_CLEAR(_self);
#line 149 "./src/pmc/pmcproxy.c"
}
static  void 
Parrot_PMCProxy_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL type_num)
{
#line 99 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes *proxy_info;
    INTVAL mro_length, i;

    /* Ensure that it's a valid type number. */
    if (type_num > interp->n_vtable_max || type_num <= 0)
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Attempt to create PMC Proxy for invalid type number = %d!", type_num);

    /* Set up the object. */
    VTABLE_init(interp, _self);

    /* Set up number, name and namespace. */
    proxy_info             = PARROT_CLASS(_self);
    proxy_info->id         = type_num;
    proxy_info->name       = interp->vtables[type_num]->whoami;
    proxy_info->_namespace = interp->vtables[type_num]->_namespace;

    /* Build MRO (skip ourself). */
    mro_length = VTABLE_elements(interp, interp->vtables[type_num]->mro);
    for (i = 1; i < mro_length; ++i) {
        PMC    * const pclass = VTABLE_get_pmc_keyed_int(interp,
                                                         interp->vtables[type_num]->mro, i);
        PMC    * const cns    = pclass->vtable->_namespace;
        STRING * const cname  = pclass->vtable->whoami;
        if (!STRING_equal(interp, cname, CONST_STRING(interp, "scalar"))) {
            PMC * const pproxy = Parrot_oo_get_class(interp, cns);
            VTABLE_push_pmc(interp, proxy_info->all_parents, pproxy);
        }
    }

    /* PMCs just do single inheritance, so we'll assume that if we have a
     * second entry in our MRO, it goes in the parents list. */
    if (VTABLE_elements(interp, proxy_info->all_parents) >= 2)
        VTABLE_push_pmc(interp, proxy_info->parents,
                VTABLE_get_pmc_keyed_int(interp, proxy_info->all_parents, 1));

    if (!PMC_IS_NULL(proxy_info->_namespace) &&
        PMC_IS_NULL(VTABLE_get_class(interp, proxy_info->_namespace))) {

        /* Link the proxy and the namespace, caching the proxy object for
         * later retrieval on class lookup. */
        Parrot_pcc_invoke_method_from_c_args(interp, proxy_info->_namespace, CONST_STRING(interp, "set_class"), "P->", _self);

        /* Extract any methods from the namespace */
        Parrot_oo_extract_methods_from_namespace(interp, _self,
                proxy_info->_namespace);
    }

    { /* Create inherited attributes */
        /* Each attribute is prefixed with his type
         * and terminated by an space,
         * the list is '\0' terminated
         */
        const char *attr = interp->vtables[type_num]->attribute_defs;
        while (*attr) {
            const char * const current = attr + 1;
            const char attrtype = *attr;

            while (*attr != ' ')
                ++attr;
            if (attrtype != ':') {
                const size_t n = attr - current;
                STRING * const sattr = Parrot_str_new(interp, current, n);
                VTABLE_add_attribute(interp, _self, sattr, NULL);
            }
            ++attr;
        }
    }
#line 225 "./src/pmc/pmcproxy.c"
}
static  void 
Parrot_PMCProxy_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init_data)
{
#line 171 "./src/pmc/pmcproxy.pmc"

    const INTVAL type_num = VTABLE_get_integer(interp, init_data);
    VTABLE_init_int(interp, _self, type_num);
#line 234 "./src/pmc/pmcproxy.c"
}
static  PMC  *
Parrot_PMCProxy_inspect(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 339 "./src/pmc/pmcproxy.pmc"

    /* Create a hash, then use inspect_str to get all of the data to
     * fill it up with. */
    STRING * const name_str    = CONST_STRING(interp, "name");
    STRING * const ns_str      = CONST_STRING(interp, "namespace");
    STRING * const meth_str    = CONST_STRING(interp, "methods");
    STRING * const parents_str = CONST_STRING(interp, "parents");

    PMC * const metadata = Parrot_pmc_new(interp, enum_class_Hash);

    VTABLE_set_pmc_keyed_str(interp, metadata, name_str,
        VTABLE_inspect_str(interp, _self, name_str));
    VTABLE_set_pmc_keyed_str(interp, metadata, ns_str,
        VTABLE_inspect_str(interp, _self, ns_str));
    VTABLE_set_pmc_keyed_str(interp, metadata, meth_str,
        VTABLE_inspect_str(interp, _self, meth_str));
    VTABLE_set_pmc_keyed_str(interp, metadata, parents_str,
        VTABLE_inspect_str(interp, _self, parents_str));

    return metadata;
#line 260 "./src/pmc/pmcproxy.c"
}
static  PMC  *
Parrot_PMCProxy_instantiate(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init)
{
#line 185 "./src/pmc/pmcproxy.pmc"

    const Parrot_Class_attributes * const _pmc = PARROT_CLASS(_self);

    if (!PMC_IS_NULL(init))
        return Parrot_pmc_new_init(interp, _pmc->id, init);

    return Parrot_pmc_new(interp, _pmc->id);
#line 273 "./src/pmc/pmcproxy.c"
}
static  INTVAL 
Parrot_PMCProxy_isa(PARROT_INTERP, ARGMOD(PMC *_self), STRING *classname)
{
#line 268 "./src/pmc/pmcproxy.pmc"

    const Parrot_Class_attributes * const _proxy = PARROT_CLASS(_self);

    if (STRING_equal(interp, classname, CONST_STRING(interp, "PMCProxy")))
        return 1;

    if (interp->vtables[enum_class_Class]->isa(interp, _self, classname))
        return 1;

    /* Look in the isa hash. */
    if (interp->vtables[_proxy->id]) {
        const Hash * const isa_hash = interp->vtables[_proxy->id]->isa_hash;

        if (!isa_hash && STRING_equal(interp,
                 interp->vtables[_proxy->id]->whoami, classname)) {
            return 1;
        }

        if (isa_hash && Parrot_hash_exists(interp, isa_hash, classname))
            return 1;
    }

    return 0;
#line 302 "./src/pmc/pmcproxy.c"
}
static  INTVAL 
Parrot_PMCProxy_isa_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *lookup)
{
#line 204 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const _proxy = PARROT_CLASS(_self);
    INTVAL        i, num_classes;
    const STRING *classname;
    PMC          *classobj;

    if (PMC_IS_NULL(lookup))
        return 0;

    if (interp->vtables[enum_class_Class]->isa_pmc(interp, _self, lookup))
        return 1;

    classobj = Parrot_oo_get_class(interp, lookup);

    if (PMC_IS_NULL(classobj))
        return 0;

    classname = VTABLE_get_string(interp, classobj);

    /* Check if the passed name is the same as the stored short name. */
    if (STRING_equal(interp, classname, _proxy->name))
        return 1;

    /* Check if the class object is the same as self's class object */
    if (VTABLE_is_same(interp, _self, classobj))
        return 1;

    /* Check if the passed name is the same as the fully qualified name. */
    if (STRING_equal(interp, classname, VTABLE_get_string(interp, _self)))
        return 1;

    /* Look in the isa hash. */
    if (interp->vtables[_proxy->id]) {
        const Hash * const isa_hash = interp->vtables[_proxy->id]->isa_hash;
        PARROT_ASSERT(isa_hash);
        if (Parrot_hash_exists(interp, isa_hash, classname))
            return 1;
    }

    /* Iterate over all the parents and check if they respond true
     * for 'isa' on the original comparison. */
    num_classes = VTABLE_elements(interp, _proxy->parents);

    for (i = 0; i < num_classes; ++i) {
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp,
            _proxy->parents, i);

        if (VTABLE_isa_pmc(interp, cur_class, lookup))
            return 1;
    }

    return 0;
#line 360 "./src/pmc/pmcproxy.c"
}
static  INTVAL 
Parrot_PMCProxy_type(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 323 "./src/pmc/pmcproxy.pmc"
    const Parrot_Class_attributes * const _class = PARROT_CLASS(_self);
    return _class->id;
#line 368 "./src/pmc/pmcproxy.c"
}
static  void
Parrot_PMCProxy_nci_name(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 387 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const _pmc     = PARROT_CLASS(_self);
    STRING       * const ret_name = _pmc->name;
    #line 392 "./src/pmc/pmcproxy.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)ret_name);
        
        return;
     }
#line 390 "./src/pmc/pmcproxy.pmc"


#line 401 "./src/pmc/pmcproxy.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PMCProxy_nci_get_namespace(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 404 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const _pmc          = PARROT_CLASS(_self);
    PMC          * const ret_namespace = _pmc->_namespace;
    #line 432 "./src/pmc/pmcproxy.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)ret_namespace);
        
        return;
     }
#line 407 "./src/pmc/pmcproxy.pmc"

#line 440 "./src/pmc/pmcproxy.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PMCProxy_nci_new(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* args;
    INTVAL got_args;
    
    const INTVAL arity = 1; /* "PiPoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        args = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);
        got_args = 1;
    }
    else {
        args = PMCNULL;
        got_args = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 420 "./src/pmc/pmcproxy.pmc"

    PMC * const obj = VTABLE_instantiate(interp, _self, args);
    UNUSED(got_args);
    #line 487 "./src/pmc/pmcproxy.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)obj);
        
        return;
     }
#line 423 "./src/pmc/pmcproxy.pmc"

#line 495 "./src/pmc/pmcproxy.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PMCProxy_nci_methods(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 436 "./src/pmc/pmcproxy.pmc"

    PMC * const ret_methods = VTABLE_inspect_str(interp, _self, CONST_STRING(interp, "methods"));
    #line 525 "./src/pmc/pmcproxy.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)ret_methods);
        
        return;
     }
#line 438 "./src/pmc/pmcproxy.pmc"

#line 533 "./src/pmc/pmcproxy.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PMCProxy_nci_parents(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 451 "./src/pmc/pmcproxy.pmc"

    PMC * const ret_parents = VTABLE_inspect_str(interp, _self, CONST_STRING(interp, "parents"));
    #line 563 "./src/pmc/pmcproxy.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)ret_parents);
        
        return;
     }
#line 453 "./src/pmc/pmcproxy.pmc"

#line 571 "./src/pmc/pmcproxy.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PMCProxy_nci_inspect(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* what;
    INTVAL got_what;
    
    const INTVAL arity = 1; /* "PiSoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        what = VTABLE_get_string_keyed_int(interp, _call_object, 1);
        got_what = 1;
    }
    else {
        what = STRINGNULL;
        got_what = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 467 "./src/pmc/pmcproxy.pmc"

    /* Just delegate to the appropriate vtable. */
    PMC * const found =
        got_what
            ? VTABLE_inspect_str(interp, _self, what)
            : VTABLE_inspect(interp, _self);

    #line 622 "./src/pmc/pmcproxy.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)found);
        
        return;
     }
#line 474 "./src/pmc/pmcproxy.pmc"

#line 630 "./src/pmc/pmcproxy.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_PMCProxy_update_vtable(VTABLE *vt) {
    vt->does = Parrot_PMCProxy_does;
    vt->get_string = Parrot_PMCProxy_get_string;
    vt->init = Parrot_PMCProxy_init;
    vt->init_int = Parrot_PMCProxy_init_int;
    vt->init_pmc = Parrot_PMCProxy_init_pmc;
    vt->inspect = Parrot_PMCProxy_inspect;
    vt->instantiate = Parrot_PMCProxy_instantiate;
    vt->isa = Parrot_PMCProxy_isa;
    vt->isa_pmc = Parrot_PMCProxy_isa_pmc;
    vt->type = Parrot_PMCProxy_type;
    vt->attr_size = sizeof(Parrot_PMCProxy_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_PMCProxy_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->does = Parrot_PMCProxy_does;
    vt->get_string = Parrot_PMCProxy_get_string;
    vt->inspect = Parrot_PMCProxy_inspect;
    vt->instantiate = Parrot_PMCProxy_instantiate;
    vt->isa = Parrot_PMCProxy_isa;
    vt->isa_pmc = Parrot_PMCProxy_isa_pmc;
    vt->type = Parrot_PMCProxy_type;
    vt->attr_size = sizeof(Parrot_PMCProxy_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_PMCProxy_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Class_get_vtable(interp);
    Parrot_PMCProxy_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_PMCProxy_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Class_ro_get_vtable(interp);
    Parrot_PMCProxy_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_PMCProxy_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Class_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "PMCProxy"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_PMCProxy_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_Class_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "PMCProxy")), PMCNULL);
    return isa;
}

void
Parrot_PMCProxy_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iid Sname Sfullname F_namespace Iinstantiated Fparents Fall_parents Froles Fmethods Fvtable_overrides Fattrib_metadata Fattrib_index Fattrib_cache Fresolve_method Fparent_overrides Fmeth_cache :isa_cache ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_PMCProxy_get_vtable(interp);
        vt->base_type      = enum_class_PMCProxy;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "PMCProxy");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_PMCProxy_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_PMCProxy_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_PMCProxy;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_PMCProxy_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "name");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PMCProxy_nci_name),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_namespace");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PMCProxy_nci_get_namespace),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "new");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PMCProxy_nci_new),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "methods");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PMCProxy_nci_methods),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "parents");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PMCProxy_nci_parents),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "inspect");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PMCProxy_nci_inspect),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_PMCProxy_class_init */

#line 476 "./src/pmc/pmcproxy.pmc"
 /* END pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_pmc.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
