/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/ptr.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_ptr.h"
#include "pmc_default.h"
#include "ptr.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/ptr.pmc"
/*
Copyright (C) 2011-2014, Parrot Foundation.

=head1 NAME

src/pmc/ptr.pmc - Ptr PMC

=head1 DESCRIPTION

C<Ptr> is a bare bones PMC for representing the base type for pointers. It is
intended that additional functionality be added via subclassing. Any
functionality added to this PMC not critical to its operation as a pointer
representation is deprecated in advance and subject to removal without notice.

=head2 Fat versus Thin

C<Ptr> can be implemented with two separate representations - C<fat>, which
makes use of the conventional PMC attributes structure and C<thin> which is
more efficient and stores the pointer directly, avoiding memory allocation and
pointer dereference costs at the expense of extensibility.

The distinction is managed via a set of macros - C<PTR_FAT_TEST>,
C<PTR_FAT_SET>, and C<PTR_FAT_CLEAR>. Internally, these use the
C<private1> flag, and this flag is therefore unavailable for subclass use.

=cut

*/

#include "parrot/string_funcs.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */

/*

=head2 Vtable Functions

=over 4

=cut

*/
#line 68 "./src/pmc/ptr.c"
static  void  Parrot_Ptr_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Ptr_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Ptr_get_integer(SHIM_INTERP, SHIM(PMC *_self));
static  void  * Parrot_Ptr_get_pointer(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Ptr_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Ptr_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL i);
static  void  Parrot_Ptr_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *p);
static  void  Parrot_Ptr_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr);
static  void Parrot_Ptr_nci_as_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void 
Parrot_Ptr_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 145 "./src/pmc/ptr.pmc"

    if (PTR_FAT_TEST(interp, _self) && PMC_data(_self))
        mem_gc_free(interp, PMC_data(_self));
#line 85 "./src/pmc/ptr.c"
}
static  INTVAL 
Parrot_Ptr_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 131 "./src/pmc/ptr.pmc"

    return Parrot_Ptr_get_pointer(interp, _self) != NULL;
#line 93 "./src/pmc/ptr.c"
}
static  INTVAL 
Parrot_Ptr_get_integer(SHIM_INTERP, SHIM(PMC *_self))
{
#line 162 "./src/pmc/ptr.pmc"
    return 0;
#line 100 "./src/pmc/ptr.c"
}
static  void  *
Parrot_Ptr_get_pointer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 103 "./src/pmc/ptr.pmc"

    void *ptr;
    if (PTR_FAT_TEST(interp, _self))
        GETATTR_Ptr_ptr(interp, _self, ptr);
    else
        ptr = PMC_data(_self);
    /* We are returning raw pointer. Someone can write into it */
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return ptr;
#line 115 "./src/pmc/ptr.c"
}
static  void 
Parrot_Ptr_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 71 "./src/pmc/ptr.pmc"

    if (PTR_FAT_TEST(interp, _self) && !PMC_data(_self)) {
        PMC_data(_self) = (void *)mem_gc_allocate_zeroed_typed(interp, Parrot_Ptr_attributes);
        PObj_custom_destroy_SET(_self);
        PARROT_GC_WRITE_BARRIER(interp, _self);
    }
#line 127 "./src/pmc/ptr.c"
}
static  void 
Parrot_Ptr_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL i)
{
#line 79 "./src/pmc/ptr.pmc"

    void *ptr = (void *)i;
    VTABLE_init(interp, _self);
    Parrot_Ptr_set_pointer(interp, _self, ptr);
#line 137 "./src/pmc/ptr.c"
}
static  void 
Parrot_Ptr_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *p)
{
#line 85 "./src/pmc/ptr.pmc"

    void *ptr = VTABLE_get_pointer(interp, p);
    VTABLE_init(interp, _self);
    Parrot_Ptr_set_pointer(interp, _self, ptr);
#line 147 "./src/pmc/ptr.c"
}
static  void 
Parrot_Ptr_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr)
{
#line 114 "./src/pmc/ptr.pmc"

    if (PTR_FAT_TEST(interp, _self))
        SETATTR_Ptr_ptr(interp, _self, ptr);
    else
        PMC_data(_self) = ptr;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 159 "./src/pmc/ptr.c"
}
static  void
Parrot_Ptr_nci_as_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* encodingname;
    
    const INTVAL arity = 1; /* "PiSo" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        encodingname = VTABLE_get_string_keyed_int(interp, _call_object, 1);
    }
    else {
        encodingname = STRINGNULL;
    }

    { /* BEGIN PMETHOD BODY */
#line 185 "./src/pmc/ptr.pmc"

    const char * content = (const char *)_self->vtable->get_pointer(interp, _self);
    STRING *result = Parrot_str_new_from_cstring(interp, content, encodingname);
    #line 196 "./src/pmc/ptr.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)result);
        
        return;
     }
#line 188 "./src/pmc/ptr.pmc"

#line 204 "./src/pmc/ptr.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Ptr_update_vtable(VTABLE *vt) {
    vt->destroy = Parrot_Ptr_destroy;
    vt->get_bool = Parrot_Ptr_get_bool;
    vt->get_integer = Parrot_Ptr_get_integer;
    vt->get_pointer = Parrot_Ptr_get_pointer;
    vt->init = Parrot_Ptr_init;
    vt->init_int = Parrot_Ptr_init_int;
    vt->init_pmc = Parrot_Ptr_init_pmc;
    vt->set_pointer = Parrot_Ptr_set_pointer;
    vt->attr_size = 0;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Ptr_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->destroy = Parrot_Ptr_destroy;
    vt->get_bool = Parrot_Ptr_get_bool;
    vt->get_integer = Parrot_Ptr_get_integer;
    vt->get_pointer = Parrot_Ptr_get_pointer;
    vt->attr_size = 0;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Ptr_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Ptr_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Ptr_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Ptr_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Ptr_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Ptr"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Ptr_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Ptr")), PMCNULL);
    return isa;
}

void
Parrot_Ptr_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":ptr ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Ptr_get_vtable(interp);
        vt->base_type      = enum_class_Ptr;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Ptr");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_Ptr_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_Ptr_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_Ptr;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Ptr_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "as_string");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Ptr_nci_as_string),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_Ptr_class_init */

#line 190 "./src/pmc/ptr.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
