/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablebooleanarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablebooleanarray.h"
#include "pmc_fixedbooleanarray.h"
#include "pmc_default.h"
#include "resizablebooleanarray.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/resizablebooleanarray.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/resizablebooleanarray.pmc - ResizableBooleanArray PMC

=head1 DESCRIPTION

The C<ResizableBooleanArray PMC> implements an array of resizable size, which
stores booleans.  It uses the C<Boolean PMC> for all conversions.  The
C<ResizableBooleanArray PMC> extends the C<FixedBooleanArray PMC>.

=head2 Functions

=over 4

=cut

*/

#define BITS_PER_CHAR 8
/* MIN_ALLOC is 8 * BITS_PER_CHAR */
#define MIN_ALLOC 64

/* Round a given size in bits to the nearest allocation unit, then convert it
 * to bytes. */
#define ROUND_BYTES(size) (((size) / MIN_ALLOC + 1) * MIN_ALLOC / BITS_PER_CHAR)
/* Convert a size in bits to a size in bytes */
#define BITS_TO_BYTES(size) ((size) / BITS_PER_CHAR)

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 58 "./src/pmc/resizablebooleanarray.c"
static  PMC  * Parrot_ResizableBooleanArray_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ResizableBooleanArray_elements(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizableBooleanArray_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  INTVAL  Parrot_ResizableBooleanArray_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ResizableBooleanArray_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  INTVAL  Parrot_ResizableBooleanArray_pop_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizableBooleanArray_push_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_ResizableBooleanArray_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value);
static  void  Parrot_ResizableBooleanArray_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size);
static  INTVAL  Parrot_ResizableBooleanArray_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizableBooleanArray_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  void  Parrot_ResizableBooleanArray_unshift_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  PMC  *
Parrot_ResizableBooleanArray_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 377 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL         tail_pos, head_pos;
    unsigned char * my_bit_array, * dest_bit_array;

    PMC * const     dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    GETATTR_ResizableBooleanArray_bit_array(interp, _self, my_bit_array);
    GETATTR_ResizableBooleanArray_size(interp, _self, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);

    SETATTR_ResizableBooleanArray_size(interp, dest, tail_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, dest, head_pos);

    if (my_bit_array) {
        const size_t size_in_bits = tail_pos / BITS_PER_CHAR + 1;
        dest_bit_array = (unsigned char *)Parrot_gc_allocate_memory_chunk(interp, size_in_bits);
        memcpy(dest_bit_array, my_bit_array, size_in_bits);
    }
    else
        dest_bit_array = NULL;

    SETATTR_ResizableBooleanArray_bit_array(interp, dest, dest_bit_array);

    PObj_custom_destroy_SET(dest);
    return dest;
#line 100 "./src/pmc/resizablebooleanarray.c"
}
static  INTVAL 
Parrot_ResizableBooleanArray_elements(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 346 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL tail_pos, head_pos;
    GETATTR_ResizableBooleanArray_size(interp, _self, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);
    return tail_pos - head_pos;
#line 111 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
#line 419 "./src/pmc/resizablebooleanarray.pmc"

    /* XXX Dino - I'm concerned about freezing the entire
        allocated block of memory, it's dependent on the
        BITS_PER_CHAR value.
        Maybe we need to store that during the freeze as well
        and use it during thaw?
    */

    STRING           *s;
    UINTVAL           tail_pos, rounded_size, head_pos;
    unsigned char    *bit_array;

    GETATTR_ResizableBooleanArray_size(interp, _self, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);
    GETATTR_ResizableBooleanArray_bit_array(interp, _self, bit_array);
    rounded_size = ROUND_BYTES(tail_pos);

    VTABLE_push_integer(interp, info, head_pos);
    VTABLE_push_integer(interp, info, tail_pos);

    s = Parrot_str_new(interp, (char*)bit_array, rounded_size);

    VTABLE_push_string(interp, info, s);
#line 140 "./src/pmc/resizablebooleanarray.c"
}
static  INTVAL 
Parrot_ResizableBooleanArray_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 363 "./src/pmc/resizablebooleanarray.pmc"

    return VTABLE_elements(interp, _self);
#line 148 "./src/pmc/resizablebooleanarray.c"
}
static  INTVAL 
Parrot_ResizableBooleanArray_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 58 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL offsetkey, tail_pos, head_pos;
    GETATTR_ResizableBooleanArray_size(interp, _self, tail_pos);

    /* Try to make negative index into a real index */
    if (key < 0) {
        key += tail_pos;
        /* If it's still negative, we have a problem */
        if (key < 0)
            Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                    "index out of bounds");
    }

    /* Check if key is greater than allocated size */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);
    offsetkey = key + head_pos;

    if (offsetkey >= tail_pos)
        return 0;

    return interp->vtables[enum_class_FixedBooleanArray]->get_integer_keyed_int(interp, _self, offsetkey);
#line 175 "./src/pmc/resizablebooleanarray.c"
}
static  INTVAL 
Parrot_ResizableBooleanArray_pop_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 207 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL new_size, tail_pos, head_pos;
    INTVAL  value;
    GETATTR_ResizableBooleanArray_size(interp, _self, tail_pos);

    if (tail_pos < 1)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "Can't pop from an empty array");

    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);

    new_size  = tail_pos - head_pos;
    value = VTABLE_get_integer_keyed_int(interp, _self, new_size - 1);
    VTABLE_set_integer_native(interp, _self, new_size - 1);

    return value;
#line 197 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_push_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 185 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL tail_pos, head_pos;
    INTVAL  new_size;

    GETATTR_ResizableBooleanArray_size(interp, _self, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);

    new_size = tail_pos - head_pos;
    VTABLE_set_integer_native(interp, _self, new_size + 1);
    VTABLE_set_integer_keyed_int(interp, _self, new_size, value);
#line 213 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value)
{
#line 91 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL offsetkey, tail_pos, head_pos;
    GETATTR_ResizableBooleanArray_size(interp, _self, tail_pos);

    /* Try to make negative index into a real index */
    if (key < 0) {
        key += tail_pos;
        /* If it's still negative, we have a problem */
        if (key < 0)
            Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                    "index out of bounds");
    }

    /* Check if key is greater than allocated size */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);
    offsetkey = key + head_pos;

    if (offsetkey >= tail_pos)
        VTABLE_set_integer_native(interp, _self, key+1);

    interp->vtables[enum_class_FixedBooleanArray]->set_integer_keyed_int(interp, _self, offsetkey, value);
#line 240 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size)
{
#line 124 "./src/pmc/resizablebooleanarray.pmc"


    unsigned char * bit_array;
    size_t          old_tail_pos, new_tail_pos, new_size_in_bytes, old_size_in_bytes;

    /* Size respects any existing head position offset from unshift */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, new_tail_pos);
    GETATTR_ResizableBooleanArray_size(interp, _self, old_tail_pos);
    new_tail_pos += size;

    /* We are already at the requested size. Yay */
    if (new_tail_pos == old_tail_pos)
        return;

    if (size < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "illegal argument");

    /* now set the new size, in bits */
    SETATTR_ResizableBooleanArray_size(interp, _self, new_tail_pos);

    /* convert sizes to bytes */
    new_size_in_bytes = ROUND_BYTES(new_tail_pos);
    old_size_in_bytes = ROUND_BYTES(old_tail_pos);

    /* Nothing allocated yet */
    GETATTR_ResizableBooleanArray_bit_array(interp, _self, bit_array);
    if (!bit_array) {
        void * const new_bit_array = Parrot_gc_allocate_memory_chunk(interp, new_size_in_bytes);
        memset(new_bit_array, 0, new_size_in_bytes);
        SETATTR_ResizableBooleanArray_bit_array(interp, _self, (unsigned char *)new_bit_array);

    /* The size is different, and doesn't fit within the current
     * allocation */
    }
    else if (new_size_in_bytes != old_size_in_bytes) {
        unsigned char * old_store = bit_array;
        unsigned char * new_store =
            (unsigned char *)Parrot_gc_allocate_memory_chunk(interp, new_tail_pos);
        size_t          copy_size =
            new_size_in_bytes < old_size_in_bytes ? new_size_in_bytes : old_size_in_bytes;
        memset(new_store, 0, new_tail_pos);

        /* Replace old array with new array, and free old array */
        SETATTR_ResizableBooleanArray_bit_array(interp, _self,
                (unsigned char *)memmove(
                    new_store, old_store, copy_size));
        mem_gc_free(interp, old_store);
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 296 "./src/pmc/resizablebooleanarray.c"
}
static  INTVAL 
Parrot_ResizableBooleanArray_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 292 "./src/pmc/resizablebooleanarray.pmc"

    INTVAL value;
    UINTVAL tail_pos, head_pos;
    GETATTR_ResizableBooleanArray_size(interp, _self, tail_pos);

    if (tail_pos < 1)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "Can't shift from an empty array");

    /* Get head value */
    value = VTABLE_get_integer_keyed_int(interp, _self, 0);

    /* Move the head position */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self,   head_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, _self, ++head_pos);

    /* If the head position offset is greater than our allocation unit
     * size, size this thing down */
    if (head_pos >= MIN_ALLOC) {
        /* Allocate one allocation unit less of space in new array */
        unsigned char *new_bit_array, *old_bit_array;
        size_t         new_mem_size;
        new_mem_size  = ROUND_BYTES(tail_pos - MIN_ALLOC);
        new_bit_array =
            (unsigned char *)Parrot_gc_allocate_memory_chunk(interp, new_mem_size);
        memset(new_bit_array, 0, new_mem_size);

        /* Copy contents of old array to new array, move the head position
         * offset back by one allocation unit (in bytes) */
        GETATTR_ResizableBooleanArray_bit_array(interp, _self, old_bit_array);
        memmove(new_bit_array, old_bit_array + (BITS_TO_BYTES(MIN_ALLOC)),
            new_mem_size);

        /* Replace old array with new array, and free old array */
        SETATTR_ResizableBooleanArray_bit_array(interp, _self, new_bit_array);
        mem_gc_free(interp, old_bit_array);

        /* Removed one allocation unit from the head position offset */
        SETATTR_ResizableBooleanArray_size(interp, _self, tail_pos - MIN_ALLOC);
        GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);
        SETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos- MIN_ALLOC);
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);

    return value;
#line 347 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
#line 453 "./src/pmc/resizablebooleanarray.pmc"

    const UINTVAL   head_pos      = VTABLE_shift_integer(interp, info);
    const UINTVAL   tail_pos      = VTABLE_shift_integer(interp, info);
    STRING * const  s             = VTABLE_shift_string(interp, info);
    const size_t    size_in_bytes = ROUND_BYTES(tail_pos);
    unsigned char  *bit_array;

    VTABLE_set_integer_native(interp, _self, tail_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);

    if (s->bufused < size_in_bytes)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_BAD_BUFFER_SIZE,
            "ResizableBooleanArray: invalid buffer size during thaw");

    GETATTR_ResizableBooleanArray_bit_array(interp, _self, bit_array);
    memcpy(bit_array, s->strstart, size_in_bytes);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 370 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_unshift_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 236 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL head_pos;
    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);

    /* If the current head position offset is 0, size this thing up by one
     * allocation unit */
    if (head_pos <= 0) {

        UINTVAL         tail_pos;
        unsigned char * old_bit_array;
        size_t          old_mem_size, new_mem_size;
        unsigned char * new_bit_array;

        GETATTR_ResizableBooleanArray_size(interp, _self, tail_pos);
        GETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos);
        GETATTR_ResizableBooleanArray_bit_array(interp, _self, old_bit_array);

        /* Allocate an extra allocation unit of space in new array */
        new_mem_size  = ROUND_BYTES(tail_pos+ MIN_ALLOC);
        new_bit_array = (unsigned char *)Parrot_gc_allocate_memory_chunk(interp, new_mem_size);
        memset(new_bit_array, 0, new_mem_size);

        /* Copy contents of old array to new array, moving the head
         * position forward by one allocation unit (in bytes). */
        old_mem_size = ROUND_BYTES(tail_pos);
        memmove(new_bit_array + (BITS_TO_BYTES(MIN_ALLOC)),
                old_bit_array, old_mem_size);

        /* Replace old array with new array, and free old array */
        SETATTR_ResizableBooleanArray_bit_array(interp, _self, new_bit_array);
        mem_gc_free(interp, old_bit_array);

        /* Added one allocation unit to the head position offset */
        SETATTR_ResizableBooleanArray_size(interp, _self, tail_pos + MIN_ALLOC);
        SETATTR_ResizableBooleanArray_resize_threshold(interp, _self, head_pos + MIN_ALLOC);

    }

    /* Move the head position */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, _self,   head_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, _self, --head_pos);

    /* Assign the new value as the first item */
    VTABLE_set_integer_keyed_int(interp, _self, 0, value);
#line 420 "./src/pmc/resizablebooleanarray.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ResizableBooleanArray_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ResizableBooleanArray_clone;
    vt->elements = Parrot_ResizableBooleanArray_elements;
    vt->freeze = Parrot_ResizableBooleanArray_freeze;
    vt->get_integer = Parrot_ResizableBooleanArray_get_integer;
    vt->get_integer_keyed_int = Parrot_ResizableBooleanArray_get_integer_keyed_int;
    vt->pop_integer = Parrot_ResizableBooleanArray_pop_integer;
    vt->push_integer = Parrot_ResizableBooleanArray_push_integer;
    vt->set_integer_keyed_int = Parrot_ResizableBooleanArray_set_integer_keyed_int;
    vt->set_integer_native = Parrot_ResizableBooleanArray_set_integer_native;
    vt->shift_integer = Parrot_ResizableBooleanArray_shift_integer;
    vt->thaw = Parrot_ResizableBooleanArray_thaw;
    vt->unshift_integer = Parrot_ResizableBooleanArray_unshift_integer;
    vt->attr_size = sizeof(Parrot_ResizableBooleanArray_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ResizableBooleanArray_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ResizableBooleanArray_clone;
    vt->elements = Parrot_ResizableBooleanArray_elements;
    vt->freeze = Parrot_ResizableBooleanArray_freeze;
    vt->get_integer = Parrot_ResizableBooleanArray_get_integer;
    vt->get_integer_keyed_int = Parrot_ResizableBooleanArray_get_integer_keyed_int;
    vt->attr_size = sizeof(Parrot_ResizableBooleanArray_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableBooleanArray_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedBooleanArray_get_vtable(interp);
    Parrot_ResizableBooleanArray_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableBooleanArray_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedBooleanArray_ro_get_vtable(interp);
    Parrot_ResizableBooleanArray_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ResizableBooleanArray_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_FixedBooleanArray_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "ResizableBooleanArray"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ResizableBooleanArray_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_FixedBooleanArray_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ResizableBooleanArray")), PMCNULL);
    return isa;
}

void
Parrot_ResizableBooleanArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":size :resize_threshold :bit_array ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ResizableBooleanArray_get_vtable(interp);
        vt->base_type      = enum_class_ResizableBooleanArray;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ResizableBooleanArray");
        vt->provides_str = CONST_STRING_GEN(interp, "array");
        vt->isa_hash     = Parrot_ResizableBooleanArray_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_ResizableBooleanArray_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_ResizableBooleanArray;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ResizableBooleanArray_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ResizableBooleanArray_class_init */

#line 470 "./src/pmc/resizablebooleanarray.pmc"
  /* pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
