/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizableintegerarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizableintegerarray.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_default.h"
#include "resizableintegerarray.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/resizableintegerarray.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/resizableintegerarray.pmc - ResizableIntegerArray PMC

=head1 DESCRIPTION

This class, ResizableIntegerArray, implements an array of resizable
size, which stores INTVALs.  It uses Integer PMCs for all of the
conversions.

=head2 Functions

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 48 "./src/pmc/resizableintegerarray.c"
static  PMC  * Parrot_ResizableIntegerArray_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizableIntegerArray_delete_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  INTVAL  Parrot_ResizableIntegerArray_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  void  Parrot_ResizableIntegerArray_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size);
static  INTVAL  Parrot_ResizableIntegerArray_pop_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizableIntegerArray_push_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_ResizableIntegerArray_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value);
static  void  Parrot_ResizableIntegerArray_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size);
static  INTVAL  Parrot_ResizableIntegerArray_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizableIntegerArray_unshift_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  PMC  *
Parrot_ResizableIntegerArray_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 296 "./src/pmc/resizableintegerarray.pmc"

    INTVAL  size;
    PMC * const copy = interp->vtables[enum_class_FixedIntegerArray]->clone(interp, _self);

    /* copy trimmed extra space */
    GETATTR_ResizableIntegerArray_size(interp, _self, size);
    SETATTR_ResizableIntegerArray_resize_threshold(interp, copy, size);

    return copy;
#line 72 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_delete_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 271 "./src/pmc/resizableintegerarray.pmc"

    INTVAL *int_array;
    INTVAL size;
    GETATTR_ResizableIntegerArray_size(interp, _self, size);

    if (size < 1 || key >= size)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "index out of bounds");

    GETATTR_ResizableIntegerArray_int_array(interp, _self, int_array);
    --size;
    memmove(int_array + key, int_array + key + 1, (size - key) * sizeof (INTVAL));
    VTABLE_set_integer_native(interp, _self, size);
#line 91 "./src/pmc/resizableintegerarray.c"
}
static  INTVAL 
Parrot_ResizableIntegerArray_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 57 "./src/pmc/resizableintegerarray.pmc"

    INTVAL *int_array;
    INTVAL  size;
    GETATTR_ResizableIntegerArray_size(interp, _self, size);

    if (key < 0)
        key += size;
    if (key < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "index out of bounds");

    if (key >= size)
        return 0;

    GETATTR_ResizableIntegerArray_int_array(interp, _self, int_array);
    return int_array[key];
#line 113 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size)
{
#line 39 "./src/pmc/resizableintegerarray.pmc"

    interp->vtables[enum_class_FixedIntegerArray]->init_int(interp, _self, size);
    if (size > 0) {
        SETATTR_ResizableIntegerArray_resize_threshold(interp, _self, size);
        PARROT_GC_WRITE_BARRIER(interp, _self);
    }
#line 125 "./src/pmc/resizableintegerarray.c"
}
static  INTVAL 
Parrot_ResizableIntegerArray_pop_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 199 "./src/pmc/resizableintegerarray.pmc"

    INTVAL value;
    INTVAL    size;
    GETATTR_ResizableIntegerArray_size(interp, _self, size);

    if (size == 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "Can't pop from an empty array");

    value = VTABLE_get_integer_keyed_int(interp, _self, size-1);
    VTABLE_set_integer_native(interp, _self, size - 1);
    return value;
#line 143 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_push_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 170 "./src/pmc/resizableintegerarray.pmc"

    INTVAL *int_array;
    INTVAL  nextix;
    INTVAL  resize_threshold;

    GETATTR_ResizableIntegerArray_size(interp, _self, nextix);
    GETATTR_ResizableIntegerArray_resize_threshold(interp, _self, resize_threshold);

    /* can't always avoid the resize, but don't duplicate the code */
    if ((nextix && (nextix >= resize_threshold)) || !nextix)
        VTABLE_set_integer_native(interp, _self, nextix + 1);
    else
        SETATTR_ResizableIntegerArray_size(interp, _self, nextix + 1);

    /* fetch the array only after resize check; realloc may move it */
    GETATTR_ResizableIntegerArray_int_array(interp, _self, int_array);
    int_array[nextix] = value;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 167 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value)
{
#line 85 "./src/pmc/resizableintegerarray.pmc"

    INTVAL *int_array;
    INTVAL    size;
    GETATTR_ResizableIntegerArray_size(interp, _self, size);

    if (key < 0)
        key += size;
    if (key < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "index out of bounds");

    if (key >= VTABLE_get_integer(interp, _self))
        VTABLE_set_integer_native(interp, _self, key + 1);

    GETATTR_ResizableIntegerArray_int_array(interp, _self, int_array);
    int_array[key] = value;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 190 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size)
{
#line 113 "./src/pmc/resizableintegerarray.pmc"

    INTVAL *int_array;
    INTVAL  resize_threshold;

    if (size < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "illegal argument");

    GETATTR_ResizableIntegerArray_int_array(interp, _self, int_array);
    GETATTR_ResizableIntegerArray_resize_threshold(interp, _self, resize_threshold);
    if (!int_array) {
        /* empty - used fixed routine */
        if (size < 8) {
            interp->vtables[enum_class_FixedIntegerArray]->set_integer_native(interp, _self, 8);
            SETATTR_ResizableIntegerArray_size(interp, _self, size);
            SETATTR_ResizableIntegerArray_resize_threshold(interp, _self, 8);
        }
        else {
            interp->vtables[enum_class_FixedIntegerArray]->set_integer_native(interp, _self, size);
            SETATTR_ResizableIntegerArray_resize_threshold(interp, _self, size);
        }
    }
    else if (size <= resize_threshold) {
        /* we could shrink here if necessary */
        SETATTR_ResizableIntegerArray_size(interp, _self, size);
    }
    else {
        INTVAL  cur = resize_threshold;
        INTVAL *i_array;

        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            const INTVAL needed = size - cur;
            cur          += needed + 4096;
            cur          &= ~0xfff;
        }

        GETATTR_ResizableIntegerArray_int_array(interp, _self, i_array);
        i_array = mem_gc_realloc_n_typed(interp, i_array, cur, INTVAL);
        SETATTR_ResizableIntegerArray_int_array(interp, _self, i_array);
        SETATTR_ResizableIntegerArray_size(interp, _self, size);
        SETATTR_ResizableIntegerArray_resize_threshold(interp, _self, cur);
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 241 "./src/pmc/resizableintegerarray.c"
}
static  INTVAL 
Parrot_ResizableIntegerArray_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 222 "./src/pmc/resizableintegerarray.pmc"

    INTVAL value, *int_array;
    INTVAL    size;
    GETATTR_ResizableIntegerArray_size(interp, _self, size);

    if (size == 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "Can't shift from an empty array");

    GETATTR_ResizableIntegerArray_int_array(interp, _self, int_array);
    value = int_array[0];

    --size;
    memmove(int_array, int_array + 1, size * sizeof (INTVAL));
    VTABLE_set_integer_native(interp, _self, size);
    return value;
#line 263 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_unshift_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 250 "./src/pmc/resizableintegerarray.pmc"

    INTVAL *int_array;
    INTVAL size;
    GETATTR_ResizableIntegerArray_size(interp, _self, size);

    VTABLE_set_integer_native(interp, _self, size + 1);
    GETATTR_ResizableIntegerArray_int_array(interp, _self, int_array);
    memmove(int_array + 1, int_array, size * sizeof (INTVAL));
    int_array[0] = value;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 279 "./src/pmc/resizableintegerarray.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ResizableIntegerArray_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ResizableIntegerArray_clone;
    vt->delete_keyed_int = Parrot_ResizableIntegerArray_delete_keyed_int;
    vt->get_integer_keyed_int = Parrot_ResizableIntegerArray_get_integer_keyed_int;
    vt->init_int = Parrot_ResizableIntegerArray_init_int;
    vt->pop_integer = Parrot_ResizableIntegerArray_pop_integer;
    vt->push_integer = Parrot_ResizableIntegerArray_push_integer;
    vt->set_integer_keyed_int = Parrot_ResizableIntegerArray_set_integer_keyed_int;
    vt->set_integer_native = Parrot_ResizableIntegerArray_set_integer_native;
    vt->shift_integer = Parrot_ResizableIntegerArray_shift_integer;
    vt->unshift_integer = Parrot_ResizableIntegerArray_unshift_integer;
    vt->attr_size = sizeof(Parrot_ResizableIntegerArray_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ResizableIntegerArray_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ResizableIntegerArray_clone;
    vt->get_integer_keyed_int = Parrot_ResizableIntegerArray_get_integer_keyed_int;
    vt->attr_size = sizeof(Parrot_ResizableIntegerArray_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableIntegerArray_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedIntegerArray_get_vtable(interp);
    Parrot_ResizableIntegerArray_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableIntegerArray_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedIntegerArray_ro_get_vtable(interp);
    Parrot_ResizableIntegerArray_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ResizableIntegerArray_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_FixedIntegerArray_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "ResizableIntegerArray"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ResizableIntegerArray_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_FixedIntegerArray_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ResizableIntegerArray")), PMCNULL);
    return isa;
}

void
Parrot_ResizableIntegerArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Isize :int_array Iresize_threshold ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ResizableIntegerArray_get_vtable(interp);
        vt->base_type      = enum_class_ResizableIntegerArray;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ResizableIntegerArray");
        vt->provides_str = CONST_STRING_GEN(interp, "array");
        vt->isa_hash     = Parrot_ResizableIntegerArray_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_ResizableIntegerArray_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_ResizableIntegerArray;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ResizableIntegerArray_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ResizableIntegerArray_class_init */

#line 306 "./src/pmc/resizableintegerarray.pmc"

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
