/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablepmcarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_resizablepmcarray.h"
#include "pmc_fixedpmcarray.h"
#include "pmc_default.h"
#include "resizablepmcarray.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/resizablepmcarray.pmc"
/*
Copyright (C) 2001-2015, Parrot Foundation.

=head1 NAME

src/pmc/resizablepmcarray.pmc - ResizablePMCArray PMC

=head1 DESCRIPTION

This class, ResizablePMCArray, implements an resizable array which stores
PMCs.  It changes values into Integer, Float, or String PMCs as appropriate.

Resize thresholds steps are 8 and 4096.
Between 8b and 4K resize it overallocates by factor 1.5, over 4K it aligns up to
the next 4K block.

We use now the faster nqp/qrpa model with O(1) shift/unshift
ops, by moving an extra offset index, with 8 slots reserve. See #1152

=head2 Internal Functions

=over 4

=cut

*/

#define PMC_size(x)      ((Parrot_ResizablePMCArray_attributes *)PMC_data(x))->size
#define PMC_array(x)     ((Parrot_ResizablePMCArray_attributes *)PMC_data(x))->pmc_array
#define PMC_offset(x)    ((Parrot_ResizablePMCArray_attributes *)PMC_data(x))->offset
#define PMC_threshold(x) ((Parrot_ResizablePMCArray_attributes *)PMC_data(x))->threshold

#ifdef NDEBUG
#  define TRACE_RPA(s)
#  define TRACE_RPAn(s)
#  define TRACE_RPAsize(s)
#  define TRACE_RPAself(s, self)
#  define TRACE_RPAdata(s, data)
#  define TRACE_PMC(i, pmc)
#  define TRACE_SPLC
#else
#  include "parrot/runcore_trace.h"
#  define TRACE_RPA(s)                                  \
    if (Interp_trace_TEST(interp, PARROT_TRACE_ARRAY_STATE_FLAG)) \
        fprintf(stderr, "# rpa %-12s: (%ld,%ld,%ld) ",  \
                (s), offset, size, threshold);
#  define TRACE_RPAn(s)                                             \
    if (Interp_trace_TEST(interp, PARROT_TRACE_ARRAY_STATE_FLAG))   \
        fprintf(stderr, "# rpa %-12s: (%ld,%ld,%ld)\n",             \
                (s), offset, size, threshold);
#  define TRACE_RPAsize(s)                                          \
    if (Interp_trace_TEST(interp, PARROT_TRACE_ARRAY_STATE_FLAG))   \
        fprintf(stderr, "# rpa %-12s: (%ld,%ld,%ld) -> size=%ld\n", \
                (s), offset, size, threshold, n);
#  define TRACE_RPAself(s, self)                                    \
    if (Interp_trace_TEST(interp, PARROT_TRACE_ARRAY_STATE_FLAG))   \
        fprintf(stderr, "# rpa %-12s: (%ld,%ld,%ld) ",              \
                (s), PMC_offset(self), PMC_size(self), PMC_threshold(self));
#  define TRACE_RPAdata(s, data)                                  \
    if (Interp_trace_TEST(interp, PARROT_TRACE_ARRAY_STATE_FLAG)) \
        fprintf(stderr, "# rpa %-12s: (%ld,%ld,%ld) ",            \
                (s), (data)->offset, (data)->size, (data)->threshold);
#  define TRACE_PMC(i, pmc)                 \
    if (Interp_trace_TEST(interp, PARROT_TRACE_ARRAY_STATE_FLAG)) {  \
        fprintf(stderr, " rpa[%ld]=", (i)); \
        trace_pmc_dump(interp, (pmc));      \
        fprintf(stderr, "\n");              \
    }
#  define TRACE_SPLC                        \
    if (Interp_trace_TEST(interp, PARROT_TRACE_ARRAY_STATE_FLAG)) \
        fprintf(stderr, " off=%ld, count=%ld, elems1=%ld, tail=%ld, sizediff=%ld\n", \
                off, count, elems1, tail, sizediff)
#endif


/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_INLINE
static void do_shift(PARROT_INTERP,
    ARGIN(Parrot_ResizablePMCArray_attributes *data))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_INLINE
static void do_unshift(PARROT_INTERP, ARGIN(PMC *arr), ARGIN(PMC *val))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

PARROT_DOES_NOT_RETURN
PARROT_INLINE
static void throw_pop_empty(PARROT_INTERP)
        __attribute__nonnull__(1);

PARROT_DOES_NOT_RETURN
PARROT_INLINE
static void throw_shift_empty(PARROT_INTERP)
        __attribute__nonnull__(1);

#define ASSERT_ARGS_do_shift __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(data))
#define ASSERT_ARGS_do_unshift __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(arr) \
    , PARROT_ASSERT_ARG(val))
#define ASSERT_ARGS_throw_pop_empty __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_throw_shift_empty __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static void do_shift(PARROT_INTERP, Parrot_ResizablePMCArray_attributes
*data)>

Removes and returns an item from the start of the array.

=cut

*/
PARROT_INLINE
static void
do_shift(PARROT_INTERP, ARGIN(Parrot_ResizablePMCArray_attributes *data))
{
    ASSERT_ARGS(do_shift)

    data->size--;
    PARROT_ASSERT(data->size + data->offset <= data->threshold);
    data->offset++;
    TRACE_RPAdata("shift fast", data);
    TRACE_PMC(data->offset-1, data->pmc_array[data->offset-1]); /* XXX GC problem */
#ifdef DEBUG_FILL_SLACK
    data->pmc_array[data->offset] = PMCNULL;
#endif
}

/*

=item C<static void do_unshift(PARROT_INTERP, PMC *arr, PMC *val)>

Adds an item at the start of the array.
If offset == 0 moves the whole rest of the array around.

=cut

*/
PARROT_INLINE
static void
do_unshift(PARROT_INTERP, ARGIN(PMC *arr), ARGIN(PMC *val))
{
    ASSERT_ARGS(do_unshift)

#ifndef NDEBUG
    const INTVAL threshold = PMC_threshold(arr);
#endif
    INTVAL   size = PMC_size(arr);
    INTVAL offset = PMC_offset(arr);

    if (offset > 0) {
        TRACE_RPA("unshift fast");
        offset--;
        PMC_size(arr)++;
        PMC_offset(arr) = offset;
        PMC_array(arr)[offset] = val;
        TRACE_PMC(offset, val);
    }
    else {
        PMC  **array;
        TRACE_RPA("unshift slow");
        TRACE_PMC(offset, val);
        VTABLE_set_integer_native(interp, arr, size + 1);
        array = PMC_array(arr);
        /* if there's enough room on the right, move the offset right by 3
           anticipating more unshifts. we have to move the items anyway. */
#if 0
        if (PMC_threshold(arr) - size > 3) {
            PMC_offset(arr) += 3;
            size += 3;
        }
#endif
        memmove(array + 1, array, size * sizeof (PMC *));
        array[0] = val;
    }
}
/*

=back

=head1 Vtable Functions

=over

=cut

*/
#line 225 "./src/pmc/resizablepmcarray.c"
static  PMC  * Parrot_ResizablePMCArray_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ResizablePMCArray_defined_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  void  Parrot_ResizablePMCArray_delete_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  void  Parrot_ResizablePMCArray_delete_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  INTVAL  Parrot_ResizablePMCArray_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_ResizablePMCArray_exists_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  void  Parrot_ResizablePMCArray_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  PMC  * Parrot_ResizablePMCArray_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  STRING  * Parrot_ResizablePMCArray_get_repr(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizablePMCArray_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL n);
static  void  Parrot_ResizablePMCArray_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_ResizablePMCArray_pop_float(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ResizablePMCArray_pop_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_ResizablePMCArray_pop_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_ResizablePMCArray_pop_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizablePMCArray_push_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_ResizablePMCArray_push_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_ResizablePMCArray_push_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_ResizablePMCArray_push_string(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  void  Parrot_ResizablePMCArray_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL n);
static  void  Parrot_ResizablePMCArray_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_ResizablePMCArray_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *src);
static  void  Parrot_ResizablePMCArray_set_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, PMC *src);
static  FLOATVAL  Parrot_ResizablePMCArray_shift_float(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ResizablePMCArray_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_ResizablePMCArray_shift_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_ResizablePMCArray_shift_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizablePMCArray_splice(PARROT_INTERP, ARGMOD(PMC *_self), PMC *from, INTVAL off, INTVAL count);
static  void  Parrot_ResizablePMCArray_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  void  Parrot_ResizablePMCArray_unshift_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_ResizablePMCArray_unshift_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_ResizablePMCArray_unshift_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_ResizablePMCArray_unshift_string(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  void  Parrot_ResizablePMCArray_visit(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  void Parrot_ResizablePMCArray_nci_append(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ResizablePMCArray_nci_shift(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ResizablePMCArray_nci_pop(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ResizablePMCArray_nci_unshift(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ResizablePMCArray_nci_push(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ResizablePMCArray_nci_sort(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ResizablePMCArray_nci_reverse(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  *
Parrot_ResizablePMCArray_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 785 "./src/pmc/resizablepmcarray.pmc"

    /* keep the slack and offset */
    PMC * const copy   = Parrot_pmc_new(interp, _self->vtable->base_type);
    const INTVAL size  = PMC_size(_self);
    const INTVAL tresh = PMC_threshold(_self);
    if (size) {
        PMC_size(copy)  = size;
        PMC_array(copy) = mem_gc_allocate_n_typed(interp, tresh, PMC *);
        mem_copy_n_typed(PMC_array(copy), PMC_array(_self), tresh, PMC *);
        PObj_custom_mark_destroy_SETALL(copy);
    }
    PMC_threshold(copy) = tresh;
    PMC_offset(copy)    = PMC_offset(_self);
    return copy;
#line 285 "./src/pmc/resizablepmcarray.c"
}
static  INTVAL 
Parrot_ResizablePMCArray_defined_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 595 "./src/pmc/resizablepmcarray.pmc"

    PMC *val;
    const INTVAL size = PMC_size(_self);

    if (UNLIKELY(key < 0))
        key += size;
    if (UNLIKELY(key < 0 || key >= size))
        return 0;
    val = VTABLE_get_pmc_keyed_int(interp, _self, key);
    if (UNLIKELY(PMC_IS_NULL(val))) {
        return 0;
    }
    return VTABLE_defined(interp, val);
#line 304 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_delete_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 517 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL idx  = VTABLE_get_integer(interp, key);
    VTABLE_delete_keyed_int(interp, _self, idx);
#line 313 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_delete_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 522 "./src/pmc/resizablepmcarray.pmc"

    Parrot_ResizablePMCArray_attributes * const data = PARROT_RESIZABLEPMCARRAY(_self);

    /* TODO ignore delete[0] for empty array for now to keep PGE happy. GH #1154.
       But add a new warning */
    if (!data->size && !key) {
        TRACE_RPAdata("delete oob", data);
        Parrot_warn(interp, PARROT_WARNINGS_UNDEF_FLAG,
                    "invalid delete argument ignored (deprecated)");
        return;
    }
    if (UNLIKELY(key < 0 || key >= data->size)) {
        TRACE_RPAdata("delete oob", data);
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "delete: index out of bounds");
    }

    data->size--;
    if (0 == key) {
        data->offset++;
        TRACE_RPAdata("delete fast", data);
        TRACE_PMC(key, data->pmc_array[data->offset-1]);
    }
    else {
        PMC ** const off = &data->pmc_array[key + data->offset];
        TRACE_RPAdata("delete slow", data);
        TRACE_PMC(key + data->offset, data->pmc_array[key + data->offset]);
        if (data->size > key) { /* skip when last element */
            memmove(off, off + 1, (data->size - key) * sizeof (PMC *));
        }
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 351 "./src/pmc/resizablepmcarray.c"
}
static  INTVAL 
Parrot_ResizablePMCArray_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 580 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL ix = VTABLE_get_integer(interp, key);
    return VTABLE_exists_keyed_int(interp, _self, ix);
#line 360 "./src/pmc/resizablepmcarray.c"
}
static  INTVAL 
Parrot_ResizablePMCArray_exists_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 566 "./src/pmc/resizablepmcarray.pmc"

    PMC ** const   data = PMC_array(_self);
    const INTVAL   size = PMC_size(_self);
    const INTVAL offset = PMC_offset(_self);

    if (UNLIKELY(key < 0))
        key += size;
    if (UNLIKELY(key < 0 || key >= size))
        return 0;

    return !PMC_IS_NULL(data[key + offset]);
#line 377 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
#line 975 "./src/pmc/resizablepmcarray.pmc"

    VTABLE_push_integer(interp, info, VTABLE_elements(interp, _self));
#line 385 "./src/pmc/resizablepmcarray.c"
}
static  PMC  *
Parrot_ResizablePMCArray_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 406 "./src/pmc/resizablepmcarray.pmc"

    PMC **data;
    const INTVAL   size = PMC_size(_self);
    const INTVAL offset = PMC_offset(_self);
    PMC  *val;

    if (UNLIKELY(key < 0))
        key += size;
    if (UNLIKELY(key < 0))
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
            "get: index out of bounds");
    if (UNLIKELY(key >= size))
        return PMCNULL;
#ifndef NDEBUG
    if (Interp_trace_TEST(interp, PARROT_TRACE_ARRAY_STATE_FLAG)
     && Interp_trace_TEST(interp, PARROT_TRACE_OPS_FLAG)) {
        fprintf(stderr, "# rpa get keyed: (%ld,%ld,%ld): [%ld]=",
                offset, size, PMC_threshold(_self), key);
        trace_pmc_dump(interp, PMC_array(_self)[key + offset]);
        fprintf(stderr, "\n");
    }
#endif

    data = PMC_array(_self);
    val = data[key + offset];
    if (PMC_IS_NULL(val))
        return PMCNULL; /* handles NULL also */
    return val;
#line 419 "./src/pmc/resizablepmcarray.c"
}
static  STRING  *
Parrot_ResizablePMCArray_get_repr(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 811 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  j;
    const INTVAL size = PMC_size(_self);
    STRING *res = CONST_STRING(interp, "[ ");
    STRING *ret;

    for (j = 0; j < size; ++j) {
        PMC * const val = VTABLE_get_pmc_keyed_int(interp, _self, j);
        res = Parrot_str_concat(interp, res, VTABLE_get_repr(interp, val));
        if (j < size - 1)
            res = Parrot_str_concat(interp, res, CONST_STRING(interp, ", "));
    }
    ret = Parrot_str_concat(interp, res, CONST_STRING(interp, " ]"));
    return ret;
#line 439 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL n)
{
#line 217 "./src/pmc/resizablepmcarray.pmc"

    if (UNLIKELY(n < 0))
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "illegal argument");
    interp->vtables[enum_class_FixedPMCArray]->init_int(interp, _self, n);
    PMC_offset(_self) = 0;
    if (LIKELY(n > 0)) {
        PMC_threshold(_self) = n;
    }
#line 454 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 765 "./src/pmc/resizablepmcarray.pmc"

    PMC ** data = PMC_array(_self);
    if (LIKELY(data)) {
        INTVAL i = PMC_size(_self);
        data += PMC_offset(_self);
        for (i--; i >= 0; --i)
            Parrot_gc_mark_PMC_alive(interp, data[i]);
    }
#line 468 "./src/pmc/resizablepmcarray.c"
}
static  FLOATVAL 
Parrot_ResizablePMCArray_pop_float(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 687 "./src/pmc/resizablepmcarray.pmc"

    PMC * const val = VTABLE_pop_pmc(interp, _self);
    return VTABLE_get_number(interp, val);
#line 477 "./src/pmc/resizablepmcarray.c"
}
static  INTVAL 
Parrot_ResizablePMCArray_pop_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 692 "./src/pmc/resizablepmcarray.pmc"

    PMC * const val = VTABLE_pop_pmc(interp, _self);
    return VTABLE_get_integer(interp, val);
#line 486 "./src/pmc/resizablepmcarray.c"
}
static  PMC  *
Parrot_ResizablePMCArray_pop_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 697 "./src/pmc/resizablepmcarray.pmc"

    INTVAL size = PMC_size(_self);
    const INTVAL offset = PMC_offset(_self);
    PMC   *val;

    if (UNLIKELY(0 == size))
        throw_pop_empty(interp);
    --size;
    PMC_size(_self) = size;
    val = PMC_array(_self)[offset + size];

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return val;
#line 505 "./src/pmc/resizablepmcarray.c"
}
static  STRING  *
Parrot_ResizablePMCArray_pop_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 712 "./src/pmc/resizablepmcarray.pmc"

    PMC * const val = VTABLE_pop_pmc(interp, _self);
    return VTABLE_get_string(interp, val);
#line 514 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_push_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 627 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size = PMC_size(_self);
    PMC   * const val = Parrot_pmc_new(interp, enum_class_Float);

    VTABLE_set_number_native(interp, val, value);
    VTABLE_push_pmc(interp, _self, val);
#line 526 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_push_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 635 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size = PMC_size(_self);
    PMC   * const val = Parrot_pmc_new_init_int(interp, enum_class_Integer, value);
    VTABLE_push_pmc(interp, _self, val);
#line 536 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_push_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 641 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL threshold = PMC_threshold(_self);
    const INTVAL size      = PMC_size(_self);
    INTVAL       offset    = PMC_offset(_self);

    /* if there's enough room on the right */
    if (PMC_array(_self) && (offset + size < threshold)) {
        PMC_size(_self)++;
        TRACE_RPAself("push fast", _self);
    }
    else {
        VTABLE_set_integer_native(interp, _self, size + 1);
        offset = PMC_offset(_self);
        TRACE_RPAself("push slow", _self);
    }
    ((PMC **)PMC_array(_self))[offset + size] = value;
    TRACE_PMC(offset+size, value);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 560 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_push_string(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
#line 660 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size = PMC_size(_self);
    PMC   * const val = Parrot_pmc_new(interp, enum_class_String);

    VTABLE_assign_string_native(interp, val, value);
    VTABLE_push_pmc(interp, _self, val);
#line 572 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL n)
{
#line 238 "./src/pmc/resizablepmcarray.pmc"

    INTVAL   size      = PMC_size(_self);
    INTVAL   offset    = PMC_offset(_self);
    INTVAL   threshold = PMC_threshold(_self); /* i.e. allocated size */
    PMC    **array     = PMC_array(_self);

    if (UNLIKELY(n < 0))
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "illegal argument");
    if (UNLIKELY(!array)) {
        /* empty - used fixed routine */
        PMC_offset(_self) = 0;
        if (n < 8) {
            interp->vtables[enum_class_FixedPMCArray]->set_integer_native(interp, _self, 8);
            PMC_size(_self)      = n;
            PMC_threshold(_self) = 8;
        }
        else {
            interp->vtables[enum_class_FixedPMCArray]->set_integer_native(interp, _self, n);
            PMC_threshold(_self) = n;
        }
        TRACE_RPAsize("resize init");
    }
    else if (n == size) {
        return;
    }
    else if (n <= threshold - offset) {
        TRACE_RPAsize("resize skip");
        PMC_size(_self) = n;
        /* PARROT_GC_WRITE_BARRIER(interp, _self); */
        /* we could shrink here, but this would need a GC mark */
        return;
    }
    /* enough room at the left */
    else if (offset > 0 && n + offset > size && n <= threshold) {
        /* if there aren't enough slots at the end, shift off empty
         * slots from the beginning first */
        if (size > 0) {
             /* 7,1,8 n:6 =>5. 1,5,10 n=10 =>1 */
            const INTVAL diff = n - size > offset ? offset : n - size;
            size_t i;
            TRACE_RPAsize("resize off move"); /* move diff to the left */
            PARROT_ASSERT(offset >= diff);
            memmove(&array[offset - diff], &array[offset], size * sizeof (PMC *));
#ifdef DEBUG_FILL_SLACK
            for (i=-diff; i<0; ++i) {      /* fill the slack */
                array[offset+size+i] = PMCNULL;
            }
#endif
            PMC_offset(_self) -= diff;
            PARROT_GC_WRITE_BARRIER(interp, _self);
        }
        else { /* for empty arrays just reset the offset */
            PMC_offset(_self) = 0;
            TRACE_RPAsize("resize off empty");
        }
        PMC_size(_self) = n;
    }
    else {
        INTVAL old;
        old = threshold;
        n += offset;
        if (n < 8192) {
            INTVAL newsize = threshold;  /* overallocate small blocks by 1.5 */
            newsize += newsize/2;
            threshold = (n < newsize) ? newsize : n;
            if (threshold < 8) threshold = 8;
        }
        else {
            const INTVAL needed = n - threshold;
            threshold += needed + 4096;     /* next block */
            threshold &= ~0xfff;
        }
        array = mem_gc_realloc_n_typed(interp, array, threshold, PMC *);
#ifdef DEBUG_FILL_SLACK
        for (; old < threshold; ++old) { /* fill the slack */
            array[old] = PMCNULL;
        }
#endif
        PMC_threshold(_self) = threshold;
        PMC_size(_self)      = n - offset;
        if (PMC_array(_self) != array) { /* data moved? */
            PMC_array(_self) = array;
            TRACE_RPAsize("resize move");
        }
#ifndef NDEBUG
        else {
            TRACE_RPAsize("resize fast realloc");
        }
#endif
        PARROT_GC_WRITE_BARRIER(interp, _self);
    }
#line 670 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 485 "./src/pmc/resizablepmcarray.pmc"

    INTVAL size;
    INTVAL i;
    PMC ** data = PMC_array(_self);

    if (_self == value)
        return;
    if (UNLIKELY(!VTABLE_does(interp, value, CONST_STRING(interp, "array"))))
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "Can't set self from this type");

    PMC_offset(_self) = 0;
    size = PMC_size(_self) = VTABLE_elements(interp, value);
    /* TODO realloc */
    if (data) mem_gc_free(interp, data);
    data = PMC_array(_self) = mem_gc_allocate_n_typed(interp, size, PMC *);
    for (i = 0; i < size; ++i)
        data[i] = VTABLE_get_pmc_keyed_int(interp, value, i);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 695 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *src)
{
#line 481 "./src/pmc/resizablepmcarray.pmc"

    interp->vtables[enum_class_FixedPMCArray]->set_pmc_keyed(interp, _self, key, src);
#line 703 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_set_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, PMC *src)
{
#line 450 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size = PMC_size(_self);
    INTVAL offset = PMC_offset(_self);

    if (UNLIKELY(key < 0))
        key += size;
    if (UNLIKELY(key < 0))
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
            "set: index out of bounds");
#ifndef NDEBUG
    if (Interp_trace_TEST(interp, PARROT_TRACE_ARRAY_STATE_FLAG)
     && Interp_trace_TEST(interp, PARROT_TRACE_OPS_FLAG)) {
        fprintf(stderr, "# rpa set keyed: (%ld,%ld,%ld): [%ld]=",
                offset, size, PMC_threshold(_self), key);
        trace_pmc_dump(interp, src);
        fprintf(stderr, "\n");
    }
#endif
    if (UNLIKELY(key >= size)) {
        INTVAL i;
        PMC ** array;
        VTABLE_set_integer_native(interp, _self, key + 1);
        offset = PMC_offset(_self);
        array = PMC_array(_self);
        for (i=size+offset; i<PMC_size(_self)+offset; ++i) { /* fill the slack */
            array[i] = PMCNULL;
        }
    }
    PMC_array(_self)[key + offset] = src;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 739 "./src/pmc/resizablepmcarray.c"
}
static  FLOATVAL 
Parrot_ResizablePMCArray_shift_float(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 351 "./src/pmc/resizablepmcarray.pmc"

    Parrot_ResizablePMCArray_attributes * const data = PARROT_RESIZABLEPMCARRAY(_self);
    FLOATVAL value;

    if (UNLIKELY(0 == data->size))
        throw_shift_empty(interp);
    value = VTABLE_get_number(interp, data->pmc_array[data->offset]);
    do_shift(interp, data);
    return value;
#line 754 "./src/pmc/resizablepmcarray.c"
}
static  INTVAL 
Parrot_ResizablePMCArray_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 362 "./src/pmc/resizablepmcarray.pmc"

    Parrot_ResizablePMCArray_attributes * const data = PARROT_RESIZABLEPMCARRAY(_self);
    INTVAL value;

    if (UNLIKELY(0 == data->size))
        throw_shift_empty(interp);
    value = VTABLE_get_integer(interp, data->pmc_array[data->offset]);
    do_shift(interp, data);
    return value;
#line 769 "./src/pmc/resizablepmcarray.c"
}
static  PMC  *
Parrot_ResizablePMCArray_shift_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 373 "./src/pmc/resizablepmcarray.pmc"

    Parrot_ResizablePMCArray_attributes * const data = PARROT_RESIZABLEPMCARRAY(_self);
    PMC   *value;

    if (UNLIKELY(0 == data->size))
        throw_shift_empty(interp);
    value = data->pmc_array[data->offset];
    do_shift(interp, data);
    return value;
#line 784 "./src/pmc/resizablepmcarray.c"
}
static  STRING  *
Parrot_ResizablePMCArray_shift_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 384 "./src/pmc/resizablepmcarray.pmc"

    Parrot_ResizablePMCArray_attributes * const data = PARROT_RESIZABLEPMCARRAY(_self);
    STRING  *value;

    if (UNLIKELY(0 == data->size))
        throw_shift_empty(interp);
    value = VTABLE_get_string(interp, data->pmc_array[data->offset]);
    do_shift(interp, data);
    return value;
#line 799 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_splice(PARROT_INTERP, ARGMOD(PMC *_self), PMC *from, INTVAL off, INTVAL count)
{
#line 840 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size      = PMC_size(_self);
    const INTVAL threshold = PMC_threshold(_self);
    INTVAL       offset    = PMC_offset(_self);
    const INTVAL elems1    = VTABLE_elements(interp, from);
    PMC **item;
    INTVAL tail = 0, sizediff = 0, newsize;
#ifndef NDEBUG
    int no_debug = 0; /* if we didn't branch into a TRACE_RPA */
#endif

    /* start from end? */
    if (UNLIKELY(off < 0))
        off += size;
    if (UNLIKELY(count < 0))
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "illegal argument");
    if (UNLIKELY(off < 0))
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "splice: index out of bounds");
    if (UNLIKELY(off > size)) {
        Parrot_warn(interp, PARROT_WARNINGS_UNDEF_FLAG, /* _MISC in perl5 */
                "splice: offset past end of array");
        TRACE_RPAself("splice off > size", _self);
        TRACE_SPLC;
        off = size;
    }

    /* number of elements to the right of the splice (the "tail") */
    tail = size - off - count;
    if (tail < 0) tail = 0;

    /* [0    ^      ...  ... ] */
    /*  self offset size threshold */
    item = PMC_array(_self);
    sizediff = count - elems1;
    if (tail > 0 && sizediff > 0) {
        /* we're shrinking the array, so first move the tail left. */
        /* maybe we can just adjust the offset. */
        if (!off && offset >= sizediff) { /* enough room at the left to fill in from */
            TRACE_RPAself("splice shrink fast", _self);
            TRACE_SPLC;
            item += offset + elems1;
            offset += sizediff;
            PMC_offset(_self) = offset;
            PMC_size(_self) -= sizediff;
            goto splice_copy;
        }
        else {
            TRACE_RPAself("splice shrink", _self);
            TRACE_SPLC;
            memmove(item + offset + off + elems1, item + offset + off + count,
                    tail * sizeof (PMC *));
        }
    }
#ifndef NDEBUG
    else {
        no_debug = 1;
    }
#endif
    /* now resize the array */
    newsize = off + elems1 + tail;
    if (newsize > threshold - offset) {
        VTABLE_set_integer_native(interp, _self, newsize);
        offset = PMC_offset(_self);
        item   = PMC_array(_self);
    }
    else {
        PMC_size(_self) = newsize; /* enough room */
    }
    item += offset;
    if (tail > 0 && sizediff < 0) { /* elems1 > count */
        TRACE_RPAself("splice grow", _self);
        TRACE_SPLC;
        PARROT_ASSERT(offset + newsize <= PMC_threshold(_self));
        /* the array grew, so move the tail to the right */
        memmove(item + off + elems1, item + off + count,
                tail * sizeof (PMC *));
    }
#ifndef NDEBUG
    else if (!no_debug) {
        no_debug = 1;
    }
#endif

  splice_copy:
    /* now copy C<from>'s elements into _self */
    if (elems1 > 0) {
        INTVAL i;
        PMC *iter = VTABLE_get_iter(interp, from);
        TRACE_RPAself("splice fill", _self);
        TRACE_SPLC;
        for (i = 0; i < elems1; i++)
            item[off + i] = VTABLE_shift_pmc(interp, iter);
    }
#ifndef NDEBUG
    else if (no_debug) {
        /* we are better of with a simple resize here */
        TRACE_RPAself("splice noop", _self);
        TRACE_SPLC;
    }
#endif
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 908 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
#line 979 "./src/pmc/resizablepmcarray.pmc"

    VTABLE_init_int(interp, _self, VTABLE_shift_integer(interp, info));
#line 916 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_unshift_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 734 "./src/pmc/resizablepmcarray.pmc"

    PMC * const val = Parrot_pmc_new(interp, enum_class_Float);
    VTABLE_set_number_native(interp, val, value);
    do_unshift(interp, _self, val);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 927 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_unshift_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 740 "./src/pmc/resizablepmcarray.pmc"

    PMC * const val = Parrot_pmc_new_init_int(interp, enum_class_Integer, value);
    do_unshift(interp, _self, val);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 937 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_unshift_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 745 "./src/pmc/resizablepmcarray.pmc"

    do_unshift(interp, _self, value);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 946 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_unshift_string(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
#line 749 "./src/pmc/resizablepmcarray.pmc"

    PMC * const val = Parrot_pmc_new(interp, enum_class_String);
    VTABLE_set_string_native(interp, val, value);
    do_unshift(interp, _self, val);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 957 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_visit(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
#line 964 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  i;
    const INTVAL n = VTABLE_elements(interp, _self);
    PMC   **pos    = PMC_array(_self) + PMC_offset(_self);

    for (i = 0; i < n; ++i, ++pos) {
        VISIT_PMC(interp, info, *pos);
    }
    interp->vtables[enum_class_FixedPMCArray]->visit(interp, _self, info);
#line 972 "./src/pmc/resizablepmcarray.c"
}
static  void
Parrot_ResizablePMCArray_nci_append(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* other;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    other = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 999 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL n = VTABLE_elements(interp, _self);
    const INTVAL m = VTABLE_elements(interp, other);
    const INTVAL offset = PMC_offset(_self);
    if (!m)
        return;

    /* pre-size it */
    VTABLE_set_integer_native(interp, _self, n + m);

    if (other->vtable->base_type == _self->vtable->base_type
    ||  other->vtable->base_type == enum_class_FixedPMCArray) {
        PMC ** const other_data = PMC_array(other);
        PMC ** const this_data  = PMC_array(_self) + offset;

        /* libc is faster at copying data than a manual loop here */
        memmove(this_data + n, other_data, m  * sizeof (PMC *));
    }
    else {
        PMC ** const this_data = PMC_array(_self);
        INTVAL i;
        for (i = offset; i < m; ++i)
            this_data[n + i] = VTABLE_get_pmc_keyed_int(interp, other, i);
    }
    #line 1019 "./src/pmc/resizablepmcarray.c"
    {
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
    }
#line 1023 "./src/pmc/resizablepmcarray.pmc"

#line 1026 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ResizablePMCArray_nci_shift(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 1039 "./src/pmc/resizablepmcarray.pmc"

    PMC * const value = VTABLE_shift_pmc(interp, _self);
    #line 1056 "./src/pmc/resizablepmcarray.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)value);
        
        return;
     }
#line 1041 "./src/pmc/resizablepmcarray.pmc"

#line 1064 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ResizablePMCArray_nci_pop(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 1044 "./src/pmc/resizablepmcarray.pmc"

    PMC * const value = VTABLE_pop_pmc(interp, _self);
    #line 1094 "./src/pmc/resizablepmcarray.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)value);
        
        return;
     }
#line 1046 "./src/pmc/resizablepmcarray.pmc"

#line 1102 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ResizablePMCArray_nci_unshift(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* value;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    value = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 1061 "./src/pmc/resizablepmcarray.pmc"

    VTABLE_unshift_pmc(interp, _self, value);
#line 1134 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ResizablePMCArray_nci_push(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* value;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    value = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 1065 "./src/pmc/resizablepmcarray.pmc"

    VTABLE_push_pmc(interp, _self, value);
#line 1166 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ResizablePMCArray_nci_sort(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* cmp_func;
    
    const INTVAL arity = 1; /* "PiPo" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        cmp_func = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);
    }
    else {
        cmp_func = PMCNULL;
    }

    { /* BEGIN PMETHOD BODY */
#line 1079 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL n      = _self->vtable->elements(interp, _self);
    const INTVAL offset = PMC_offset(_self);
    PMC ** array        = PMC_array(_self);

    if (n > 1) {
        /* XXX Workaround for TT #218 */
        if (PObj_is_object_TEST(_self)) {
            PMC * const parent = _self->vtable->get_attr_str(interp, _self, CONST_STRING(interp, "proxy"));
            Parrot_pcc_invoke_method_from_c_args(interp, parent, CONST_STRING(interp, "sort"), "P->", cmp_func);
        }
        else {
            array += offset;
            Parrot_util_quicksort(interp, (void **)array, n, cmp_func, "PP->I");
        }
    }
    #line 1223 "./src/pmc/resizablepmcarray.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)_self);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 1095 "./src/pmc/resizablepmcarray.pmc"

#line 1231 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ResizablePMCArray_nci_reverse(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 1108 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL offset = PMC_offset(_self);
    INTVAL       n      = _self->vtable->elements(interp, _self);

    if (n > 1) {
        PMC *val;
        PMC **data = PMC_array(_self) + offset;
        INTVAL i;

        for (i = 0; i <= --n; i++) {
            val = data[i];
            data[i] = data[n];
            data[n] = val;
        }
    }
#line 1274 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ResizablePMCArray_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ResizablePMCArray_clone;
    vt->defined_keyed_int = Parrot_ResizablePMCArray_defined_keyed_int;
    vt->delete_keyed = Parrot_ResizablePMCArray_delete_keyed;
    vt->delete_keyed_int = Parrot_ResizablePMCArray_delete_keyed_int;
    vt->exists_keyed = Parrot_ResizablePMCArray_exists_keyed;
    vt->exists_keyed_int = Parrot_ResizablePMCArray_exists_keyed_int;
    vt->freeze = Parrot_ResizablePMCArray_freeze;
    vt->get_pmc_keyed_int = Parrot_ResizablePMCArray_get_pmc_keyed_int;
    vt->get_repr = Parrot_ResizablePMCArray_get_repr;
    vt->init_int = Parrot_ResizablePMCArray_init_int;
    vt->mark = Parrot_ResizablePMCArray_mark;
    vt->pop_float = Parrot_ResizablePMCArray_pop_float;
    vt->pop_integer = Parrot_ResizablePMCArray_pop_integer;
    vt->pop_pmc = Parrot_ResizablePMCArray_pop_pmc;
    vt->pop_string = Parrot_ResizablePMCArray_pop_string;
    vt->push_float = Parrot_ResizablePMCArray_push_float;
    vt->push_integer = Parrot_ResizablePMCArray_push_integer;
    vt->push_pmc = Parrot_ResizablePMCArray_push_pmc;
    vt->push_string = Parrot_ResizablePMCArray_push_string;
    vt->set_integer_native = Parrot_ResizablePMCArray_set_integer_native;
    vt->set_pmc = Parrot_ResizablePMCArray_set_pmc;
    vt->set_pmc_keyed = Parrot_ResizablePMCArray_set_pmc_keyed;
    vt->set_pmc_keyed_int = Parrot_ResizablePMCArray_set_pmc_keyed_int;
    vt->shift_float = Parrot_ResizablePMCArray_shift_float;
    vt->shift_integer = Parrot_ResizablePMCArray_shift_integer;
    vt->shift_pmc = Parrot_ResizablePMCArray_shift_pmc;
    vt->shift_string = Parrot_ResizablePMCArray_shift_string;
    vt->splice = Parrot_ResizablePMCArray_splice;
    vt->thaw = Parrot_ResizablePMCArray_thaw;
    vt->unshift_float = Parrot_ResizablePMCArray_unshift_float;
    vt->unshift_integer = Parrot_ResizablePMCArray_unshift_integer;
    vt->unshift_pmc = Parrot_ResizablePMCArray_unshift_pmc;
    vt->unshift_string = Parrot_ResizablePMCArray_unshift_string;
    vt->visit = Parrot_ResizablePMCArray_visit;
    vt->attr_size = sizeof(Parrot_ResizablePMCArray_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ResizablePMCArray_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ResizablePMCArray_clone;
    vt->defined_keyed_int = Parrot_ResizablePMCArray_defined_keyed_int;
    vt->exists_keyed = Parrot_ResizablePMCArray_exists_keyed;
    vt->exists_keyed_int = Parrot_ResizablePMCArray_exists_keyed_int;
    vt->freeze = Parrot_ResizablePMCArray_freeze;
    vt->get_pmc_keyed_int = Parrot_ResizablePMCArray_get_pmc_keyed_int;
    vt->get_repr = Parrot_ResizablePMCArray_get_repr;
    vt->mark = Parrot_ResizablePMCArray_mark;
    vt->visit = Parrot_ResizablePMCArray_visit;
    vt->attr_size = sizeof(Parrot_ResizablePMCArray_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizablePMCArray_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedPMCArray_get_vtable(interp);
    Parrot_ResizablePMCArray_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizablePMCArray_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedPMCArray_ro_get_vtable(interp);
    Parrot_ResizablePMCArray_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ResizablePMCArray_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_FixedPMCArray_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "ResizablePMCArray"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ResizablePMCArray_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_FixedPMCArray_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ResizablePMCArray")), PMCNULL);
    return isa;
}

void
Parrot_ResizablePMCArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Isize :pmc_array Ioffset Ithreshold ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ResizablePMCArray_get_vtable(interp);
        vt->base_type      = enum_class_ResizablePMCArray;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ResizablePMCArray");
        vt->provides_str = CONST_STRING_GEN(interp, "array");
        vt->isa_hash     = Parrot_ResizablePMCArray_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_ResizablePMCArray_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_ResizablePMCArray;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ResizablePMCArray_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "append");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_append),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "shift");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_shift),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "pop");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_pop),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "unshift");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_unshift),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "push");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_push),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "sort");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_sort),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "reverse");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_reverse),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_ResizablePMCArray_class_init */

#line 1124 "./src/pmc/resizablepmcarray.pmc"


/*

=back

=head2 Auxiliar functions

=over 4

=item C<static void do_shift(PARROT_INTERP, PMC *arr)>

Common part for all shift operations.

=item C<static void do_unshift(PARROT_INTERP, PMC *arr, PMC *val)>

Common part for all unshift operations.

=item C<static void throw_shift_empty(PARROT_INTERP)>

=item C<static void throw_pop_empty(PARROT_INTERP)>

Throws with the appropriate message.

=cut

*/

PARROT_DOES_NOT_RETURN
PARROT_INLINE
static void
throw_shift_empty(PARROT_INTERP)
{
    ASSERT_ARGS(throw_shift_empty)
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
            "Can't shift from an empty array");
}

PARROT_DOES_NOT_RETURN
PARROT_INLINE
static void
throw_pop_empty(PARROT_INTERP)
{
    ASSERT_ARGS(throw_pop_empty)
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
            "Can't pop from an empty array");
}

/*

=back

=head1 See also

F<docs/pdds/pdd17_basic_types.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
