/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/role.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_role.h"
#include "pmc_default.h"
#include "role.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/role.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/role.pmc - Role PMC

=head1 DESCRIPTION

This class implements the Role PMC, a unit of class composition as outlined in
F<docs/pdds/pdd15_objects.pod>.

Role is not derived from any other PMC.

=head2 Structure

The Role PMC structure (C<Parrot_Role>) consists of five items:

=over 4

=item C<name>

The name of the role -- a STRING.
An empty STRING is allocated during initialization.

=item C<namespace>

The namespace the role is associated with, if any.
A Null PMC is allocated during initialization.

=item C<roles>

The list of roles from which this role is composed, if any.
An empty ResizablePMCArray is allocated during initialization.

=item C<methods>

The directory of method names and methods this role implements.
An empty Hash PMC is allocated during initialization.

=item C<attrib_metadata>

The directory of attribute names and attribute metadata this role contains.
An empty Hash PMC is allocated during initialization.

=cut

*/

#include "pmc/pmc_namespace.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void init_role_from_hash(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *info))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

#define ASSERT_ARGS_init_role_from_hash __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(info))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static void init_role_from_hash(PARROT_INTERP, PMC *self, PMC *info)>

Takes a hash and initializes the role based on it.

=cut

*/

static void
init_role_from_hash(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *info))
{
    ASSERT_ARGS(init_role_from_hash)
    Parrot_Role_attributes * const role     = PARROT_ROLE(self);
    STRING * const ns_string      = CONST_STRING(interp, "NameSpace");
    STRING * const name_str       = CONST_STRING(interp, "name");
    STRING * const namespace_str  = CONST_STRING(interp, "namespace");
    STRING * const set_class_str  = CONST_STRING(interp, "set_class");
    STRING * const roles_str      = CONST_STRING(interp, "roles");
    STRING * const attributes_str = CONST_STRING(interp, "attributes");
    STRING * const methods_str    = CONST_STRING(interp, "methods");

    int have_name, have_ns;
    PMC *old_ns;
    int i;

    /* Ensure we actually have some initialization info. */
    if (PMC_IS_NULL(info))
        return;

    /* Check if we have a name and/or a namespace. */
    have_name = VTABLE_exists_keyed_str(interp, info, name_str);

    have_ns = VTABLE_exists_keyed_str(interp, info, namespace_str);

    /* Take a copy of the current namespace the role is attached to. */
    old_ns = role->_namespace;

    /* Let's roll (no pun intended!) If we have a namespace and a name,
     * set both. */
    if (have_name && have_ns) {
        /* If we weren't passed a NameSpace PMC, assume it's something we have
         * to look one up with and do so. */
        PMC *_namespace = VTABLE_get_pmc_keyed_str(interp, info, namespace_str);
        if (!VTABLE_isa(interp, _namespace, ns_string))
            _namespace = Parrot_ns_make_namespace_autobase(interp, _namespace);

        /* If we get something null back it's an error; otherwise, store it. */
        if (!PMC_IS_NULL(_namespace))
            role->_namespace = _namespace;
        else
            Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_GLOBAL_NOT_FOUND,
                    "Namespace not found");

        /* Set a (string) name. */
        role->name = VTABLE_get_string_keyed_str(interp, info, name_str);
    }

    /* Otherwise, we may just have a name. */
    else if (have_name) {
        /* Set the name. */
        role->name = VTABLE_get_string_keyed_str(interp, info, name_str);

        /* Namespace is nested in the current namespace and with the name of
         * the role. */
        role->_namespace = Parrot_ns_make_namespace_keyed_str(interp,
            Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp)), role->name);
    }

    /* Otherwise, we may just have a namespace. */
    else if (have_ns) {
        /* If we weren't passed a NameSpace PMC, assume it's something we have
         * to look one up with and do so. */
        PMC *_namespace = VTABLE_get_pmc_keyed_str(interp, info, namespace_str);
        if (!VTABLE_isa(interp, _namespace, ns_string))
            _namespace = Parrot_ns_make_namespace_autobase(interp, _namespace);

        /* If we get something null back it's an error; otherwise, store it. */
        if (PMC_IS_NULL(_namespace))
            Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_GLOBAL_NOT_FOUND,
                    "Namespace not found");

        role->_namespace = _namespace;
        /* Name is that of the most nested part of the namespace. */
        role->name = VTABLE_get_string(interp, _namespace);
    }

    /* If we were attached to a namespce and are now attached to a new one,
     * need to unset ourselves in the old namespace. */
    if (!PMC_IS_NULL(old_ns) && role->_namespace != old_ns) {
        Parrot_pcc_invoke_method_from_c_args(interp, old_ns, set_class_str, "P->", PMCNULL);
    }

    /* Link namespace to this role, if there is one. */
    if (!PMC_IS_NULL(role->_namespace)) {
        Parrot_pcc_invoke_method_from_c_args(interp, role->_namespace, set_class_str, "P->", self);
    }

    /* Initialize roles, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, roles_str)) {
        /* Loop over roles array and compose them. */
        PMC    * const role_list = VTABLE_get_pmc_keyed_str(interp, info, roles_str);
        const int role_count     = VTABLE_elements(interp, role_list);

        for (i = 0; i < role_count; ++i) {
            PMC * const cur_role = VTABLE_get_pmc_keyed_int(interp, role_list, i);
            VTABLE_add_role(interp, self, cur_role);
        }
    }

    /* Initialize attributes, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, attributes_str)) {
        /* Loop over attributes array and add them. */
        PMC    * const attrib_name_list = VTABLE_get_pmc_keyed_str(interp, info, attributes_str);

        const int attrib_count = VTABLE_elements(interp, attrib_name_list);

        for (i = 0; i < attrib_count; ++i) {
            STRING * const attrib_name = VTABLE_get_string_keyed_int(interp,
                attrib_name_list, i);
            VTABLE_add_attribute(interp, self, attrib_name, PMCNULL);
        }
    }

    /* Initialize methods, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, methods_str)) {
        /* Get the methods hash. */
        PMC    * const methods     = VTABLE_get_pmc_keyed_str(interp, info, methods_str);

        /* Iterate over the list of methods. */
        PMC    * const iter        = VTABLE_get_iter(interp, methods);

        while (VTABLE_get_bool(interp, iter)) {
            /* Add the method. */
            STRING * const method_name = VTABLE_shift_string(interp, iter);
            PMC    * const method_pmc  =
                VTABLE_get_pmc_keyed_str(interp, methods, method_name);
            VTABLE_add_method(interp, self, method_name, method_pmc);
        }
    }

    /* Extract any methods from the namespace */
    Parrot_oo_extract_methods_from_namespace(interp, self, role->_namespace);
}

/*

=back

=head2 Functions

=over 4

=cut

*/
#line 250 "./src/pmc/role.c"
static  void  Parrot_Role_add_attribute(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, PMC *type);
static  void  Parrot_Role_add_method(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, PMC *sub);
static  void  Parrot_Role_add_role(PARROT_INTERP, ARGMOD(PMC *_self), PMC *role);
static  INTVAL  Parrot_Role_does(PARROT_INTERP, ARGMOD(PMC *_self), STRING *role_name);
static  INTVAL  Parrot_Role_does_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *role);
static  STRING  * Parrot_Role_get_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Role_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Role_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init_data);
static  PMC  * Parrot_Role_inspect(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_Role_inspect_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *what);
static  void  Parrot_Role_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Role_remove_method(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name);
static  void Parrot_Role_nci_name(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Role_nci_get_namespace(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Role_nci_attributes(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Role_nci_add_attribute(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Role_nci_methods(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Role_nci_add_method(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Role_nci_remove_method(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Role_nci_roles(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Role_nci_add_role(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Role_nci_inspect(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Role_nci_does(PARROT_INTERP, ARGMOD(PMC *_self));
static  void 
Parrot_Role_add_attribute(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, PMC *type)
{
#line 304 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role  = PARROT_ROLE(_self);
    PMC           * const new_attribute  = Parrot_pmc_new(interp, enum_class_Hash);

    /* Set name and type. */
    VTABLE_set_string_keyed_str(interp, new_attribute, CONST_STRING(interp, "name"), name);

    if (!PMC_IS_NULL(type))
        VTABLE_set_pmc_keyed_str(interp, new_attribute, CONST_STRING(interp, "type"), type);

    /* Enter the attribute in the attributes array. */
    VTABLE_set_pmc_keyed_str(interp, role->attrib_metadata,
        name, new_attribute);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 292 "./src/pmc/role.c"
}
static  void 
Parrot_Role_add_method(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, PMC *sub)
{
#line 329 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role = PARROT_ROLE(_self);

    /* If we have already added a method with this name... */
    if (VTABLE_exists_keyed_str(interp, role->methods, name)) {
        /* XXX Need to handle multi methods here. */
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_UNIMPLEMENTED,
            "Currently, adding multiple methods of the same name"
            " is not supported.");
    }
    else {
        /* Enter it into the table. */
        VTABLE_set_pmc_keyed_str(interp, role->methods, name, sub);
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 313 "./src/pmc/role.c"
}
static  void 
Parrot_Role_add_role(PARROT_INTERP, ARGMOD(PMC *_self), PMC *role)
{
#line 375 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const this_role = PARROT_ROLE(_self);

    /* Do the composition. */
    Parrot_ComposeRole(interp, role, PMCNULL, 0, PMCNULL, 0,
           this_role->methods, this_role->roles);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 326 "./src/pmc/role.c"
}
static  INTVAL 
Parrot_Role_does(PARROT_INTERP, ARGMOD(PMC *_self), STRING *role_name)
{
#line 537 "./src/pmc/role.pmc"

    const Parrot_Role_attributes * const role  = PARROT_ROLE(_self);
    INTVAL      i, count;

    if (STRING_equal(interp, role->name, role_name))
        return 1;

    count = VTABLE_elements(interp, role->roles);
    for (i = 0; i < count; ++i) {
        PMC * const cur_role = VTABLE_get_pmc_keyed_int(interp, role->roles, i);
        if (VTABLE_does(interp, cur_role, role_name))
            return 1;
    }

    return 0;
#line 347 "./src/pmc/role.c"
}
static  INTVAL 
Parrot_Role_does_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *role)
{
#line 563 "./src/pmc/role.pmc"

    const Parrot_Role_attributes * const this_role  = PARROT_ROLE(_self);
    INTVAL      i, count;

    if (role == _self)
        return 1;

    count = VTABLE_elements(interp, this_role->roles);
    for (i = 0; i < count; ++i) {
        PMC * const cur_role = VTABLE_get_pmc_keyed_int(interp, this_role->roles, i);
        if (VTABLE_does_pmc(interp, cur_role, role))
            return 1;
    }

    return 0;
#line 368 "./src/pmc/role.c"
}
static  STRING  *
Parrot_Role_get_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 506 "./src/pmc/role.pmc"

    const Parrot_Role_attributes * const role = PARROT_ROLE(_self);
    PMC               * const _namespace = role->_namespace;

    if (!PMC_IS_NULL(_namespace)) {
        /* Call the 'get_name' method on the role's associated namespace
         * to retrieve a fully qualified list of names, then join the list
         * with a semicolon.
         */
        PMC * const names = Parrot_ns_get_name(interp, _namespace);

        if (!PMC_IS_NULL(names)) {
            /* remove the HLL namespace name */
            VTABLE_shift_string(interp, names);
            return Parrot_str_join(interp, CONST_STRING(interp, ";"), names);
        }
    }

    /* Otherwise, copy the stored string name of the class. */
    return role->name;
#line 394 "./src/pmc/role.c"
}
static  void 
Parrot_Role_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 250 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role =
            (Parrot_Role_attributes *) PMC_data(_self);

    /* Set flags for custom GC mark. */
    PObj_custom_mark_SET(_self);

    /* Set up the object. */
    role->name            = CONST_STRING(interp, "");
    role->_namespace      = PMCNULL;
    role->roles           = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    role->methods         = Parrot_pmc_new(interp, enum_class_Hash);
    role->attrib_metadata = Parrot_pmc_new(interp, enum_class_Hash);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 414 "./src/pmc/role.c"
}
static  void 
Parrot_Role_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init_data)
{
#line 265 "./src/pmc/role.pmc"

    /* Create the role. */
    VTABLE_init(interp, _self);

    /* Initialize the role with the supplied data. */
    init_role_from_hash(interp, _self, init_data);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 427 "./src/pmc/role.c"
}
static  PMC  *
Parrot_Role_inspect(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 468 "./src/pmc/role.pmc"

    /* Create a hash, then use inspect_str to get all of the data to
     * fill it up with. */
    PMC * const metadata = Parrot_pmc_new(interp, enum_class_Hash);

    STRING * const name       = CONST_STRING(interp, "name");
    STRING * const _namespace = CONST_STRING(interp, "namespace");
    STRING * const attributes = CONST_STRING(interp, "attributes");
    STRING * const methods    = CONST_STRING(interp, "methods");
    STRING * const roles      = CONST_STRING(interp, "roles");

    VTABLE_set_pmc_keyed_str(interp, metadata, name,
        VTABLE_inspect_str(interp, _self, name));

    VTABLE_set_pmc_keyed_str(interp, metadata, _namespace,
        VTABLE_inspect_str(interp, _self, _namespace));

    VTABLE_set_pmc_keyed_str(interp, metadata, attributes,
        VTABLE_inspect_str(interp, _self, attributes));

    VTABLE_set_pmc_keyed_str(interp, metadata, methods,
        VTABLE_inspect_str(interp, _self, methods));

    VTABLE_set_pmc_keyed_str(interp, metadata, roles,
        VTABLE_inspect_str(interp, _self, roles));
    return metadata;
#line 459 "./src/pmc/role.c"
}
static  PMC  *
Parrot_Role_inspect_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *what)
{
#line 411 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role  = PARROT_ROLE(_self);

    /* What should we return? */
    PMC         *found;

    if (STRING_equal(interp, what, CONST_STRING(interp, "name"))) {
        found = Parrot_pmc_new(interp, enum_class_String);
        VTABLE_set_string_native(interp, found, role->name);
    }
    else if (STRING_equal(interp, what, CONST_STRING(interp, "namespace"))) {
        /* Don't clone the namespace, as it's not part of our state. */
        return role->_namespace;
    }
    else if (STRING_equal(interp, what, CONST_STRING(interp, "attributes"))) {
        found = role->attrib_metadata;
    }
    else if (STRING_equal(interp, what, CONST_STRING(interp, "methods"))) {
        found = role->methods;
    }
    else if (STRING_equal(interp, what, CONST_STRING(interp, "roles"))) {
        found = role->roles;
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unknown introspection value '%S'", what);
    }

    /* Clone and return. */
    if (PMC_IS_NULL(found)) { return PMCNULL; }
    if (found->vtable->base_type == enum_class_Hash) {
        /* for Hash return values, create and return a shallow
         * clone because the VTABLE_clone does a deep clone */
        PMC * const hash = Parrot_pmc_new(interp, enum_class_Hash);
        PMC * const iter = VTABLE_get_iter(interp, found);
        while (VTABLE_get_bool(interp, iter)) {
            STRING * const key   = VTABLE_shift_string(interp, iter);
            PMC *    const value = VTABLE_get_pmc_keyed_str(interp, found, key);
            VTABLE_set_pmc_keyed_str(interp, hash, key, value);
        }
        return hash;
    }
    return VTABLE_clone(interp, found);
#line 508 "./src/pmc/role.c"
}
static  void 
Parrot_Role_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 283 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role = PARROT_ROLE(_self);

    Parrot_gc_mark_STRING_alive(interp, role->name);
    Parrot_gc_mark_PMC_alive(interp, role->_namespace);
    Parrot_gc_mark_PMC_alive(interp, role->roles);
    Parrot_gc_mark_PMC_alive(interp, role->methods);
    Parrot_gc_mark_PMC_alive(interp, role->attrib_metadata);
#line 522 "./src/pmc/role.c"
}
static  void 
Parrot_Role_remove_method(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name)
{
#line 354 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role = PARROT_ROLE(_self);
    if (VTABLE_exists_keyed_str(interp, role->methods, name))
        VTABLE_delete_keyed_str(interp, role->methods, name);
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "No method named '%S' to remove in role '%S'.",
            name, VTABLE_get_string(interp, _self));
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 537 "./src/pmc/role.c"
}
static  void
Parrot_Role_nci_name(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* name;
    INTVAL got_name;
    
    const INTVAL arity = 1; /* "PiSoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        name = VTABLE_get_string_keyed_int(interp, _call_object, 1);
        got_name = 1;
    }
    else {
        name = STRINGNULL;
        got_name = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 604 "./src/pmc/role.pmc"

    Parrot_Role_attributes *role     = PARROT_ROLE(_self);
    STRING                 *ret_name = NULL;

    if (got_name) {
        /* We'll build a hash just containing the name, then give this to
         * init_role_from_hash - saves some code duplication. */
        PMC * const naming_hash = Parrot_pmc_new(interp, enum_class_Hash);
        VTABLE_set_string_keyed_str(interp, naming_hash, CONST_STRING(interp, "name"), name);
        init_role_from_hash(interp, _self, naming_hash);
    }

    ret_name = role->name;
    #line 587 "./src/pmc/role.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)ret_name);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 617 "./src/pmc/role.pmc"

#line 595 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Role_nci_get_namespace(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 632 "./src/pmc/role.pmc"

    PMC * const ret_namespace = PARROT_ROLE(_self)->_namespace;
    #line 625 "./src/pmc/role.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)ret_namespace);
        
        return;
     }
#line 634 "./src/pmc/role.pmc"

#line 633 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Role_nci_attributes(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 649 "./src/pmc/role.pmc"

    PMC * const ret_attrib_metadata = VTABLE_inspect_str(interp, _self, CONST_STRING(interp, "attributes"));
    #line 663 "./src/pmc/role.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)ret_attrib_metadata);
        
        return;
     }
#line 651 "./src/pmc/role.pmc"

#line 671 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Role_nci_add_attribute(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* attribute_name;
    PMC* attribute_type;
    INTVAL got_type;
    
    const INTVAL arity = 2; /* "PiSPoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    attribute_name = VTABLE_get_string_keyed_int(interp, _call_object, 1);
    if (param_count > 2) {
        attribute_type = VTABLE_get_pmc_keyed_int(interp, _call_object, 2);
        got_type = 1;
    }
    else {
        attribute_type = PMCNULL;
        got_type = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 667 "./src/pmc/role.pmc"

    VTABLE_add_attribute(interp, _self, attribute_name,
        got_type ? attribute_type : PMCNULL);
#line 720 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Role_nci_methods(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 682 "./src/pmc/role.pmc"

    PMC * const ret_methods = VTABLE_inspect_str(interp, _self, CONST_STRING(interp, "methods"));
    #line 750 "./src/pmc/role.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)ret_methods);
        
        return;
     }
#line 684 "./src/pmc/role.pmc"

#line 758 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Role_nci_add_method(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* name;
    PMC* sub;
    
    const INTVAL arity = 3; /* "PiSP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    name = VTABLE_get_string_keyed_int(interp, _call_object, 1);
    sub = VTABLE_get_pmc_keyed_int(interp, _call_object, 2);

    { /* BEGIN PMETHOD BODY */
#line 697 "./src/pmc/role.pmc"

    VTABLE_add_method(interp, _self, name, sub);
#line 792 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Role_nci_remove_method(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* name;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    name = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 710 "./src/pmc/role.pmc"

    VTABLE_remove_method(interp, _self, name);
#line 824 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Role_nci_roles(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 724 "./src/pmc/role.pmc"

    PMC * const ret_roles = VTABLE_inspect_str(interp, _self, CONST_STRING(interp, "roles"));
    #line 854 "./src/pmc/role.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)ret_roles);
        
        return;
     }
#line 726 "./src/pmc/role.pmc"

#line 862 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Role_nci_add_role(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* role;
    STRING* _param_name_str_exclude_method = CONST_STRING_GEN(interp, "exclude_method");
    PMC* exclude_method;
    INTVAL got_exclude_method;
    STRING* _param_name_str_alias_method = CONST_STRING_GEN(interp, "alias_method");
    PMC* alias_method;
    INTVAL got_alias_method;
    
    Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPSnPoIpSnPoIp",
        &_self, &role, &_param_name_str_exclude_method, &exclude_method, &got_exclude_method, &_param_name_str_alias_method, &alias_method, &got_alias_method);

    { /* BEGIN PMETHOD BODY */
#line 748 "./src/pmc/role.pmc"

    Parrot_Role_attributes *role_info = PARROT_ROLE(_self);
    STRING *s_name   = NULL;
    STRING *r_name   = NULL;

    #line 896 "./src/pmc/role.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "name"), "->S", &s_name);
#line 753 "./src/pmc/role.pmc"

    #line 900 "./src/pmc/role.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, role, CONST_STRING_GEN(interp, "name"), "->S", &r_name);
#line 754 "./src/pmc/role.pmc"

    UNUSED(s_name);
    UNUSED(r_name);

    Parrot_ComposeRole(interp, role, exclude_method, got_exclude_method,
                       alias_method, got_alias_method,
                       role_info->methods, role_info->roles);
#line 910 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Role_nci_inspect(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* what;
    INTVAL got_what;
    
    const INTVAL arity = 1; /* "PiSoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        what = VTABLE_get_string_keyed_int(interp, _call_object, 1);
        got_what = 1;
    }
    else {
        what = STRINGNULL;
        got_what = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 773 "./src/pmc/role.pmc"

    PMC *found;

    /* Just delegate to the appropriate vtable. */
    if (got_what)
        found = VTABLE_inspect_str(interp, _self, what);
    else
        found = VTABLE_inspect(interp, _self);

    #line 963 "./src/pmc/role.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)found);
        
        return;
     }
#line 782 "./src/pmc/role.pmc"

#line 971 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Role_nci_does(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* name;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    name = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 796 "./src/pmc/role.pmc"

    const INTVAL does = VTABLE_does(interp, _self, name);
    #line 1003 "./src/pmc/role.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)does);
        
        return;
     }
#line 798 "./src/pmc/role.pmc"

#line 1011 "./src/pmc/role.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Role_update_vtable(VTABLE *vt) {
    vt->add_attribute = Parrot_Role_add_attribute;
    vt->add_method = Parrot_Role_add_method;
    vt->add_role = Parrot_Role_add_role;
    vt->does = Parrot_Role_does;
    vt->does_pmc = Parrot_Role_does_pmc;
    vt->get_string = Parrot_Role_get_string;
    vt->init = Parrot_Role_init;
    vt->init_pmc = Parrot_Role_init_pmc;
    vt->inspect = Parrot_Role_inspect;
    vt->inspect_str = Parrot_Role_inspect_str;
    vt->mark = Parrot_Role_mark;
    vt->remove_method = Parrot_Role_remove_method;
    vt->attr_size = sizeof(Parrot_Role_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Role_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->does = Parrot_Role_does;
    vt->does_pmc = Parrot_Role_does_pmc;
    vt->get_string = Parrot_Role_get_string;
    vt->inspect = Parrot_Role_inspect;
    vt->inspect_str = Parrot_Role_inspect_str;
    vt->mark = Parrot_Role_mark;
    vt->attr_size = sizeof(Parrot_Role_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Role_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Role_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Role_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Role_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Role_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Role"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Role_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Role")), PMCNULL);
    return isa;
}

void
Parrot_Role_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Sname F_namespace Froles Fmethods Fattrib_metadata ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Role_get_vtable(interp);
        vt->base_type      = enum_class_Role;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Role");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_Role_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_Role_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_Role;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Role_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "name");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_name),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_namespace");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_get_namespace),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "attributes");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_attributes),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "add_attribute");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_add_attribute),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "methods");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_methods),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "add_method");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_add_method),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "remove_method");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_remove_method),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "roles");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_roles),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "add_role");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_add_role),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "inspect");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_inspect),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "does");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Role_nci_does),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_Role_class_init */

#line 800 "./src/pmc/role.pmc"
 /* end pmclass Role */


/*

=back

=head1 STABILITY

Unstable. This PMC is under active development; major portions of the
interface have not yet been completed.

=head1 SEE ALSO

F<docs/pdds/pdd15_objects.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
