/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/stringhandle.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_stringhandle.h"
#include "pmc_handle.h"
#include "pmc_default.h"
#include "stringhandle.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/stringhandle.pmc"
/*
Copyright (C) 2008-2014, Parrot Foundation.

=head1 NAME

src/pmc/stringhandle.pmc - StringHandle PMC

=head1 DESCRIPTION

The StringHandle PMC performs I/O operations, but on an internal string rather
than an external file. Commonly used as a mock FileHandle for testing.

=cut

*/

#include "../src/io/io_private.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_INLINE
static int encoding_is_utf8(PARROT_INTERP, ARGIN_NULLOK(const STRING *s))
        __attribute__nonnull__(1);

#define ASSERT_ARGS_encoding_is_utf8 __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=head2 Internal Functions

=over 4

=item C<static int encoding_is_utf8(PARROT_INTERP, const STRING *s)>

Helper function for internal usage. Return 1 if the string argument is
not null and has utf8 encoding, 0 otherwise.

=back

=cut

*/

PARROT_INLINE
static int
encoding_is_utf8(PARROT_INTERP, ARGIN_NULLOK(const STRING *s))
{
    ASSERT_ARGS(encoding_is_utf8)
    if (STRING_IS_NULL(s))
        return 0;
    else
        return STRING_equal(interp, s, CONST_STRING(interp, "utf8"));
}
#line 83 "./src/pmc/stringhandle.c"
static  PMC  * Parrot_StringHandle_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_StringHandle_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StringHandle_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StringHandle_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_open(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_is_closed(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_readall(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_flush(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_print(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_puts(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_buffer_type(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_buffer_size(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_mode(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_eof(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_get_fd(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_close(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  *
Parrot_StringHandle_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 111 "./src/pmc/stringhandle.pmc"

    const Parrot_StringHandle_attributes * const old_struct  = PARROT_STRINGHANDLE(_self);
    PMC * const copy = Parrot_pmc_new(interp, enum_class_StringHandle);
    Parrot_StringHandle_attributes * const data_struct = PARROT_STRINGHANDLE(copy);

    data_struct->stringhandle = old_struct->stringhandle;
    data_struct->mode         = old_struct->mode;
    data_struct->encoding     = old_struct->encoding;
    data_struct->flags        = old_struct->flags;

    data_struct->read_offset  = old_struct->read_offset;
    data_struct->filename     = old_struct->filename;
    data_struct->read_buffer  = old_struct->read_buffer;
    data_struct->write_buffer = old_struct->write_buffer;
    data_struct->record_separator = old_struct->record_separator;

    return copy;
#line 121 "./src/pmc/stringhandle.c"
}
static  INTVAL 
Parrot_StringHandle_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 161 "./src/pmc/stringhandle.pmc"

    STRING *stringhandle;
    GETATTR_StringHandle_stringhandle(interp, _self, stringhandle);

    if (STRING_IS_NULL(stringhandle))
        return 0;

    return 1;
#line 135 "./src/pmc/stringhandle.c"
}
static  void 
Parrot_StringHandle_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 81 "./src/pmc/stringhandle.pmc"

    Parrot_StringHandle_attributes * const data_struct =
            (Parrot_StringHandle_attributes *) PMC_data(_self);

    data_struct->flags        = 0;
    data_struct->read_offset  = 0;
    data_struct->stringhandle = NULL;
    data_struct->mode         = NULL;
    data_struct->filename     = NULL;
    /* inherited from Handle: */
    data_struct->encoding     = STRINGNULL;
    data_struct->io_vtable    = (IO_VTABLE *)Parrot_io_get_vtable(interp,
                                                 IO_VTABLE_STRINGHANDLE, NULL);
    data_struct->read_buffer  = NULL;
    data_struct->write_buffer = NULL;
    data_struct->record_separator = CONST_STRING(interp, "\n");

    PObj_custom_mark_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 160 "./src/pmc/stringhandle.c"
}
static  void 
Parrot_StringHandle_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 140 "./src/pmc/stringhandle.pmc"

    Parrot_StringHandle_attributes * const data_struct = PARROT_STRINGHANDLE(_self);
    Parrot_gc_mark_STRING_alive(interp, data_struct->stringhandle);
    Parrot_gc_mark_STRING_alive(interp, data_struct->mode);
    Parrot_gc_mark_STRING_alive(interp, data_struct->encoding);
    Parrot_gc_mark_STRING_alive(interp, data_struct->filename);
    Parrot_gc_mark_STRING_alive(interp, data_struct->record_separator);
    Parrot_io_buffer_mark(interp, data_struct->read_buffer);
    Parrot_io_buffer_mark(interp, data_struct->write_buffer);
#line 175 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_open(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* filename;
    INTVAL got_filename;
    STRING* mode;
    INTVAL got_mode;
    
    const INTVAL arity = 1; /* "PiSoIpSoIp" */
    const INTVAL arity_opt  = 2;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        filename = VTABLE_get_string_keyed_int(interp, _call_object, 1);
        got_filename = 1;
    }
    else {
        filename = STRINGNULL;
        got_filename = 0;
    }
    if (param_count > 2) {
        mode = VTABLE_get_string_keyed_int(interp, _call_object, 2);
        got_mode = 1;
    }
    else {
        mode = STRINGNULL;
        got_mode = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 190 "./src/pmc/stringhandle.pmc"

    STRING *open_mode, *old_string;
    PMC * handle;
    INTVAL flags;

    if (got_mode && !STRING_IS_NULL(mode))
        SETATTR_StringHandle_mode(interp, _self, mode);

    if (got_filename && !STRING_IS_NULL(filename))
        SETATTR_StringHandle_filename(interp, _self, filename);

    handle = Parrot_io_open(interp, _self, filename, mode);

    #line 235 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)handle);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 203 "./src/pmc/stringhandle.pmc"

#line 243 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_is_closed(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 217 "./src/pmc/stringhandle.pmc"

    const INTVAL closed = Parrot_io_is_closed(interp, _self);
    #line 273 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)closed);
        
        return;
     }
#line 219 "./src/pmc/stringhandle.pmc"

#line 281 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_readall(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* name;
    INTVAL got_name;
    
    const INTVAL arity = 1; /* "PiSoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        name = VTABLE_get_string_keyed_int(interp, _call_object, 1);
        got_name = 1;
    }
    else {
        name = STRINGNULL;
        got_name = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 237 "./src/pmc/stringhandle.pmc"

    STRING * const string_result = Parrot_io_readall_s(interp, _self);
    #line 327 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)string_result);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 239 "./src/pmc/stringhandle.pmc"

#line 335 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_flush(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 252 "./src/pmc/stringhandle.pmc"

    Parrot_io_flush(interp, _self);
#line 365 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_print(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* to_print;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    to_print = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 267 "./src/pmc/stringhandle.pmc"

    STRING * const string_to_print = VTABLE_get_string(interp, to_print);
    Parrot_io_write_s(interp, _self, string_to_print);
#line 398 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_puts(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* to_print;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    to_print = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 282 "./src/pmc/stringhandle.pmc"

    const INTVAL status = Parrot_io_write_s(interp, _self, to_print);
    #line 430 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)status);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 284 "./src/pmc/stringhandle.pmc"

#line 438 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_buffer_type(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* new_type;
    INTVAL got_type;
    
    const INTVAL arity = 1; /* "PiSoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        new_type = VTABLE_get_string_keyed_int(interp, _call_object, 1);
        got_type = 1;
    }
    else {
        new_type = STRINGNULL;
        got_type = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 298 "./src/pmc/stringhandle.pmc"

    INTVAL flags;
    STRING * const nobuffer_string   = CONST_STRING(interp, "unbuffered");
    STRING * const linebuffer_string = CONST_STRING(interp, "line-buffered");
    STRING * const fullbuffer_string = CONST_STRING(interp, "full-buffered");

    GETATTR_StringHandle_flags(interp, _self, flags);

    if (got_type) {
        if (STRING_equal(interp, new_type, nobuffer_string)) {
            flags &= ~ PIO_BF_LINEBUF;
            flags &= ~ PIO_BF_BLKBUF;
        }
        else if (STRING_equal(interp, new_type, linebuffer_string)) {
            flags |=   PIO_BF_LINEBUF;
            flags &= ~ PIO_BF_BLKBUF;
        }
        else if (STRING_equal(interp, new_type, fullbuffer_string)) {
            flags &= ~ PIO_BF_LINEBUF;
            flags |=   PIO_BF_BLKBUF;
        }

        SETATTR_StringHandle_flags(interp, _self, flags);
    }

    if (flags & PIO_BF_LINEBUF)
        #line 508 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)linebuffer_string);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 324 "./src/pmc/stringhandle.pmc"

    else if (flags & PIO_BF_BLKBUF)
        #line 517 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)fullbuffer_string);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 326 "./src/pmc/stringhandle.pmc"

    #line 525 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)nobuffer_string);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 327 "./src/pmc/stringhandle.pmc"

#line 533 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_buffer_size(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    INTVAL new_size;
    INTVAL got_size;
    
    const INTVAL arity = 1; /* "PiIoIp" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    if (param_count > 1) {
        new_size = VTABLE_get_integer_keyed_int(interp, _call_object, 1);
        got_size = 1;
    }
    else {
        new_size = 0;
        got_size = 0;
    }

    { /* BEGIN PMETHOD BODY */
#line 340 "./src/pmc/stringhandle.pmc"

    INTVAL buffer_size;
    STRING *stringhandle;

    GETATTR_StringHandle_stringhandle(interp, _self, stringhandle);

    if (STRING_IS_NULL(stringhandle)) {
        if (got_size) {
            stringhandle = Parrot_str_new_noinit(interp, new_size);
            SETATTR_StringHandle_stringhandle(interp, _self, stringhandle);
        }
        else {
            #line 589 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)0);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 352 "./src/pmc/stringhandle.pmc"

        }
    }
    buffer_size = stringhandle->_buflen;

    #line 601 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)buffer_size);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 357 "./src/pmc/stringhandle.pmc"


#line 610 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_mode(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 371 "./src/pmc/stringhandle.pmc"

    STRING *mode;
    GETATTR_StringHandle_mode(interp, _self, mode);
    #line 641 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)mode);
        
        return;
     }
#line 374 "./src/pmc/stringhandle.pmc"

#line 649 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_eof(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 388 "./src/pmc/stringhandle.pmc"

    const INTVAL is_eof = Parrot_io_eof(interp, _self);
    #line 679 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)0);
        
        return;
     }
#line 390 "./src/pmc/stringhandle.pmc"

#line 687 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_get_fd(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 405 "./src/pmc/stringhandle.pmc"

    UNUSED(interp);
    #line 717 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)-1);
        
        return;
     }
#line 407 "./src/pmc/stringhandle.pmc"

#line 725 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_close(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 420 "./src/pmc/stringhandle.pmc"

    const INTVAL status = Parrot_io_close(interp, _self, 0);
    #line 755 "./src/pmc/stringhandle.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)status);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 422 "./src/pmc/stringhandle.pmc"

#line 763 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_StringHandle_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_StringHandle_clone;
    vt->get_bool = Parrot_StringHandle_get_bool;
    vt->init = Parrot_StringHandle_init;
    vt->mark = Parrot_StringHandle_mark;
    vt->attr_size = sizeof(Parrot_StringHandle_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_StringHandle_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_StringHandle_clone;
    vt->get_bool = Parrot_StringHandle_get_bool;
    vt->mark = Parrot_StringHandle_mark;
    vt->attr_size = sizeof(Parrot_StringHandle_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StringHandle_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_get_vtable(interp);
    Parrot_StringHandle_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StringHandle_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_ro_get_vtable(interp);
    Parrot_StringHandle_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_StringHandle_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Handle_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "StringHandle"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_StringHandle_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_Handle_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "StringHandle")), PMCNULL);
    return isa;
}

void
Parrot_StringHandle_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":os_handle Srecord_separator :io_vtable :read_buffer :write_buffer Sencoding Iflags Sstringhandle Smode Sfilename Iread_offset ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_StringHandle_get_vtable(interp);
        vt->base_type      = enum_class_StringHandle;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "StringHandle");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_StringHandle_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_StringHandle_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_StringHandle;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_StringHandle_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "open");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_open),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "is_closed");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_is_closed),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "readall");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_readall),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "flush");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_flush),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "print");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_print),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "puts");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_puts),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "buffer_type");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_buffer_type),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "buffer_size");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_buffer_size),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "mode");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_mode),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "eof");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_eof),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_fd");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_get_fd),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "close");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_close),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_StringHandle_class_init */

#line 433 "./src/pmc/stringhandle.pmc"
 /* end pmclass */

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
