/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/timer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_timer.h"
#include "pmc_default.h"
#include "timer.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/timer.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/timer.pmc - Timer PMC

=head1 SYNOPSIS

    new P0, 'Timer'
    set P0[.PARROT_TIMER_SEC],     I_seconds       # whole seconds
    set P0[.PARROT_TIMER_USEC],    I_micro seconds # and/or micro seconds
    set P0[.PARROT_TIMER_NSEC],    N_seconds_frac  # or fraction in seconds
    set P0[.PARROT_TIMER_REPEAT],  I_repeat        # 0 = one shot ...
    set P0[.PARROT_TIMER_HANDLER], P_sub           # set handler sub PMC
    invoke P0                                      # start timer
    set P0[.PARROT_TIMER_RUNNING], 1               # same

    new P0, 'Timer', P1                            # set everything

    set I0, P0[.PARROT_TIMER_SEC]                  # query current timer status
    set N0, P0[.PARROT_TIMER_NSEC]
    ...
    set P0[.PARROT_TIMER_RUNNING], 0               # turn timer off


=head1 DESCRIPTION

This is the Timer base class

The Timer resolution is operating system dependent. It's only guaranteed
that the Timer will fire some time after the programmed interval.

The Timer stops after invoking the handler (repeat + 1) times. To create a
Timer that will run forever, set "repeat" to -1. Turning the Timer off
preserves set values; the Timer is not destroyed.

When setting both C<PARROT_TIMER_SEC> and C<PARROT_TIMER_USEC> it must
be done in that sequence, whole seconds first. If a timer is constructed
with an initializer and it should be run immediately, the
C<PARROT_TIMER_RUNNING> value has to be in the last key of the
initializer.

=head2 Functions

=over 4

=cut

*/

#include "parrot/scheduler_private.h"
#include "pmc/pmc_task.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 80 "./src/pmc/timer.c"
static  PMC  * Parrot_Timer_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Timer_get_integer_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  FLOATVAL  Parrot_Timer_get_number_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  PMC  * Parrot_Timer_get_pmc_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  void  Parrot_Timer_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Timer_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init);
static  opcode_t  * Parrot_Timer_invoke(PARROT_INTERP, ARGMOD(PMC *_self), void *next);
static  void  Parrot_Timer_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Timer_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value);
static  void  Parrot_Timer_set_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, FLOATVAL value);
static  void  Parrot_Timer_set_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, PMC *value);
static  PMC  *
Parrot_Timer_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 151 "./src/pmc/timer.pmc"

    PMC * const copy = Parrot_pmc_new(interp, _self->vtable->base_type);

    Parrot_Timer_attributes * const new_struct = PARROT_TIMER(copy);
    const Parrot_Timer_attributes * const old_struct = PARROT_TIMER(_self);

    new_struct->duration  = old_struct->duration;
    new_struct->interval  = old_struct->interval;
    new_struct->repeat    = old_struct->repeat;
    new_struct->code      = old_struct->code;

    return copy;
#line 108 "./src/pmc/timer.c"
}
static  INTVAL 
Parrot_Timer_get_integer_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 175 "./src/pmc/timer.pmc"

    const Parrot_Timer_attributes * const core_struct = PARROT_TIMER(_self);
    const FLOATVAL absolute_time = core_struct->birthtime + core_struct->duration;

    switch (key) {
      case PARROT_TIMER_SEC:
        return (INTVAL)absolute_time;
      case PARROT_TIMER_USEC:
        return (INTVAL)((absolute_time - (INTVAL)absolute_time) *1000000.0);
      case PARROT_TIMER_REPEAT:
        return (INTVAL) core_struct->repeat;
      case PARROT_TIMER_INTERVAL:
        return (INTVAL) core_struct->interval;
      case PARROT_TIMER_RUNNING:
        return 0;
      default:
        return -1;
    }
#line 132 "./src/pmc/timer.c"
}
static  FLOATVAL 
Parrot_Timer_get_number_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 227 "./src/pmc/timer.pmc"

    const Parrot_Timer_attributes * const core_struct = PARROT_TIMER(_self);

    switch (key) {
      case PARROT_TIMER_NSEC:
        return core_struct->birthtime + core_struct->duration;
      case PARROT_TIMER_INTERVAL:
        return core_struct->interval;
      default:
        break;
    }

    return -1.0;
#line 151 "./src/pmc/timer.c"
}
static  PMC  *
Parrot_Timer_get_pmc_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 206 "./src/pmc/timer.pmc"

    if (key == PARROT_TIMER_HANDLER) {
        const Parrot_Timer_attributes * const core_struct = PARROT_TIMER(_self);
        return core_struct->code;
    }

    return PMCNULL;
#line 164 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 80 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(_self);
    interp->vtables[enum_class_default]->init(interp, _self);

    /* Set up the core struct. */
    core_struct->code      = PMCNULL;
    core_struct->birthtime = 0.0;
    core_struct->duration  = 0.0;
    core_struct->interval  = 0.0;
    core_struct->repeat    = 0;
    core_struct->started   = 0;
    core_struct->running   = 0;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 183 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init)
{
#line 104 "./src/pmc/timer.pmc"

    const INTVAL n = VTABLE_get_integer(interp, init);
    INTVAL       i;

    VTABLE_init(interp, _self);

    for (i = 0; i < n; i += 2) {
        const INTVAL key = VTABLE_get_integer_keyed_int(interp, init, i);
        switch (key) {
          case PARROT_TIMER_SEC:
          case PARROT_TIMER_USEC:
          case PARROT_TIMER_REPEAT:
          case PARROT_TIMER_RUNNING:
            {
                const INTVAL val = VTABLE_get_integer_keyed_int(interp, init, i+1);
                VTABLE_set_integer_keyed_int(interp, _self, key, val);
            }
            break;
          case PARROT_TIMER_NSEC:
          case PARROT_TIMER_INTERVAL:
            {
                const FLOATVAL nval = VTABLE_get_number_keyed_int(interp, init, i+1);
                VTABLE_set_number_keyed_int(interp, _self, key, nval);
            }
            break;
          case PARROT_TIMER_HANDLER:
            {
                PMC * const pval = VTABLE_get_pmc_keyed_int(interp, init, i+1);
                VTABLE_set_pmc_keyed_int(interp, _self, key, pval);
            }
            break;
          default:
            break;
        }
    }
#line 224 "./src/pmc/timer.c"
}
static  opcode_t  *
Parrot_Timer_invoke(PARROT_INTERP, ARGMOD(PMC *_self), void *next)
{
#line 312 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes *const timer = PARROT_TIMER(_self);
    FLOATVAL now_time;
    PMC* alarm;
    PMC* task;
    Parrot_Task_attributes *tdata;

    /* If the timer has been cancelled, we're done */
    if (timer->running == 0)
        return (opcode_t*) next;

    if (timer->started == 0) {
        /* We're being called to start the timer. */
        timer->started = 1;
        timer->running = 1;

        now_time = Parrot_floatval_time();

        task = Parrot_pmc_new(interp, enum_class_Task);
        tdata = PARROT_TASK(task);
        tdata->code = _self;

        alarm = Parrot_pmc_new(interp, enum_class_Alarm);
        VTABLE_set_number_keyed_int(interp, alarm, PARROT_ALARM_TIME,
                                    now_time + timer->duration);


        VTABLE_set_pmc_keyed_int(interp, alarm, PARROT_ALARM_TASK, task);
        next = VTABLE_invoke(interp, alarm, next);
    }
    else {
        /* This is the timer triggering. */
        if (!PMC_IS_NULL(timer->code)) {
            Parrot_ext_call(interp, timer->code, "->");
        }

        /* Repeat semantics as documented. */
        if (timer->repeat != 0) {
            if (timer->repeat > 0)
                timer->repeat--;

            now_time = Parrot_floatval_time();

            task = Parrot_pmc_new(interp, enum_class_Task);
            tdata = PARROT_TASK(task);
            tdata->code = _self;

            alarm = Parrot_pmc_new(interp, enum_class_Alarm);
            VTABLE_set_number_keyed_int(interp, alarm, PARROT_ALARM_TIME,
                                        now_time + timer->interval);
            VTABLE_set_pmc_keyed_int(interp, alarm, PARROT_ALARM_TASK, task);
            next = VTABLE_invoke(interp, alarm, next);
        }
    }

    return (opcode_t*) next;
#line 286 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 407 "./src/pmc/timer.pmc"

    if (PARROT_TIMER(_self)) {
        Parrot_Timer_attributes * const core_struct = PARROT_TIMER(_self);
        Parrot_gc_mark_PMC_alive(interp, core_struct->code);
    }
#line 297 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL value)
{
#line 253 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(_self);

    switch (key) {
      case PARROT_TIMER_SEC:
        core_struct->duration = value;
        break;
      case PARROT_TIMER_USEC:
        core_struct->duration += value / 1000000.0;
        break;
      case PARROT_TIMER_REPEAT:
        core_struct->repeat = value;
        break;
      case PARROT_TIMER_INTERVAL:
        core_struct->interval = value;
        break;
      case PARROT_TIMER_RUNNING:
        core_struct->running = value;
        if (value)
            (void) VTABLE_invoke(interp, _self, 0);
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Unknown timer type in Timer.set_integer_keyed_int: %d",
                key);
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 331 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_set_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, FLOATVAL value)
{
#line 380 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(_self);

    switch (key) {
      case PARROT_TIMER_NSEC:
        core_struct->duration = value;
        break;
      case PARROT_TIMER_INTERVAL:
        core_struct->interval = value;
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Unknown timer attribute in Timer.set_number_keyed_int: %d",
                key);
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 354 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_set_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, PMC *value)
{
#line 292 "./src/pmc/timer.pmc"

    if (key == PARROT_TIMER_HANDLER) {
        SETATTR_Timer_code(interp, _self, value);
        PARROT_GC_WRITE_BARRIER(interp, _self);
    }
#line 365 "./src/pmc/timer.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Timer_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Timer_clone;
    vt->get_integer_keyed_int = Parrot_Timer_get_integer_keyed_int;
    vt->get_number_keyed_int = Parrot_Timer_get_number_keyed_int;
    vt->get_pmc_keyed_int = Parrot_Timer_get_pmc_keyed_int;
    vt->init = Parrot_Timer_init;
    vt->init_pmc = Parrot_Timer_init_pmc;
    vt->invoke = Parrot_Timer_invoke;
    vt->mark = Parrot_Timer_mark;
    vt->set_integer_keyed_int = Parrot_Timer_set_integer_keyed_int;
    vt->set_number_keyed_int = Parrot_Timer_set_number_keyed_int;
    vt->set_pmc_keyed_int = Parrot_Timer_set_pmc_keyed_int;
    vt->attr_size = sizeof(Parrot_Timer_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Timer_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Timer_clone;
    vt->get_integer_keyed_int = Parrot_Timer_get_integer_keyed_int;
    vt->get_number_keyed_int = Parrot_Timer_get_number_keyed_int;
    vt->get_pmc_keyed_int = Parrot_Timer_get_pmc_keyed_int;
    vt->invoke = Parrot_Timer_invoke;
    vt->mark = Parrot_Timer_mark;
    vt->attr_size = sizeof(Parrot_Timer_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Timer_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Timer_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Timer_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Timer_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Timer_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Timer"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Timer_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Timer")), PMCNULL);
    return isa;
}

void
Parrot_Timer_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fcode Fbirthtime Fduration Finterval Irepeat Istarted Irunning ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Timer_get_vtable(interp);
        vt->base_type      = enum_class_Timer;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Timer");
        vt->provides_str = CONST_STRING_GEN(interp, "invokable");
        vt->isa_hash     = Parrot_Timer_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_Timer_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_Timer;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Timer_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_Timer_class_init */

#line 413 "./src/pmc/timer.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
